.TH XDPYINFO 1 "1 October 1988" "X Version 11"
.SH NAME
xdpyinfo - display information utility for X
.SH SYNOPSIS
.B "xdpyinfo"
[-display \fIdisplayname\fP]
.SH DESCRIPTION
.PP
.I Xdpyinfo
is a utility for displaying information about an X server.  It is used to 
examine the
capabilities of a server, the predefined values for various parameters used
in communicating between clients and the server, and the different types of
screens and visuals that are available.
.SH EXAMPLE
.PP
The following shows a sample produced by
.I xdpyinfo
when connected to display that supports an 8 plane Pseudocolor screen as well
as a 1 plane (monochrome) screen.
.PP
.nf
name of display:    empire:0.0
version number:    11.0
vendor string:    MIT X Consortium
vendor release number:    3
maximum request size:  16384 longwords (65536 bytes)
motion buffer size:  0
bitmap unit, bit order, padding:    32, MSBFirst, 32
image byte order:    MSBFirst
keycode range:    minimum 8, maximum 129
default screen number:    0
number of screens:    2

screen #0:
  dimensions:    1152x900 pixels (325x254 millimeters)
  resolution:    90x90 dots per inch
  root window id:    0x8006d
  depth of root window:    1 plane
  number of colormaps:    minimum 1, maximum 1
  default colormap:    0x80065
  default number of colormap cells:    2
  preallocated pixels:    black 1, white 0
  options:    backing-store YES, save-unders YES
  current input event mask:    0x1b8003c
    ButtonPressMask          ButtonReleaseMask        EnterWindowMask          
    LeaveWindowMask          SubstructureNotifyMask   SubstructureRedirectMask 
    FocusChangeMask          ColormapChangeMask       OwnerGrabButtonMask      
  number of visuals:    1
  default visual id:  0x80064
  visual:
    visual id:    0x80064
    class:    StaticGray
    depth:    1 plane
    size of colormap:    2 entries
    red, green, blue masks:    0x0, 0x0, 0x0
    significant bits in color specification:    1 bits

screen #1:
  dimensions:    1152x900 pixels (325x254 millimeters)
  resolution:    90x90 dots per inch
  root window id:    0x80070
  depth of root window:    8 planes
  number of colormaps:    minimum 1, maximum 1
  default colormap:    0x80067
  default number of colormap cells:    256
  preallocated pixels:    black 1, white 0
  options:    backing-store YES, save-unders YES
  current input event mask:    0x0
  number of visuals:    1
  default visual id:  0x80066
  visual:
    visual id:    0x80066
    class:    PseudoColor
    depth:    8 planes
    size of colormap:    256 entries
    red, green, blue masks:    0x0, 0x0, 0x0
    significant bits in color specification:    8 bits
.fi

.SH ENVIRONMENT
.PP
.TP 8
.B DISPLAY
To get the default host, display number, and screen.
.SH "SEE ALSO"
X(1), xwininfo(1), xprop(1), xrdb(1)
.SH BUGS
Due to a bug in the Xlib interface,
there is currently no portable way to determine the depths of pixmap images
that are supported by the server.
.SH COPYRIGHT
Copyright 1988, Massachusetts Institute of Technology.
.br
See \fIX(1)\fP for a full statement of rights and permissions.
.SH AUTHOR
Jim Fulton, MIT X Consortium
