.\" $XConsortium: Xplx.man,v 1.2 88/09/06 15:28:45 jim Exp $
.TH XPLX 1 "31 August 1988" "X Version 11"
.SH NAME
Xplx \- Parallax Graphics 1280 server for X Version 11
.SH SYNOPSIS
.B Xplx
[ option ] ...
.SH DESCRIPTION
.I Xplx
is the server for Version 11 of the X window system on the Parallax 1280
video graphics processor. This server includes extensions for providing
live and still video images within a window.
It will normally be started by
.IR xinit(1).
.PP
.SH CONFIGURATIONS
.PP
.I Xplx
operates under SunOS versions 3.5 on Sun/3 workstations and under
Ultrix 2.0 on Microvax-II's.
.PP
The server is configured to run on an 8-bit 1280 video graphics processor
plugged into either of those machines. It 
supports a Logitech mouse and a DEC LK201 keyboard connected to the 
1280 graphics processor via the serial port.
.PP
.SH VIDEO EXTENSIONS
.PP
This server uses a set of sample video extensions to provide the ability
of showing a video image in an X Window. The extensions can be found in
the 
.I extensions
directory. A sample video program can be found in the
.I contrib
directory.
.SH SOFTWARE REQUIRMENTS.
The
.I Xplx
server requires the standard Parallax Graphics base software. This package
contains the device driver for 1280 processor, 'C' Language interface code and diagnostic
programs.
.PP
The server uses the
.B EIS
(Extended Instruction Set)
microcode package to handle clipping windows, cursor tracking and image
loading. This microcode can be resident in EPROM of
the Parallax 1280 processor or downloaded to
the board by the server.
.PP
Please contact the factory for these items.
.SH OPTIONS
.TP
\fB-microcode ucodefile\fP
This specifies the
.B EIS
microcode file (ucodefile) and if the currently running microcode is a different
revision, the server will reload upon startup.
.TP
\fB-device\fP
takes the following argument as the name of the special file for
a display device. 
If no device is specified, the enviroment variable
.B PLX
is used, if PLX environment variable is not present then
.B /dev/plx0
is used.
.PP
Other options are described under
.I Xserver(1).
.SH ENVIRONMENT VARIABLES
.TP
\fBPLX          \fP
If present,  and if no explicit
.B -device
options are given,  specifies the display device to use.
.TP
\fBPLXMICROCODE\fP If present,  and if no explicit
.B -microcode
option is given,  specifies the microcode file to use.
.SH FILES
.TP
/dev/plx0
default Parallax display device name.
.SH "SEE ALSO"
.PP
Xserver(1), xinit(1), X(1),
.SH BUGS & RESTRICTIONS
.TP
1
The server does not use the
.I CFB
or 
.I MFB
directories for drawing. All drawables are kept either on the screen
or as off-screen pixmaps. All drawing operations, such as lines, copies,
stipple's and text are done by the 1280 graphics processor.
With this scheme comes the restriction that pixmaps are limited in size.
.TP
2
The server code does not implement thick lines.
.SH AUTHORS
.TP
.B Parallax Graphics Inc.
.br
Greg Cockroft (Parallax Graphics & Univ Michigan CITI),
.br
Bob Goodwin,
.br
Martin Levy,
.br
Murali Srinivasan.
.TP
.B MIT Project Athena.
.br
Mark Levine.
