.\"
.\"
.\"  This macro puts the section numbers, labels, and page numbers out
.\"   to the standard output.   aps, crw, rjr.
.\"   WARNING: This macro assumes certain knowledge about the the ms/mu
.\"   packages work (what number and string registers are used, to be exact).
.\"
.de AC
.NH \\$2
\\$1
.\"
.\"  This indents section heading of level two or greater.
.\"
.tm .Bg \\n(NS
.tm \\*(SN \\$1
.tm .Ed \\n%
..

.de AP
.\"
.\"  This indents section heading of level two or greater.
.\"
.tm .Bg 1
.tm \\$1
.tm .Ed \\n%
..

.de RU
.br
\l'6i'
.sp
..

.de AR
.IP \\$1 1.0i
..

.de Sh		\" start a section (chapter type)
.bp
.NH 1
\fB\\$1\fP
.tm .Nh "\\$1" "\\n%" "0" "\\n(H1" "\\n(H2" "\\n(H3"	 \" zero is for chapter,group
..

.de Nh		\" Start a new section
.ds RH \\$1
.nr In 0 1
.ds Ic \\$1
.nr Ac 0 1
.LP
.NH 2
\\$1
.tm .Nh "\\$1" "\\n%" "1" "\\n(H1" "\\n(H2" "\\n(H3"   	\" one is for sub-chapter
..

.de Fs		\" Function Start
..
.de Nn		\" Start name of function
.NH 3
\\$1
..

.de Na		\" Start name of function
.sp
.LP
.in 0.5i
.ti -0.5i
\fBName:\fP 
.ti 0.5i
\fB\\$1\fP
..

.de Or		\" name of output request
.sp -1
.LP
\fB\\$1\fP
.tm .Bg 3
.tm \\$1
.tm .Ed \\n%
..

.de Op		\" add an output request parameter
.br
.RS
\fI\\$1 : \fP  \\$2
.RE
..

.de Ds		\" Start Description of function
.LP
.ti -0.5i
\fBDescription:\fP
.LP
..

.de Pa		\" add a parameter
.ti 0.5i
\fI\\$1 : \fP  \\$2
..

.de Rq		\" Start Request list
.LP
.ti -0.5i
\fBRequest:\fP
..

.de Re		\" Start Reply list
.LP
.ti -0.5i
\fBReply:\fP
..

.de Se		\" Start ERRORS list
.LP
.ti -0.5i
\fBErrors:\fP
.ti 0.5i
..

.de Fe		\" End of Function
.in 0i
..

.de Bl		\" Start of bullet item
.sp -1
.IP "\fI\\$1\fP"
..
                                      
.de 2d		\" Description of 2d primtives
When processed, this command will cause \\$1 primitives to be drawn.
This primitive
functions exactly as the 3D \\$1 primitive
except that modeling
coordinate positions are specified using only \fIx-\fP and \fIy-\fP
coordinates, and the \fIz\fP-coordinate is always assumed to be zero.
..

.de Es		\" Start of enumerated type description table
.LD
.ta 0.2i 1.7i
..

.de Ee		\" End of enumerated type description table
.ta
.DE
..
.LP
\ 
.sp 12
.PP
.TL
\fB\s+9PEX Protocol Specification\s-9\fP
.sp 2
.AU
Version 3.20
1-October-1988
.sp 0.5i
.nf
.ce
\fBX3D Chairman\fP
.sp 0.05i
.ta 1.7i 2.9i
.R
	Bertram Herzog	\fIUniversity of Michigan\fP
.sp 0.3i
.ce
\fBPEX Architecture Team\fP
.sp 0.05i
	Jeffrey Friedberg	\fIDigital Equipment Corp.\fP
	Dave Gorgen	\fIApollo Computer Inc.\fP
	Tom Gross	\fIApollo Computer Inc.\fP
	Marty Hess	\fISun Microsystems\fP
	Randi J. Rost	\fIDigital Equipment Corp.\fP
	Jeffrey S. Saltz	\fIDigital Equipment Corp.\fP
	Jeff Stevenson	\fIHewlett-Packard\fP
	Jim Van Loo	\fISun Microsystems\fP
.sp 0.3i
.ce
\fBPEX Architecture Team Secretary\fP
.sp 0.05i
	John McConnell	\fIDigital Equipment Corp.\fP
	Pete Nishimoto	\fIDigital Equipment Corp.\fP
.sp 0.3i
.ce
\fBPEX Document Editor\fP
.sp 0.05i
	Randi J. Rost	\fIDigital Equipment Corp.\fP
.ta
.bp
.nr LL 6.5i
.nr PD 0.1i
.nr HM 1.2i
.nr FM 1.0i
.nr PO 1.0i
.nh
.DA "PEX Version 3.20, 1-October-1988"
.EH ''-%-''
.OH ''-%-''
\ 
.sp 36
.LP
.nf
.ce 2
Copyright \(co 1988, Massachussetts Institute of Technology
All rights reserved.
.LP
.LP
Permission to use, copy, modify, and distribute this document for any purpose
and without fee is hereby granted, provided that the above copyright notice
appear in all copies and that both that copyright notice and this permission
notice are retained, and that the name of M.I.T. not be used in advertising or
publicity pertaining to this document without specific, written prior
permission.  M.I.T. makes no representations about the suitability of this
document or the protocol defined in this document for any purpose.  It is
provided "as is" without express or implied warranty.
.bp 1
.AC "Acknowledgements" 1
.LP
.RU
.LP
This document is presented to the members of the X3D ad hoc committee
and the general public.  It embodies the specification of a protocol
now ready for implementation.  An important first step has been accomplished.
.LP
This work began when, at the first X3D meeting at MIT in June, 1987,
Digital Equipment Corporation and Sun Microsystems, Inc. jointly proposed
that a protocol be defined based upon an initial working draft developed
by Digital.  This draft was influenced by comments from professional
colleagues.  We recognize especially the authors of that first document:
Randi J. Rost, Jeffrey Friedberg, Jeffrey S. Saltz, Pete Nishimoto, and
William H. Clifford, Jr., all of Digital Equipment Corporation.  They
provided a head start for this major undertaking.
.LP
We owe a major debt to the PEX architecture team which met frequently
from June, 1987 till November, 1987 to argue and debate.  In addition,
daily interchange was carried out via electronic mail.  They studied
and resolved all the issues and have published this document.  We thank
the PEX architecture team:
.DS
	Jeffrey Friedberg		\fIDigital Equipment Corp.\fP
	Dave Gorgen		\fIApollo Computer Inc.\fP
	Tom Gross			\fIApollo Computer Inc.\fP
	Marty Hess			\fISun Microsystems\fP
	John McConnell		\fIDigital Equipment Corp.\fP (AT Secretary)
	Pete Nishimoto		\fIDigital Equipment Corp.\fP (AT Secretary)
	Randi J. Rost		\fIDigital Equipment Corp.\fP
	Jeffrey S. Saltz		\fIDigital Equipment Corp.\fP
	Jeff Stevenson		\fIHewlett-Packard\fP
	Jim Van Loo		\fISun Microsystems\fP
.DE
Several members of the X3D group provided useful comments to the 
PEX architecture team.  We note especially the contributions of
Jim Michener of Apollo Computer Inc., and Branko Gerovac, Todd
Newman, and Raymond Drewry of Digital Equipment Corporation who attended
several architecture team meetings and provided counsel.
.LP
Robert Scheifler, Director of the X Consortium at M.I.T., provided
invaluable critique and advice that ensured that our efforts conformed
to the spirit and definition of the X Window System.
.LP
To Randi Rost, the PEX Document Editor, go the thanks of all, for
translating all the decisions into the written word.
Thanks also to the individuals that worked on the X11, PHIGS, and PHIGS+
specification documents, from which some PEX descriptions were obtained.
.LP
As your chairman, and therefore on your behalf, I thank all who
contributed to this document.  A job well done!  The next step:  We
await the implementation of the PEX protocol.  Some work has already begun.

.ID 4.0i
Bertram Herzog
X3D Chairman
14-Dec-1987
.DE
.bp
.AC "PEX Protocol Specification" 1
.LP
.RU
.LP
.AC "Protocol Format" 2
.LP
All PEX\(dg protocol formats are based on the formats specified by the 
\fIX Window System Protocol, Version 11\fP\(dd,
which is referred to as X11 throughout the remainder of this
document.
The PEX protocol will adhere to the philosophy and requirements of X11.
.FS
.br
.sp
\(dg X3D, X3D-PEX, and PEX are trademarks of the 
Massachussetts Institute of Technology
.FE
.FS
.br
.sp
\(dd"X Window System" is a trademark of the 
Massachussetts Institute of Technology
.FE

.AC "Request Format" 3
.LP
Every X11 request consists of a 4-byte header which contains an 8-bit
major opcode, an 8-bit data field, and a 16-bit length field.  The header
is followed by zero or more additional bytes of data, the length of
which is specified by the length field.  Since PEX is a proper extension
of X11, the 8-bit major opcode contains the opcode assigned for
the PEX extension by X11.  The length field contains the length of the
request in units of four bytes,
including the header.  The data (or minor opcode) field will contain the
PEX opcode for this request.

.AC "Reply Format" 3
.LP
Every reply consists of at least 32 bytes.  A header is contained in
these 32 bytes.
The header of a reply
consists of
a 32-bit length field, a 16-bit sequence number field, and an 8-bit
type field.  Zero or
more additional bytes follow the header as specified in the length field.  The 
length field specifies the length of the data following the 32 byte reply
header and is in units of four bytes.
Unused bytes within a reply
are not guaranteed to be zero.
The sequence number field 
contains the least significant 16 bits of the sequence number of
the corresponding request.
The type field defines the type of reply generated.

.AC "Error Format" 3
.LP
Error reports are 32 bytes long.  Every error includes an 8-bit 
error code.
This error code is used to signify the specific PEX error that occurred.
Every error code also includes the major opcode
(the extension reporting the error is identified by the major opcode),
the minor opcode
(the extension opcode which caused the error),
and the least significant 16 bits
of the sequence number of the request which had failed.  Also included
is an 8-bit type field which designates the packet as being an
error packet.  Unused bytes
within an error are not guaranteed to be zero.
               
.AC "Event Format" 3
.LP
Events are 32 bytes long.  Every event contains an 8-bit type code.
The most significant bit in this field is set if the event was generated
from a \fBSendEvent\fP request.  Event codes 64-127 are reserved for extensions,
so only eight events can be defined for interest selection.

.bp
.Fs
.AC "Syntax" 2
.LP
Curly braces {...} enclose a set of alternatives.
Square brackets [...] enclose a list of structure components.
When embedded in descriptions, request names are printed in boldface
(e.g., \fBPEXCreateStructure\fP).
Request parameters are lower case, use the underscore (_) for separation,
and are printed in italics (e.g., \fIitem_mask\fP).
Defined constants, registered enumerated type mnemonics, or alternative
values have an initial capital letter, may use capital letters
for separation, and are printed in italics (e.g., \fIRGBFloat\fP).
Defined types are printed in all caps, use the underscore
for separation, and are printed in the standard font (e.g.,
COORD_3D).
.sp
.LP
Requests are described as follows:
.Fs
.Na PEXSampleRequest
.Rq
.Pa arg1 type1
.Pa argN typeN
.Re
.Pa result1 type1
.Pa resultM typeM
.Se                    
kind1,..., kindK
.Ds 
Functional description goes here
.Fe
.LP
If no reply description is given,
then the request has no 
reply (it is asynchronous), but errors may still be reported.

.AC "Naming Conventions" 2
.LP
PEX requests use a consistent naming convention.  The verbs that are
commonly used in request names are described here.
.DS
.ta 1.2i
\fICreate\fP	Create an instance of a resource
\fIFree\fP	Remove an instance of a resource
\fICopy\fP	Copy attributes from one resource to another of the same type
\fIGet\fP	Return resource attributes from the server to the client
\fIChange\fP	Modify attributes of a resource
\fISet\fP	Modify a selected attribute of a resource
\fIDelete\fP	Remove an instance of a resource, with additional side effects
\fIFetch\fP	Return structure elements from the server to the client
\fIStore\fP	Send structure elements from the client to a structure resource in the server
\fIBegin\fP	Perform an initialization step of some kind
\fIEnd\fP	Perform a termination step of some kind
.ta
.DE
.bp
.AC "Common Types" 2
.LP
The types listed in this section define the common types used in
the PEX protocol specification.
.AC "LISTofFOO" 3
.LP
A type name of the form LISTofFOO means a counted list of elements of
type FOO; the size of the length field may vary (it is not necessarily
the same size as FOO).  In all cases
in the PEX protocol
(except for LISTofVALUE), the length
field is explicit.
.AC "BITMASK and LISTofVALUE" 3
.LP
The types BITMASK
and LISTofVALUE are somewhat special.  Various requests
contain arguments of the form:
.DS
	item_mask : BITMASK
	item_list   : LISTofVALUE
.DE
used to allow the client to specify a subset of a heterogeneous collection
of "arguments".  The \fIitem_mask\fP specifies which 
arguments are to be provided;
each such argument is assigned a unique bit position.  
The representation of BITMASK may contain more bits
than there are defined arguments; unused bits in the  \fIitem_mask\fP 
must be zero (or the extension will generate a Value error).
The \fIitem_list\fP
contains
one item for each one bit in the mask, from least to most significant bit
in the mask.   

.AC "Floating Point Format - FLOAT" 3
.LP
The PEX protocol allows floating-point values to be passed in
various floating-point formats.
All floating-point arguments will
be specified as FLOAT, which is defined to be the
floating-point type contained in the format word associated with the
request.  Furthermore, items such as MATRIX, VECTOR, and COORD
will be in the floating-point format specified
by the format word associated with the request.

.AC "Colors" 3
.LP
In PEX, colors are typically passed as a flag and a value.
The flag specifies whether
the color is an index value or a direct color value.
PEX servers are required to be able to
deal with indexed colors
and at least one type of direct color.
Indexed colors are specified using an index which is used to obtain
the color from a color lookup table.
Direct colors are specified
directly as RGB, HSV, HLS, or CIE color values of some form.
The list of registered direct color formats can be found in the
"Extension Information" section.
PEX servers are free to store direct color values
in whatever implementation-dependent format they choose, but
they must be capable of converting those values back into one
of the supported direct color types when queried by the client.

.AC "Element Types" 3
.LP
Chapter 3 describes the set of output commands that are recognized
by a PEX implementation.  These output commands are distinguished
by a 16-bit ELEMENT_TYPE value.  This value contains a 16-bit unsigned
short that defines the actual type of output command.  The high-order
bit of the element type is used to signify whether the output command
is a standard PEX output command (high-order bit equals zero) or whether
the output command is a proprietary addition to the set of standard
PEX output commands.  Servers are expected to be able to create structure
elements containing non-standard PEX output commands, but the execution
of such output commands can be a no-op.
Unlike the use of the PHIGS-style GSE and GDP output commands,
this extension mechanism allows vendors to gracefully add
fully-integrated functionality to the standard PEX extension, and permits
an implementation to ignore output commands
with which it is not familiar.

.AC "Types" 3
.LP
The PEX Protocol types are as follows:

.ID

ASF_ATTRIBUTE		: {\fIMarkerTypeASF, MarkerScaleASF, MarkerColorASF,
						TextFontIndexASF, TextPrecASF, CharExpansionASF,
						CharSpacingASF, TextColorASF, LineTypeASF,
						LineWidthASF, LineColorASF, CurveApproxASF,
						PolylineInterpASF, InteriorStyleASF, InteriorStyleIndexASF,
						SurfaceColorASF, SurfaceInterpASF, ReflectionModelASF,
						ReflectionAttrASF, BFInteriorStyleASF, BFInteriorStyleIndexASF,
						BFSurfaceColorASF, BFSurfaceInterpASF, BFReflectionModelASF,
						BFReflectionAttrASF, SurfaceApproxASF, TrimCurveApproxASF,
						SurfaceEdgesASF, SurfaceEdgeTypeASF, SurfaceEdgeWidthASF,
						SurfaceEdgeColorASF\fP}
ASF_SPECIFIER			: [enables, asfs : BITMASK]
ASF_VALUE			: {\fIBundled, Individual\fP}
ATEXT_STYLE			: ENUM_TYPE_INDEX (used with \fIATextStyle\fP enumerated type)
BITMASK				: CARD32
BOOLEAN				: {\fIFalse, True\fP}
CARD8				: unsigned 8-bit integer
CARD16				: unsigned 16-bit integer
CARD32				: unsigned 32-bit integer
COLOR				: {direct color value\(dg, TABLE_INDEX}
COLOR_FORMAT		: ENUM_TYPE_INDEX (used with \fIDirectColorFormat\fP enumerated type)
COLOR_SPECIFIER		: [color_type : COLOR_TYPE,
						color_value : COLOR]
COLOR_TYPE			: {\fIDirect, Indexed\fP}
COMPOSITION			: {\fIPreConcatenate, PostConcatenate, Replace\fP} 
CONSTANT_NAME		: CARD16
COORD				: {COORD_2D, COORD_3D, COORD_4D}
COORD_2D			: [x, y : FLOAT]
COORD_3D			: [x, y, z : FLOAT] 
COORD_4D			: [x, y, z, w : FLOAT]
COORD_TYPE			: {\fIRational, NonRational\fP}
CULL_MODE			: {\fINone, BackFaces, FrontFaces\fP}
CURVE_APPROX		: [approx_method : CURVE_APPROX_METHOD,
						tolerance : FLOAT]
CURVE_APPROX_METHOD : ENUM_TYPE_INDEX (used with \fICurveApproxMethod\fP enumerated type)
CURVE_BASIS			: ENUM_TYPE_INDEX (used with \fICurveBasis\fP enumerated type)
DIRECT_COLOR		: direct color value\(dg
.FS
\(dg See the "Extension Information" section for a list of the registered
direct color formats.
.FE
DISPLAY_STATE		: {\fINotEmpty, Empty\fP}
DISPLAY_UPDATE		: ENUM_TYPE_INDEX (used with \fIDisplayUpdateMode\fP enumerated type)
DRAWABLE_COORD		: [x, y : CARD16, z : FLOAT]
DRAWABLE_ID			: {WINDOW_ID, PIXMAP_ID}
DYNAMIC_TYPE		: {\fIIMM, IRG, CBS\fP}
EDGE				: OPT_SWITCH
EDIT_MODE			: {\fIStructureInsert, StructureReplace\fP}
EDITING_CONTEXT_ID	: RESOURCE_ID
ELEMENT_INFO		: [type : ELEMENT_TYPE,
						length : CARD16]
ELEMENT_POS			: [whence : {\fIBeginning, Current, End\fP}
						offset : INT32]
ELEMENT_RANGE		: [position1, position2 : ELEMENT_POS]
ELEMENT_REF			: [structure_id : STRUCTURE_ID,
						offset : CARD32]
ELEMENT_TYPE		: CARD16
ENUM_TYPE			: {\fIMarkerType, ATextStyle, InteriorStyle, HatchStyle,
						LineType, SurfaceEdgeType, PolylineInterpMethod,
						CurveApproxMethod, CurveBasis, ReflectionModel,
						SurfaceInterpMethod, SurfaceApproxMethod, SurfaceBasis,
						ModelClipOperator, LightType, DirectColorFormat,
						FloatFormat\fP}

ENUM_TYPE_INDEX		: INT16
FACET				: [facet_data : OPT_DATA,
						vertices : LISTofVERTEX]
FLOAT				: floating point value\(dg
.FS
\(dg See the "Extension Information" section for a list of the registered
floating point formats.
.FE
FLOAT_FORMAT		: ENUM_TYPE_INDEX (used with \fIFloatFormat\fP enumerated type)
FORMAT				: [fp_format : FLOAT_FORMAT,
						direct_color_format : COLOR_FORMAT]
HALFSPACE			: [point : COORD_3D,
						vector : VECTOR_3D]
HALFSPACE_2D			: [point : COORD_2D,
						vector : VECTOR_2D]
HATCH_STYLE			: ENUM_TYPE_INDEX (used with \fIHatchStyle\fP enumerated type)
HLHSR_MODE			: ENUM_TYPE_INDEX (used with \fIHLHSRMode\fP enumerated type)
INT8					: signed 8-bit integer
INT16				: signed 16-bit integer
INT32				: signed 32-bit integer
INTERIOR_STYLE		: ENUM_TYPE_INDEX (used with \fIInteriorStyle\fP enumerated type)
LIGHT_TYPE			: ENUM_TYPE_INDEX (used with \fILightType\fP enumerated type)
LINE_TYPE			: ENUM_TYPE_INDEX (used with \fILineType\fP enumerated type)
LOOKUP_TABLE_ID		: RESOURCE_ID
MARKER_TYPE			: ENUM_TYPE_INDEX (used with \fIMarkerType\fP enumerated type)
MATRIX				: FLOAT[4][4]
MATRIX_3X3			: FLOAT[3][3]
NAME				: CARD32
NAME_SET_ID			: RESOURCE_ID
NPC_SUBVOLUME		: [min : COORD_3D,
						max : COORD_3D]
OPERATOR			: ENUM_TYPE_INDEX (used with \fIModelClipOperator\fP enumerated type)
.bp
OPT_COLOR			: optional COLOR\(dg
OPT_DATA			: [color : OPT_COLOR,
						normal : OPT_NORMAL,
						edges : OPT_SWITCH ]
OPT_NORMAL			: optional VECTOR_3D\(dg
OPT_SWITCH			: optional SWITCH\(dg
.FS
\(dg
Indicates a parameter (or portion of a parameter) that
may or may not be present in the request.
However, its presence or absence can always be inferred
from previous parameters in the request.
.FE
OUTPUT_CMD			: [element_type : ELEMENT_TYPE,
						size : CARD16,
						data : \(dd ]
.FS
\(dd
See the section "Output Commands" for a description of
each of the data records that can be passed as an output command.
.FE
PC_BITMASK			: CARD32[2]
PEX_FONT_ID			: RESOURCE_ID
PHIGS_WKS_ID			: RESOURCE_ID
PIPELINE_CONTEXT_ID	: RESOURCE_ID
PICK_DEVICE_TYPE		: ENUM_TYPE_INDEX (used with \fIPickDeviceType\fP enumerated type)
PICK_MEASURE_ID		: RESOURCE_ID
PICK_ELEMENT_REF		: [s_id : STRUCTURE_ID,
						offset : CARD32,
						pickid : CARD32]
PIXMAP_ID			: RESOURCE_ID
POLYLINE_INTERP		: ENUM_TYPE_INDEX (used with \fIPolylineInterpMethod\fP enumerated type)
PROMPT_ECHO_TYPE	: ENUM_TYPE_INDEX (used with \fIPromptEchoType\fP enumerated type)
REFLECTION_ATTRIBUTES : [ambient_coef : FLOAT,
						diffuse_coef : FLOAT,
						specular_coef : FLOAT,
						specular_conc : FLOAT,
						transmission_coef : FLOAT,
						specular_color : COLOR_SPECIFIER]
REFLECTION_MODEL	: ENUM_TYPE_INDEX (used with \fIReflectionModel\fP enumerated type)
RENDERER_ID			: RESOURCE_ID
RENDERER_STATE		: {\fIRendering, Idle\fP}
RESOURCE_ID			: 32-bit identifier
SEARCH_CONTEXT_ID	: RESOURCE_ID
SHAPE				: {Convex, NonConvex, Complex, Unknown}
STRING				: LISTofCARD8
STRUCTURE_ID			: RESOURCE_ID
SURFACE_APPROX		: [approx_method : SURFACE_APPROX_METHOD,
						s_tolerance, t_tolerance : FLOAT]
SURFACE_APPROX_METHOD : ENUM_TYPE_INDEX (used with \fISurfaceApproxMethod\fP enumerated type)
SURFACE_EDGE_TYPE	: ENUM_TYPE_INDEX (used with \fISurfaceEdgeType\fP enumerated type)
SURFACE_BASIS		: ENUM_TYPE_INDEX (used with \fISurfaceBasis\fP enumerated type)
SURFACE_INTERP		: ENUM_TYPE_INDEX (used with \fISurfaceInterpMethod\fP enumerated type)
SWITCH				: {\fIOff, On\fP}
TABLE_ENTRY			: [data : * ]
.FS
* See the section "Lookup Tables" for a description of
each of the data records that can be passed/returned as a table entry.
.FE
TABLE_INDEX			: CARD16
TABLE_TYPE			: {\fILineBundle, MarkerBundle, TextBundle, InteriorBundle,
						EdgeBundle, Pattern, TextFont, Color, View, Light,
						DepthCue, RGBApprox, IntensityApprox\fP}
TEXT_ALIGNMENT		: [vertical : TEXT_VALIGNMENT,
						horizontal : TEXT_HALIGNMENT]
TEXT_HALIGNMENT		: {\fINormal, Left, Right, Center\fP}
TEXT_PATH			: {\fIRight, Left, Up, Down\fP}
TEXT_PRECISION		: {\fIString, Char, Stroke\fP}
TEXT_VALIGNMENT		: {\fINormal, Top, Cap, Half, Base, Bottom\fP}
TRIM_CURVE			: [type : COORD_TYPE,
						visibility : SWITCH,
						order : CARD32,
						tmin, tmax : FLOAT,
						points : LISTofCOORD,
						knots : LISTofFLOAT]

TYPE_OR_TABLE_INDEX	: {ENUM_TYPE_INDEX, TABLE_INDEX}
UPDATE_STATE		: {\fINotPending, Pending\fP}
VECTOR_2D			: [x, y : FLOAT]          
VECTOR_3D			: [x, y, z : FLOAT]          
VERTEX				: [point : COORD_3D
						data : OPT_DATA]
VERTEX_INDEX		: [vertex : CARD16,
						data : OPT_DATA]
VIEWPORT			: [min : DRAWABLE_COORD,
						max : DRAWABLE_COORD,
						use_drawable : BOOLEAN]
VIEW_REP				: [index : TABLE_INDEX,
						clip_flags : BITMASK,
						clip_limits : NPC_SUBVOLUME,
						orientation : MATRIX,
						mapping : MATRIX]
VISUAL_STATE			: {\fICorrect, Deferred, Simulated\fP}
WINDOW_ID			: RESOURCE_ID
X11_FONT_ID			: RESOURCE_ID
				
.DE

.bp
.AC "Errors" 3
.LP
The PEX Protocol uses the same set of error codes as the X11 Protocol
when applicable.
Additional error codes are provided for PEX-specific errors.
The following error codes can be returned by the various PEX requests:

.Bl "DirectColorFormat"
The specified direct color format is not supported.

.Bl "EditingContext"
A value for a editing context argument is illegal or does not name a defined
editing context resource.

.Bl "FloatingPointFormat"
The specified floating point format is not supported.

.Bl "Label      "
A value for a label is not found in the specified structure.

.Bl "LookupTable"
A value for a lookup table argument is illegal or does not name a defined
lookup table resource.

.Bl "NameSet"
A value for a name set argument is illegal or does not name a defined
name set resource.

.Bl "Path         "
A value for a structure network path contains inappropriate or
illegal values.

.Bl "PEXfont"
A value for a PEX font argument is illegal or does not name a defined
PEX font resource.

.Bl "PhigsWKS"
A value for a PHIGS workstation argument is illegal or does not name a defined
PHIGS workstation resource.

.Bl "PickMeasure"
A value for a pick measure argument is illegal or does not name a defined
pick measure resource.

.Bl "PipelineContext"
A value for a pipeline context argument is illegal or does not name a defined
pipeline context resource.

.Bl "Renderer"
A value for a renderer argument is illegal or does not name a defined
renderer resource.

.Bl "SearchContext"
A value for a search context argument is illegal or does not name a defined
search context resource.

.Bl "Structure"
A value for a structure argument is illegal or does not name a defined
structure resource.

.AC "Events" 2
.LP
All PEX events will use the same mechanisms as X events.  PEX does
not introduce any new X events.
.bp
.AC "Extension Information" 2
.LP
These requests return static information
about the PEX extension and what it supports.
Information about specific capabilities and tradeoffs should be
found in the documentation describing a particular PEX server implementation
(e.g., what is the "best" HLHSR method or floating point format or direct
color format to use, whether quick update really does anything, what
range of line and surface edge widths are supported, etc.)

.AC "Get Extension Information" 3
.Fs
.Na "PEXGetExtensionInfo"
.Rq                 
.Pa client_protocol_major_version CARD16
.Pa client_protocol_minor_version CARD16
.Re
.Pa protocol_major_version CARD16
.Pa protocol_minor_version CARD16
.Pa vendor STRING
.Pa release_number CARD32
.Pa subset_info CARD32
.Ds              
The \fIclient_protocol_major_version\fP and the 
\fIclient_protocol_minor_version\fP
indicate what version of the protocol the client
expects the server to implement.
The protocol version numbers
returned indicate the protocol the PEX extension actually supports.
This might not equal the version sent by the client.
A PEX extension can (but need
not) support more than one version simultaneously.
The \fIprotocol_major_version\fP and the \fIprotocol_minor_version\fP are
a mechanism to support future revisions of the PEX protocol which
may be necessary.
In general, the major version would increment for incompatible changes,
and the minor version would increment for small, upward-compatible changes.
Barring changes, the \fIprotocol_major_version\fP will be three, and the
\fIprotocol_minor_version\fP will be two.
The \fIvendor\fP parameter is a string of ISO-LATIN1 characters that
describes the vendor that supplied the PEX extension.  The release number
is a 32-bit values whose semantics are controlled by the vendor.  The
\fIsubset_info\fP parameter is a 32-bit value that indicates the completeness
of the PEX extension.  If \fIsubset_info\fP is equal to zero, the extension
is a complete PEX implementation.
If the low-order bit of \fIsubset_info\fP
is a one, then the PEX extension is an immediate-mode only implementation.
If the next-to-low-order bit of \fIsubset_info\fP
is a one, then the PEX extension is a structure-mode only implementation.
The \fIsubset_info\fP pararmeter will always have at most one of these
two bits set.
See Appendix A for the definition of immediate-mode only and structure-mode
only subsets.
.Fe
.bp


.AC "Get Enumerated Type Information" 3
.Fs
.Na "PEXGetEnumeratedTypeInfo"
.Rq
.Pa drawable_id DRAWABLE_ID
.Pa enum_types LISTofENUM_TYPE
.Pa item_mask BITMASK
.Re
.Pa types LISTofLISTofVALUE
.Se
Drawable, Value
.Ds
This request returns information about the enumerated types specified
by \fIenum_types\fP.
It returns information about the enumerated
types that are supported for drawables that have the same root window
and depth as the drawable indicated by
\fIdrawable_id\fP.  The \fIitem_mask\fP indicates the data that is to
be returned to describe each enumerated type.  The components
of an enumerated type descriptor (and the corresponding bits of
\fIitem_mask\fP) are:
.ID
    index		: ENUM_TYPE_INDEX
    mnemonic	: STRING
.DE
If only the \fIindex\fP bit is set in \fIitem_mask\fP, a list of index
values (type ENUM_TYPE_INDEX)
will be returned for the defined values for each enumerated type
specified in the \fIenum_types\fP list.
If only the \fImnemonic\fP bit is set in \fIitem_mask\fP,
only descriptor strings that use the ISO-Latin1 encoding
will be returned for the defined values (type STRING).
If both the \fIindex\fP and \fImnemonic\fP bits are set,
an index/mnemonic pair
will be returned for each of the defined values for each of the
requested enumerated types.
If neither bit is set, a list of counts
will be returned, where each count represents the number of supported
types for each entry in \fIenum_types\fP.
.LP
The various enumerated types and registered values are listed below.
Each registered value is followed by the mnemonic string that is
returned and a brief description.
Strings are returned using the ISO-Latin1 character set.
The strings are returned exactly as shown below.
Any enumerated type values less than zero are implementation-dependent (consult
the implementation documentation for their descriptions), and any numbers
greater than the listed values are reserved for future registration.


.Bl "MarkerType"
The marker type specifies the shape of the marker primitive that
is to be drawn when rendering marker primitives.  The registered values
are:
.Es
1	Dot	"." which is always displayed as the smallest displayable
		dot (the \fImarker_scale\fP attribute is ignored) with the dot
		at the marker position.
2	Cross	"+" (cross or plus sign) with intersection at the marker position.
3	Asterisk	"*" with intersection at the marker position.
4	Circle	"o" with center at marker position
5	X	"x" with intersection at the marker position.
.Ee


.Bl "ATextStyle"
The annotation text style specifies the style that
is to be used when rendering annotation text primitives.  The registered values
are:
.Es
1	NotConnected	The annotation text primitive will be drawn with no
		line connecting it to the annotation text reference point.
2	Connected	The annotation text primitive will be connected to
		the annotation text reference point with a line, which will be
		drawn using the current set of line attributes.
.Ee


.Bl "InteriorStyle"
The interior style specifies the style that
is to be used when rendering surface primitives.
The registered values are:
.Es
1	Hollow	The interiors of surface primitives are not filled, but the
		boundary is drawn using the surface color.  If the surface
		primitive is clipped, the boundary must be drawn along
		the clipped boundary as well.
2	Solid	The interiors of surface primitives are filled using the
		surface color.
3	Pattern	The interiors of surface primitives are filled using the
		pattern table entry specified by the interior style index.
4	Hatch	The interiors of surface primitives are filled using the
		surface color and the hatch style whose index is specified
		by the interior style index.
5	Empty	The interior of the surface primitive is not drawn at all.
.Ee


.Bl "HatchStyle"
The hatch style specifies the method that
is to be used to render surface primitives when the interior
style is set to \fIHatch\fP.  There are currently no registered hatch styles.


.Bl "LineType"
The line type specifies the style that
is to be used when rendering polyline and curve primitives.
The registered values are:
.Es
1	Solid	Draw the polyline or curve with a solid, unbroken line.
2	Dashed	Draw the polyline or curve with a line that is dashed.
3	Dotted	Draw the polyline or curve with a line that is dotted.
4	DashDot	Draw the polyline or curve with a line that contains
		alternating dots and dashes.
.Ee
It is implementation-dependent whether the sequence for the
\fIDashed\fP, \fIDotted\fP, and \fIDashDot\fP line types is restarted
or continued at the start of the polyline, at the start of a clipped
segment of a polyline, and at each vertex of a polyline.


.Bl "SurfaceEdgeType"
The surface edge type specifies the style that
is to be used when rendering surface edges.
The registered values are:
.Es
1	Solid	Draw the surface edge with a solid, unbroken line.
2	Dashed	Draw the surface edge with a line that is dashed.
3	Dotted	Draw the surface edge with a line that is dotted.
4	DashDot	Draw the surface edge with a line that contains alternating
		dots and dashes.
.Ee
It is implementation-dependent whether the sequence for the
\fIDashed\fP, \fIDotted\fP, and \fIDashDot\fP edge types is restarted
or continued at the start of the edge, at the start of a clipped
segment of an edge, and at each vertex.


.Bl "PickDeviceType"
The pick device type specifies the type of pick device that
is to be used to perform picking operations.
There are currently no registered pick devices.


.Bl "PolylineInterpMethod"
The polyline interpolation method specifies the style that
is to be used when rendering polyline primitives that have colors
specified per-vertex.
Depth-cueing is applied as a post-process
to polylines regardless of the polyline interpolation method.
The registered values are:
.Es
1	None	No interpolation will be performed between polyline vertices.
		If color values are supplied that differ for the endpoints
		of a polyline segment, it is implementation-dependent whether
		the color of the \fIi\fPth vertex will be used to draw the
		line between the \fIi\fPth and \fI(i+1)\fPth vertices (if \fIn\fP
		is the number of vertices, the color at the \fIn\fPth will be
		ignored), or whether they will be used to compute an average
		color which will be used for the entire segment.
2	Color	The polyline's vertex colors (if present) are used.  Color
		values along each polyline segment are then computed by
		linearly interpolating between the color values at the
		vertices.
.Ee


.Bl "CurveApproxMethod"
The curve approximation method specifies the method that
is to be used when rendering parametric curve primitives.
The registered values are:
.Es
1	Constant	This technique tessellates the curve with equal
		parametric increments.  If the control value is
		negative, the technique evaluates the curve at just
		the parametric bounds. If the control value is positive,
		the technique evaluates the curve at the number of points
		between the parameter bounds.   

2	ConstantBetweenKnots	This technique tessellates the curve with equal
		parametric increments between successive pairs of knots.
		When the curve includes knots, if the control value is
		negative, the technique evaluates the curve at just the
		parametric bounds, plus all knots which are between the
		parametric bounds.  If the control value is positive, the
		technique evaluates the curve at the number of points
		between the knots, but only if these parametric values
		are between the parametric bounds.

3	WCS_Metric	This technique tessellates the curve until the length
		of every line segment, in world coordinates, is less
		than the tolerance.

4	NPC_Metric	This technique tessellates the curve until the length
		of every line segment, in normalized projection
		coordinates, is less than the tolerance.

5	WCS_ChordalDev	This technique tessellates the curve until the maximum
		deviation (in world coordinates) between the line and
		the curve is less than the tolerance.

6	NPC_ChordalDev	This technique tessellates the curve until the maximum
		deviation (in normalized projection coordinates) between
		the line and the curve is less than the tolerance.
.Ee


.Bl "CurveBasis"
The curve basis specifies the basis that
is to be used when rendering parametric curve primitives.
The registered values are:
.Es
1	UniformBSpline	A uniform B-spline curve approximates the data points
		supplied.  Given m control points and the positive order
		n (<=m), a series of m-n+1 polynomial spans of order n
		which are connected with parametric continuity of class
		n-2 are drawn.  For example, a cubic B-spline curve of
		order 4 will have continuity of all derivatives up to and
		including the second.  In the degenerate case where the
		specified m is less than n, a B-spline of order m will
		be generated.

2	PiecewiseBezier	This type of curve (order n) is produced by interpolating
		its first and n'th control points and approximating the
		other (interior) control points in a well-defined, variation-
		diminishing way.  A common use of these curves is to chain
		them together end-to-end to represent more complicated
		curves.  The piecewise Bezier curve of order n is a curve
		composed of spans of order n which meet at the n'th control
		point and every (n-1)'st control point thereafter with
		positional continuity.  A well-formed piecewise Bezier
		curve of order n will have m control points where m = n
		plus some integer multiple of (n-1).  When excess control
		points are provided, they will be ignored.  In the degenerate
		case where the specified m is less than n, a Bezier curve
		of order m will be generated.


.Bl "ReflectionModel"
The reflection model specifies the method that
is used to perform the light source shading computation
when rendering surface primitives.  The input to the light source shading
computation is known as the \fIbase color\fP and the output is known
as the \fIshaded color\fP.
If a normal exists at the
point at which the reflection model is to be evaluated, it will be
used.  Otherwise, if a normal exists for the facet containin the point,
it will be used to evaluate the reflection model.  If no normal exists,
the reflection model is evaluated, if possible, without a normal.
The registered values are:
.Es
1	NoShading	No light source shading computation is performed.  The
		surface color is not affected by light source illumination
		(effectively, shaded color == base color).
2	Ambient	Only the ambient terms of the lighting equation are used.
		The shaded color will be the base color as seen under
		ambient light.
3	Diffuse	Only the ambient and diffuse terms of the lighting equation
		are used.  The shaded color will be the base color as
		seen under ambient light, plus a diffuse reflection
		component from each light source.
4	Specular	The ambient, diffuse, and specular terms of the lighting
		equation are all used during the light source shading
		computation.  The shaded color will be the same as for
		\fIDiffuse\fP, plus a specular reflection component from
		each light source.
.Ee


.Bl "SurfaceInterpMethod"
The surface interpolation method specifies the method that
is used to compute color values in surface interiors
when rendering surface primitives.
Depth-cueing is applied as a post-process
to surface primitives regardless of the surface interpolation method.
The registered values are:
.Es
1	None	The color resulting from a single light source computation is
		used for the entire surface.  No interpolation will be
		performed across surface interiors or edges.
2	Color	The colors are computed at the vertices of the surface according
		to the current \fIreflection_model\fP.  These color values
		are then linearly interpolated across the interior of the
		surface or the edges.
3	DotProduct	The lighting equation dot products are computed at the
		vertices.  These dot products are linearly interpolated
		and the light source shading computation is applied using
		these values to compute the color value at each pixel in
		the interior of a surface or along a surface edge.
4	Normal	An attempt is made to determine a normal and perform the light
		source shading computation as accurately as possible at
		each pixel in the interior of a surface or along a surface
		edge.
.Ee


.Bl "SurfaceApproxMethod"
The surface approximation method specifies how to display parametric surface 
primitives.
The registered values are:
.Es
1	Constant	This technique tessellates the parametric surface with
		equal parametric increments.  The function requires two
		control values. The two control values specify how to
		subdivide the two parametric dimensions. If the control
		value is negative, the technique evaluates the surface at
		just the u or v parametric bounds. If the control value is
		positive, the technique evaluates the surface at points
		between the u or v parameter bounds.  The control value,
		in this case, represents the number of parametric samples
		between the bounds.

2	ConstantBetweenKnots	This technique tessellates the surface with equal parametric
		increments between successive pairs of knots.  When the
		surface includes knots, if the control values are negative,
		the technique evaluates the surface at the u or v parametric
		bounds, plus all the knots between the u or v parametric
		bounds.  If the control values are positive, the technique
		evaluates the surface at points between the knots, but only
		if these parametric samples are between the u or v parametric
		bounds.

3	WCS_Metric	This technique tessellates the surface until the length of every
		line segment, in world coordinates, is less than the tolerance. 

4	NPC_Metric	This technique tessellates the surface until the length of every
		line segment, in normalized projection coordinates, is less
		than the tolerance.

5	WC_PlanarDev	This technique tessellates the surface into facets.  The
		technique subdivides the surface until the maximum deviation,
		in world coordinates, between the plane and the surface is
		less than the tolerance. 

6	NPC_PlanarDev	This technique tessellates the surface into facets.  The
		technique subdivides the surface until the maximum deviation,
		in normalize projection coordinates, between the plane and the
		surface is less than the tolerance. 


.Bl "SurfaceBasis"
The surface basis specifies the basis that
is to be used when rendering parametric surface primitives.
The registered values are:
.Es
1	UniformBSpline	A uniform B-spline surface approximates the control
		points supplied with an array of bi-polynomial surface
		patches of order specified in the s and t directions.  It
		does not necessarily interpolate any of the control points.
		Continuity between patches is completely analogous to the
		continuity of B-spline curve spans.   For example, a mesh
		defining an array of bicubic patches (order 4) will have
		positional and first and second parametric derivative
		continuity between patches.

		In the degenerate case where the specified mesh dimension
		is less than the polynomial order for that direction, a
		polynomial of order equal to the mesh dimension will be
		generated.

2	PiecewiseBezier	This basis interpolates the corner points of the control
		mesh and approximates the other (interior) control points
		in a well-defined, variation-diminishing way.  The surface
		may have different orders associated with each direction and 
		thus require a different number of rows and columns in the
		control mesh.  The dimensions of the mesh are the respective
		orders, the order in the s direction is equal to the number
		of columns of the mesh and the order on the t direction is
		equal to the number of rows.  One use of these surfaces is
		to make arrays of them to describe more complicated surfaces.

		The piecewise Bezier surface is composed of an array of
		patches abutted at the edges with at least positional
		continuity by virtue of sharing their "edge" control points.
		This compositing of patches implies the appropriate
		dimensionality of the control mesh in a manner analogous
		to the piecewise extension of  curves.  A well-formed
		piecewise Bezier surface of order n in the s direction
		will thus have m columns of control points where m = n
		plus some integer multiple of (n-1), and similarly in the
		t direction.

		Where excess rows or columns of control points are provided,
		they will be ignored.  In the degenerate case where the
		specified row or column is less than the polynomial order
		for the associated direction, a Bezier surface of order
		equal to the row or column dimension will be generated.
.Ee


.Bl "ModelClipOperator"
The model clip operator defines the operation that is to be used
to combine the specified halfspaces with the current composite
modeling clipping volume.
The registered values are:
.Es
1	Replace	The specified halfspaces are used to create a new composite
		modeling clipping volume that replaces the current composite
		modeling clipping volume.
2	Intersection	The specified halfspaces are and'ed with the current
		composite modeling clipping volume to compute a new composite
		modeling clipping volume.
.Ee


.Bl "LightType"
The light type defines the characteristics of the light sources
that can be used in light source shading computations.
The registered values are:
.Es
1	Ambient	A light source that affects all surface primitives uniformly.
		Ambient light sources have only a color attribute.
2	WCS_Vector	A light source that is specified in world coordinates
		with a color and a direction vector.
3	WCS_Point	A light source that is specified in world coordinates
		with a color, a position, and two attenuation coefficients.
4	WCS_Spot	A light source that is specified in world coordinates
		with a color, a position, a direction vector, a concentration
		exponent, two attenuation coefficients and a spread angle.
.Ee


.Bl "DirectColorFormat"
The direct color format defines the format of direct color values.
The registered values are:
.Es
1	RGBFloat	A color that is passed as three floating point values,
		in the order red, green, blue.  A color in this format
		has a type defined by:
		COLOR_RGB_FLOAT	: [r, g, b : FLOAT]
2	CIEFloat	A color that is passed as three floating point values,
		in the order x, y (CIE diagram coefficients), and luminance.
		A color in this format has a type defined by:
		COLOR_CIE_FLOAT	: [x, y, luminance : FLOAT]
3	HSVFloat	A color that is passed as three floating point values,
		in the order hue, saturation, and value.  A color in this
		format has a type defined by:
		COLOR_HSV_FLOAT	: [hue, saturation, value : FLOAT]
4	HLSFloat	A color that is passed as three floating point values,
		in the order hue, lightness, and saturation.  A color in this
		format has a type defined by:
		COLOR_HLS_FLOAT	: [hue, lightness, saturation : FLOAT]
5	RGBInt8	A color that is passed as a unit of four bytes, in the
		order red, green, blue.  A color in this format has a type
		defined by:
		COLOR_RGB_INT8	: [r, g, b, pad : CARD8]
6	RGBInt16	A color that is passed as three short integer values
		in the order red, green, blue.  A color in this format has
		a type defined by:
		COLOR_RGB_INT16	: [r, g, b, pad : CARD16]
.Ee


.Bl "FloatFormat"
The floating point format defines the format of floating point values.
The registered values are:
.Es
1	IEEE_754_32	An IEEE 754 standard 32-bit floating point value.
2	DEC_F_Floating	A DEC F-floating value.
.Ee


.Bl "HLHSRMode"
The HLHSR mode defines the method used to do hidden line/hidden surface
removal.
The registered values are:
.Es
1	Off	All output primitives are drawn in the order they are
		processed.  No attempt will be made to remove hidden surfaces.
2	ZBuffer	Visibility is resolved at each pixel using a depth-,
		or z-buffering technique.  The z-buffering method and
		the number of bits of precision in the z values is
		device-dependent.  This technique permits visibility
		to be computed without an intermediate storage area for
		transformed data, can be used to incrementally add primitives
		to an image, and is an HLHSR method which is of linear order.
3	Painters	Output primitives are buffered as they are processed.
		When the renderer is freed or reinitialized, the primitives
		in the buffer are sorted based on the average depth and
		rendered back-to-front.  This technique is fairly fast
		for small numbers of primitives, but requires an intermediate
		storage area.  This technique does not guarantee totally
		correct results, since it fails in cases involving cyclically
		overlapping or interpenetrating objects, and in other, even
		simpler cases.
4	Scanline	Output primitives are buffered as they are received.
		When the renderer is freed or reinitialized, the primitives
		in the buffer are sorted and visibility is computed in scan
		line order.  This technique can be fairly fast for small
		numbers of polygons, but uses an intermediate storage area
		to buffer output primitives and must perform a sorting step.
5	HiddenLineOnly	Only visible lines will be drawn.  Output primitives
		may be buffered as they are received.  When the
		renderer is freed or reinitialized, the primitives in the
		buffer are sorted and a hidden line computation is performed.
.Ee


.Bl "PromptEchoType"
The prompt echo type defines the method used to do prompting and echoing
during picking operations.
The registered values are:
.Es
1	EchoPrimitive	Use an implementation-dependent technique that at
		least highlights the picked primitive for a short period
		of time.
2	EchoStructure	Echo the contiguous group of primitives with the same
		pick id as the picked primitive, or all of the primitives
		of the structure with the same pick id as the picked primitive.
3	EchoNetwork	Echo the entire posted structure network that contains
		the picked primitive.
.Ee


.Bl "DisplayUpdateMode"
The display update mode defines the manner in which changes will affect
the displayed image.
The registered values are:
.Es
1	VisualizeEach	Visualize each change as it occurs. (PHIGS - ASAP)
2	VisualizeEasy	Visualize only the changes that are "easy to do" (PHIGS -
		WAIT/UWOR).  Things that are "easy to do" are those that
		have a dynamic modification of \fIIMM\fP or can be updated
		without a regeneration of the displayed image.  If regeneration
		is "easy to do" (as defined by the PEX implementor), then a
		regeneration may occur.
3	VisualizeNone	Visualize none of the changes (PHIGS - WAIT/NIVE).  The
		changes are applied, but the image is not regenerated until
		there is an explicit request to do so.
4	SimulateSome	Visualize the easy changes and simulate those changes
		that can be simulated.  (PHIGS - WAIT/UQUM)
5	VisualizeWhenever	All changes will eventually be visualized.  If regenerations
		are necessary, they will be performed at the server's
		convenience.  One regeneration may cause a number of changes
		to be visualized.  The client can issue an update workstation
		request to guarantee that all changes have been visualized.
		(PHIGS - ASTI/NIVE)
.Ee
It should be noted that implicit image regenerations may be performed when
the display update is one of
\fIVisualizeEach\fP, \fIVisualizeWhenever\fP, or \fISimulateSome\fP.
If such a regeneration occurs, the display surface will be cleared
and any output that was not generated by traversing the posted structure
list (such as output from core X) will be lost.  \fIVisualizeEasy\fP
and \fIVisualizeNone\fP will not cause implicit regenerations to occur.
.Fe
.bp


.AC "Get Implementation-Dependent Constants" 3
.Fs
.Na "PEXGetImpDepConstants"
.Rq                 
.Pa fp_format FLOAT_FORMAT
.Pa drawable_example DRAWABLE_ID
.Pa names LISTofCONSTANT_NAME
.Re
.Pa constants LISTofVALUE
.Se
Value, FloatingPointFormat, Drawable
.Ds              
This request allows a client to query one or more of the
implementation-dependent constants in a PEX server extension.
A single CARD32 or FLOAT is returned for each value requested.
These values are returned in order, with one return value in
\fIconstants\fP for each requested value in \fInames\fP.  Floating-point
values will be returned in the format specified by
\fIfp_format\fP.  The implementation-dependent constants that
are returned are based on the values that would be used for
a drawable with the same root and depth as \fIdrawable_example\fP.
.LP
PEX defines a number of standard constant names that all PEX
extensions must be able to return.  These standard constant
names are 16-bit integers with the high order bit equal to zero.
Additional proprietary implementation-dependent constants can
be defined and returned by PEX server extensions using 16-bit
integers with the high order bit equal to one.  The standard
constant names consist of:
.LD
.ta 1.6i 2.4i
\fINominalLineWidth\fP	CARD32	Width (in pixels) of "standard" line or curve.
\fINumSupportedLineWidths\fP	CARD32	Number of supported line or curve widths (a value of 0
		indicates that all line widths, including fractional widths,
		between min and max line width are supported).

\fIMinLineWidth\fP	CARD32	Width (in pixels) of thinnest line or curve that can be drawn.

\fIMaxLineWidth\fP	CARD32	Width (in pixels) of widest line or curve that can be drawn.

\fINominalEdgeWidth\fP	CARD32	Width (in pixels) of "standard" edge.

\fINumSupportedEdgeWidths\fP	CARD32	Number of supported edge widths (a value of 0 indicates that
		all edge widths, including fractional widths, between min and
		max edge width are supported).

\fIMinEdgeWidth\fP	CARD32	Width (in pixels) of thinnest edge that can be drawn.

\fIMaxEdgeWidth\fP	CARD32	Width (in pixels) of widest edge that can be drawn.

\fINominalMarkerSize\fP	CARD32	Largest dimension (either height or width, in pixels) of
		"standard" marker.

\fINumSupportedMarkerSizes\fP	CARD32	Number of supported marker sizes (a value of 0 indicates that
		all marker sizes, including fractional values, between min and
		max marker size are supported).

\fIMinMarkerSize\fP	CARD32	Largest dimension (either height or width, in pixels) of
		smallest marker that may be drawn (this minimum is exclusive
		of the marker type "Dot" which is always drawn as the smallest
		displayable point).

\fIMaxMarkerSize\fP	CARD32	Largest dimension (either height or width, in pixels) of
		largest marker that may be drawn (this maximum is exclusive
		of the marker type "Dot" which is always drawn as the smallest
		displayable point).

\fIChromaticityX\fP	FLOAT	Returns the CIE X chromaticity coefficient for the (properly
		adjusted) display device.

\fIChromaticityY\fP	FLOAT	Returns the CIE Y chromaticity coefficient for the (properly
		adjusted) display device.

\fIChromaticityLuminance\fP	FLOAT	Returns the CIE luminance value for the (properly adjusted)
		display device.

\fIMaxNamesetNames\fP	CARD32	Maximum number of names allowed in a nameset

\fIMaxModelClipPlanes\fP	CARD32	Maximum number of modeling clipping planes that may be defined.

\fITransparencySupported\fP	CARD32	Returns "True" or "False", depending on whether the transmission
		coefficient is utilized in the light source shading computations.

\fIDitheringSupported\fP	CARD32	Returns "True" or "False", depending on whether the dithering hint
		actually causes dithering to occur.

\fIMaxNonAmbientLights\fP	CARD32	Maximum number of non-ambient light sources that may be enabled
		at one time.

\fIMaxNURBOrder\fP	CARD32	Maximum non-uniform rational B-spline order supported.

\fIMaxUPPOrder\fP	CARD32	Maximum uniform parametric polynomial order supported.

\fIMaxTrimCurveOrder\fP	CARD32	Maximum order for trim curves.

\fIRgbBestApproximation\fP	CARD32	Returns a constant indicating whether it is a significant
		performance win if the number of reds/greens/blues is a power
		of two so that pixels can be composited using shifts and adds.

.ta
.Fe
.bp


.AC "Output Commands" 1
.LP
.RU
.LP
This section defines output commands.  Output commands are commands
that are capable of being processed by a renderer or
stored as structure elements.  The format of each of the
commands is listed below.
Output commands may be passed
to the server to be processed immediately by a renderer with the
\fBPEXRenderOutputCommands\fP request.
Output commands may be passed
to the server to be stored in a structure with the
\fBPEXStoreElements\fP request.
Output commands may be retrieved by a client from a structure resource
with the
\fBPEXFetchElements\fP request.
.LP
Output commands are always executed in exactly the same fashion, no
matter whether
they are processed immediately by a renderer or processed as part of
a structure traversal.
In general, when executed, an output command that contains inappropriate or
illegal values is ignored.  However, only the bogus output command is
ignored.  Other output commands in the structure network or output command
stream will be executed if they contain valid data.
.AC "Data Formats" 2
.LP
Each of the requests listed above takes a format word (which is a parameter
of type FORMAT).
This format word contains a specification for floating point format
(type FLOAT_FORMAT) and for direct color format (type COLOR_FORMAT).
For those requests sending data from the client to the server,
this format word is used to indicate to the server the format of any
floating point values or direct color values that are contained in the request.
For those requests requiring data to be sent back to the client,
the format is used to indicate to the server how it should format
the floating point or direct color data in the reply sent back to the client.
.LP
Color values are passed as a flag and a value.  The flag specifies whether
the color is an index value or a direct color value.
PEX servers are required to be able to
deal with indexed colors
and at least one type of direct color.
Indexed colors are specified using an index which is used to obtain
the color from a color lookup table.
Direct colors are specified
directly as RGB, HSV, HLS, or CIE color values.  PEX
servers are free to store direct colors in whatever format they choose, but
they must be capable of converting direct color values back into one
of the supported direct color types when queried by the client.
.LP
After being passed to the server,
floating point and direct color values
may be converted to server-specific formats
before being used by a renderer or stored in structures.
The implication of this is that some precision may be lost if floating
point or direct color values are later
retrieved by the client.
.AC "Output Command Descriptions" 2
.LP
The list below describes the format of the output commands that are supported.
Each output command is a structure of type OUTPUT_COMMAND, which
contains a 16-bit opcode that uniquely defines the output command (as well
as uniquely identifying the structure element if the command is stored
in a structure), a 16-bit size field which specifies the length of the
output command in units of four bytes, and
the data needed to specify the output command.  The high-order bit of
the opcode field is reserved to indicate whether the output command
is one of the standard PEX output commands (high-order bit equals zero)
or a non-standard or proprietary output command (high-order bit equals one).

.Or "Marker type"
.Op marker_type MARKER_TYPE
.IP
When processed by a renderer,
this command will
modify the renderer's \fImarker_type\fP attribute.

.Or "Marker scale"
.Op scale FLOAT
.IP
When processed by a renderer,
this command will
modify the renderer's \fImarker_scale\fP attribute.

.Or "Marker color index"
.Op color TABLE_INDEX
.IP
When processed by a renderer,
this command will
modify the renderer's \fImarker_color\fP attribute,
setting the
color type to \fIIndexed\fP and the color value to the index specified by
\fIcolor\fP.

.Or "Marker color"
.Op color COLOR_SPECIFIER
.IP
When processed by a renderer,
this command will
modify the renderer's \fImarker_color\fP attribute,
setting the
color type and value as specified.
If color type is \fIDirect\fP, the value is interpreted using the color format
word that is passed with the request.

.Or "Marker bundle index"
.Op index TABLE_INDEX
.IP
When processed by a renderer,
this command will
modify the renderer's \fImarker_bundle_index\fP attribute.

.Or "Text font index"
.Op index TABLE_INDEX
.IP
When processed by a renderer,
this command will
modify the renderer's \fItext_font_index\fP attribute.

.Or "Text precision"
.Op precision TEXT_PRECISION
.IP
When processed by a renderer,
this command will
modify the renderer's \fItext_precision\fP attribute.

.Or "Character expansion"
.Op expansion FLOAT
.IP
When processed by a renderer,
this command will
modify the renderer's \fIchar_expansion\fP attribute.

.Or "Character spacing"
.Op spacing FLOAT
.IP
When processed by a renderer,
this command will
modify the renderer's \fIchar_spacing\fP attribute.

.Or "Text color index"
.Op color TABLE_INDEX
.IP
When processed by a renderer,
this command will
modify the renderer's \fItext_color\fP attribute,
setting the
color type to \fIIndexed\fP and the color value to the index specified by
\fIcolor\fP.

.Or "Text color"
.Op color COLOR_SPECIFIER
.IP
When processed by a renderer,
this command will
modify the renderer's \fItext_color\fP attribute,
setting the
color type and value as specified.
If color type is \fIDirect\fP, the value is interpreted using the color format
word that is passed with the request.

.Or "Character height"
.Op height FLOAT
.IP
When processed by a renderer,
this command will
modify the renderer's \fIchar_height\fP attribute.

.Or "Character up vector"
.Op up VECTOR_2D
.IP
When processed by a renderer,
this command will
modify the renderer's \fIchar_up_vector\fP attribute.

.Or "Text path"
.Op path TEXT_PATH
.IP
When processed by a renderer,
this command will
modify the renderer's \fItext_path\fP attribute.

.Or "Text alignment"
.Op alignment TEXT_ALIGNMENT
.IP
When processed by a renderer,
this command will
modify the renderer's
\fItext_alignment\fP attribute.

.Or "Annotation text height"
.Op height FLOAT
.IP
When processed by a renderer,
this command will
modify the renderer's \fIatext_height\fP attribute.

.Or "Annotation text up vector"
.Op up VECTOR_2D
.IP
When processed by a renderer,
this command will
modify the renderer's \fIatext_up_vector\fP attribute.

.Or "Annotation text path"
.Op path TEXT_PATH
.IP
When processed by a renderer,
this command will
modify the renderer's \fIatext_path\fP attribute.

.Or "Annotation text alignment"
.Op alignment TEXT_ALIGNMENT
.IP
When processed by a renderer,
this command will
modify the renderer's
\fIatext_alignment\fP attribute.

.Or "Annotation text style"
.Op index ATEXT_STYLE
.IP
When processed by a renderer,
this command will
modify the renderer's \fIatext_style\fP attribute.

.Or "Text bundle index"
.Op index TABLE_INDEX
.IP
When processed by a renderer,
this command will
modify the renderer's \fItext_bundle_index\fP attribute.

.Or "Line type"
.Op line_type LINE_TYPE
.IP
When processed by a renderer,
this command will
modify the renderer's \fIline_type\fP attribute.

.Or "Line width"
.Op width FLOAT
.IP
When processed by a renderer,
this command will
modify the renderer's \fIline_width\fP attribute.

.Or "Line color index"
.Op color TABLE_INDEX
.IP
When processed by a renderer,
this command will
modify the renderer's \fIline_color\fP attribute,
setting the
color type to \fIIndexed\fP and the color value to the index specified by
\fIcolor\fP.

.Or "Line color"
.Op color COLOR_SPECIFIER
.IP
When processed by a renderer,
this command will
modify the renderer's \fIline_color\fP attribute,
setting the
color type and value as specified.
If color type is \fIDirect\fP, the value is interpreted using the color format
word that is passed with the request.

.Or "Curve approximation"
.Op approx CURVE_APPROX
.IP
When processed by a renderer,
this command will
modify the renderer's \fIcurve_approx\fP
attribute.

.Or "Polyline interpolation method"
.Op polyline_interp POLYLINE_INTERP
.IP
When processed by a renderer,
this command will
modify the renderer's \fIpolyline_interp\fP attribute.

.Or "Line bundle index"
.Op index TABLE_INDEX
.IP
When processed by a renderer,
this command will
modify the renderer's \fIline_bundle_index\fP attribute.

.Or "Surface interior style"
.Op interior_style INTERIOR_STYLE
.IP
When processed by a renderer,
this command will
modify the renderer's \fIinterior_style\fP attribute.

.Or "Surface interior style index"
.Op index TYPE_OR_TABLE_INDEX
.IP
When processed by a renderer,
this command will
modify the renderer's \fIinterior_style_index\fP attribute.

.Or "Surface color index"
.Op color TABLE_INDEX
.IP
When processed by a renderer,
this command will
modify the renderer's \fIsurface_color\fP attribute,
setting the
color type to \fIIndexed\fP and the color value to the index specified by
\fIcolor\fP.

.Or "Surface color"
.Op color COLOR_SPECIFIER
.IP
When processed by a renderer,
this command will
modify the renderer's \fIsurface_color\fP attribute,
setting the
color type and value as specified.
If color type is \fIDirect\fP, the value is interpreted using the color format
word that is passed with the request.

.Or "Surface reflection attributes"
.Op ambient_coef FLOAT
.Op diffuse_coef FLOAT
.Op specular_coef FLOAT
.Op specular_color COLOR_SPECIFIER
.Op specular_conc FLOAT
.Op transmission_coef FLOAT
.IP
When processed by a renderer,
this command will
modify the renderer's
\fIambient_coef\fP, \fIdiffuse_coef\fP,
\fIspecular_coef\fP, \fIspecular_color\fP,
\fIspecular_conc\fP, and \fItransmission_coef\fP
attributes.

.Or "Surface reflection model"
.Op reflection_model REFLECTION_MODEL
.IP
When processed by a renderer,
this command will
modify the renderer's \fIreflection_model\fP attribute.

.Or "Surface interpolation method"
.Op surface_interp SURFACE_INTERP
.IP
When processed by a renderer,
this command will
modify the renderer's \fIsurface_interp\fP attribute.
       
.Or "Backface surface interior style"
.Op interior_style INTERIOR_STYLE
.IP
When processed by a renderer,
this command will
modify the renderer's \fIbf_interior_style\fP attribute.

.Or "Backface surface interior style index"
.Op index TYPE_OR_TABLE_INDEX
.IP
When processed by a renderer,
this command will
modify the renderer's \fIbf_interior_style_index\fP attribute.

.Or "Backface surface color index"
.Op color TABLE_INDEX
.IP
When processed by a renderer,
this command will
modify the renderer's \fIbf_surface_color\fP attribute,
setting the
color type to \fIIndexed\fP and the color value to the index specified by
\fIcolor\fP.

.Or "Backface surface color"
.Op color COLOR_SPECIFIER
.IP
When processed by a renderer,
this command will
modify the renderer's \fIbf_surface_color\fP attribute,
setting the
color type and value as specified.
If color type is \fIDirect\fP, the value is interpreted using the color format
word that is passed with the request.

.Or "Backface surface reflection attributes"
.Op ambient FLOAT
.Op diffuse FLOAT
.Op specular FLOAT
.Op specular_color COLOR_SPECIFIER
.Op specular_conc FLOAT
.Op transmission_coef FLOAT
.IP
When processed by a renderer,
this command will
modify the renderer's
\fIbf_ambient_coef\fP, \fIbf_diffuse_coef\fP,
\fIbf_specular_coef\fP, \fIbf_specular_color\fP,
\fIbf_specular_conc\fP, and \fIbf_transmission_coef\fP
attributes.

.Or "Backface surface reflection model"
.Op reflection_model REFLECTION_MODEL
.IP
When processed by a renderer,
this command will
modify the renderer's \fIbf_reflection_model\fP attribute.

.Or "Backface surface interpolation method"
.Op surface_interp SURFACE_INTERP
.IP
When processed by a renderer,
this command will
modify the renderer's \fIbf_surface_interp\fP attribute.
       
.Or "Surface approximation"
.Op approx SURFACE_APPROX
.IP
When processed by a renderer,
this command will
modify the renderer's \fIsurface_approx\fP
attribute.
       
.Or "Trim curve approximation"
.Op approx CURVE_APPROX
.IP
When processed by a renderer,
this command will
modify the renderer's \fItrim_curve_approx\fP
attribute.

.Or "Facet culling mode"
.Op culling_mode CULL_MODE
.IP
When processed by a renderer,
this command will
modify the renderer's \fIculling_mode\fP attribute.

.Or "Facet distinguish flag"
.Op distinguish BOOLEAN
.IP
When processed by a renderer,
this command will
modify the renderer's \fIdistinguish\fP attribute.

.Or "Normal reorientation mode"
.Op normalflip BOOLEAN
.IP
When processed by a renderer,
this command will
modify the renderer's \fInormalflip\fP attribute.

.Or "Pattern size"
.Op size COORD_2D
.IP
When processed by a renderer,
this command will
modify the renderer's \fIpattern_size\fP attribute.

.Or "Pattern reference point"
.Op point COORD_2D
.IP
When processed by a renderer,
this command will
modify the renderer's \fIpattern_ref_pt\fP attribute.

.Or "Pattern reference point and vectors"
.Op ref_pt COORD_3D
.Op vector1 VECTOR_3D
.Op vector2 VECTOR_3D
.IP
When processed by a renderer,
this command will
modify the renderer's \fIpattern_ref_pt\fP, \fIpattern_ref_vec1\fP,
and \fIpattern_ref_vec2\fP attributes.

.Or "Interior bundle index"
.Op index TABLE_INDEX
.IP
When processed by a renderer,
this command will
modify the renderer's \fIinterior_bundle_index\fP attribute.

.Or "Surface edge flag"
.Op onoff SWITCH
.IP
When processed by a renderer,
this command will
modify the renderer's \fIsurface_edges\fP attribute.

.Or "Surface edge type"
.Op edge_type SURFACE_EDGE_TYPE
.IP
When processed by a renderer,
this command will
modify the renderer's \fIsurface_edge_type\fP attribute.

.Or "Surface edge width"
.Op width FLOAT
.IP
When processed by a renderer,
this command will
modify the renderer's \fIsurface_edge_width\fP attribute.

.Or "Surface edge color index"
.Op color TABLE_INDEX
.IP
When processed by a renderer,
this command will
modify the renderer's \fIsurface_edge_color\fP attribute,
setting the
color type to \fIIndexed\fP and the color value to the index specified by
\fIcolor\fP.

.Or "Surface edge color"
.Op color COLOR_SPECIFIER
.IP
When processed by a renderer,
this command will
modify the renderer's \fIsurface_edge_color\fP attribute,
setting the
color type and value as specified.
If color type is \fIDirect\fP, the value is interpreted using the color format
word that is passed with the request.

.Or "Edge bundle index"
.Op index TABLE_INDEX
.IP
When processed by a renderer,
this command will
modify the renderer's \fIedge_bundle_index\fP attribute.

.Or "Set individual ASF"
.Op attribute ASF_ATTRIBUTE
.Op source ASF_VALUE
.IP
When processed by a renderer,
this command will
modify the specified ASF (aspect source flag) attribute in the
renderer.  Depending on the value of \fIattribute\fP,
one of the following rendering pipeline attributes will be modified:
.ta 1.5i
.DS
\fImarker_type_asf\fP		\fIinterior_style_asf\fP
\fImarker_scale_asf\fP		\fIinterior_style_index_asf\fP
\fImarker_color_asf\fP		\fIsurface_color_asf\fP
\fItext_font_index_asf\fP	\fIsurface_interp_asf\fP
\fItext_prec_asf\fP		\fIreflection_model_asf\fP
\fIchar_expansion_asf\f	\fIreflection_attr_asf\fP
\fIchar_spacing_asf\fP		\fIbf_interior_style_asf\fP
\fItext_color_asf\fP		\fIbf_interior_style_index_asf\fP
\fIline_type_asf\fP		\fIbf_surface_color__asf\fP
\fIline_width_asf\fP		\fIbf_surface_interp_asf\fP
\fIline_color_asf\fP		\fIbf_reflection_model_assf\fP
\fIcurve_approx_asf\fP		\fIbf_reflection_attr_asf\fP
\fIpolyline_interp_asf\fP	\fIsurface_approx_asf\fP
				\fItrim_curve_approx_asf\fP
				\fIsurface_edges_asf\fP
				\fIsurface_edge_type_asf\fP
				\fIsurface_edge_width_asf\fP
				\fIsurface_edge_color_asf\fP
.DE
.ta

.Or "Local transform 3D"
.Op comp_type COMPOSITION
.Op matrix MATRIX
.IP
When processed by a renderer,
this command will
modify the renderer's \fIlocal_transform\fP attribute.
If \fIcomp_type\fP is \fIPreConcatenate\fP, the specified matrix is 
pre-concatenated
to the local model transformation matrix.  If \fIcomp_type\fP is 
\fIPostConcatentate,\fP the specified matrix is post-concatenated to the 
local modeling transform.  If \fIcomp_type\fP is \fIReplace\fP, the
specified matrix replaces the local modeling transform.

.Or "Local transform 2D"
.Op comp_type COMPOSITION
.Op matrix MATRIX_3X3
.IP
When processed by a renderer,
this command will
modify the renderer's \fIlocal_transform\fP attribute.  This command is
identical to \fIlocal transform 3D\fP except that the specified matrix
is a 3 \(mu 3 matrix instead of a 4 \(mu 4 matrix.  Before the concatenation
occurs, the 3 \(mu 3 matrix represented by
.IP
.EQ
left [
    {
    ~~~ pile { a above d above g }
    ~~~ pile { b above e above h }
    ~~~ pile { c above f above j }
    }
    ~~~ right ]
.EN
.sp
will be expanded to a 4 \(mu 4 matrix as follows:
.IP
.EQ
left [
    {
    ~~~ pile { a above d above g }
    ~~~ pile { b above e above h }
    ~~~ pile { c above f above j }
    }
    ~~~ right ] ->
left [
    {
    ~~~ pile { a above d above 0 above g }
    ~~~ pile { b above e above 0 above h }
    ~~~ pile { 0 above 0 above 1 above 0 }
    ~~~ pile { c above f above 0 above j }
    }
    ~~~ right ]
.EN

.Or "Global transform 3D"
.Op matrix MATRIX
.IP
When processed by a renderer,
this command will
modify the renderer's \fIglobal_transform\fP attribute.

.Or "Global transform 2D"
.Op matrix MATRIX_3X3
.IP
When processed by a renderer,
this command will
modify the renderer's \fIglobal_transform\fP attribute.  This command is
identical to \fIglobal transform 3D\fP except that the specified matrix
is a 3 \(mu 3 matrix instead of a 4 \(mu 4 matrix.  Before the concatenation
occurs, the 3 \(mu 3 matrix represented by
.IP
.EQ
left [
    {
    ~~~ pile { a above d above g }
    ~~~ pile { b above e above h }
    ~~~ pile { c above f above j }
    }
    ~~~ right ]
.EN
.sp
will be expanded to a 4 \(mu 4 matrix as follows:
.IP
.EQ
left [
    {
    ~~~ pile { a above d above g }
    ~~~ pile { b above e above h }
    ~~~ pile { c above f above j }
    }
    ~~~ right ] ->
left [
    {
    ~~~ pile { a above d above 0 above g }
    ~~~ pile { b above e above 0 above h }
    ~~~ pile { 0 above 0 above 1 above 0 }
    ~~~ pile { c above f above 0 above j }
    }
    ~~~ right ]
.EN

.Or "Model clip"
.Op onoff SWITCH
.IP
When processed by a renderer,
this command will
modify the renderer's \fImodel_clip\fP attribute.

.Or "Set model clip volume 3D"
.Op operator OPERATOR
.Op halfspaces LISTofHALFSPACE
.IP
When processed by a renderer,
this command will
modify the renderer's \fImodel_clip_volume\fP attribute.
The operator indicated by \fIoperator\fP will be used to combine the
specified list of \fIhalfspaces\fP with the current modeling clipping
volume to form a new modeling clipping volume.  Each halfspace is
defined by a point and a normal in modeling coordinates.
The vector is considered to be a normal to the plane of the bound of
the halfspace and points in the direction of the halfspace,
and the point is considered to be on the plane.
If an operator is specified that is not supported, or if a halfspace
is found to be degenerate, the action specified by the command is ignored.

.Or "Set model clip volume 2D"
.Op operator OPERATOR
.Op halfspaces LISTofHALFSPACE_2D
.IP
When processed by a renderer,
this command will
modify the renderer's \fImodel_clip_volume\fP attribute.
The operator indicated by \fIoperator\fP will be used to combine the
specified list of \fIhalfspaces\fP with the current modeling clipping
volume to form a new modeling clipping volume.  The halfspaces
are specified in modeling coordinates, with the z component of each
point and vector assumed to be zero.
If an operator is specified that is not supported, or if a halfspace
is found to be degenerate, the action specified by the command is ignored.

.Or "Restore model clip volume"
.IP
When processed by a renderer,
this command will
modify the renderer's \fImodel_clip_volume\fP attribute.
The modeling clipping volume will be restored to
the last saved modeling clipping volume.  If there is no saved
modeling clipping volume that can be restored,
the modeling clipping volume is restored to
its default state.

.Or "View index"
.Op index TABLE_INDEX
.IP
When processed by a renderer,
this command will
modify the renderer's \fIview_index\fP attribute.

.Or "Light source state"
.Op enable BITMASK
.Op disable BITMASK
.IP
When processed by a renderer,
this command will
modify the renderer's \fIlight_state\fP attribute.  First, the enable
mask is applied to the current \fIlight_state\fP.  Each set bit in the
\fIenable\fP array will cause the corresponding light source to
be activated.  Then the disable mask is applied.  Each set bit in the
\fIdisable\fP array will cause the corresponding light source to
be deactivated.

.Or "Depth cue index"
.Op index TABLE_INDEX
.IP
When processed by a renderer,
this command will
modify the renderer's \fIdepth_cue_index\fP attribute.

.Or "Pick id       "
.Op pickid CARD32
.IP
When processed by a renderer,
this command will
modify the renderer's \fIpick_id\fP attribute.

.Or "HLHSR identifier"
.Op id CARD32
.IP
When processed by a renderer,
the effect of this command is implementation-dependent.
It is provided for PHIGS compatibility purposes.

.Or "Add names to name set"
.Op names LISTofNAME
.IP
When processed by a renderer,
this command will
add names to the renderer's name set.

.Or "Remove names from name set"
.Op names LISTofNAME
.IP
When processed by a renderer,
this command will
add names to the renderer's name set.

.Or "Execute structure"
.Op s_id STRUCTURE_ID
.IP
When processed by a renderer,
this output command transfers flow-of-control to the specified
structure.  
Processing of output commands
will then commence with the first structure element in the structure
specified by \fIs_id\fP.
When all of the elements in the called
structure have been processed, control will be returned.
When 
this command is executed, all of the rendering pipeline
attribute values in the renderer are saved.  Then,
the current global modeling transform is set to the current composite
modeling transform and the current local modeling matrix is set
to the identity matrix.
When control is returned,
the saved rendering pipeline
attribute values are restored.
If the structure specified by \fIs_id\fP does not exist at the
time the "execute structure" command is processed by a renderer,
the execute structure command is effectively a no-op.

.Or "Label"
.Op label CARD32
.IP
When processed by a renderer,
this output command is a no-op.  Its main usefulness
is when used as a structure element to maintain the specified
\fIlabel\fP as an aid to navigation during structure editing.

.Or "Application data"
.Op data LISTofCARD8
.IP
When processed by a renderer,
this output command is a no-op.  It's main usefulness
is when used as a structure element in order to maintain the specified
client application data.

.Or "GSE"
.Op id CARD32
.Op data LISTofCARD8
.IP
When processed by a renderer, the effect of
this command is implementation-dependent.
Because of floating point and color format discrepancies across
a network interface, it is not anticipated that the GSE will provide
a useful extension mechanism, but
it is provided for PHIGS compatibility purposes.

.Or "Marker 3D"
.Op points LISTofCOORD_3D
.IP
When processed by a renderer,
this command will cause marker primitives to be rendered.
A marker is a geometric primitive with only one geometric attribute -
its position.  
The list \fIpoints\fP contains a list of 
3D coordinates, each of which specifies the position
of a marker in modeling coordinates.
.IP
During the rendering process, the marker's position is transformed
to a position in device coordinates.  A marker has no geometric size,
so geometric transformations will not affect the displayed size of the marker.
The marker's color is transformed only
by the depth-cueing computation (the light-source shading
stage of the rendering pipeline affects only surfaces)
and mapped to a device color.  The method used to clip marker primitives
is implementation-dependent.
.IP
Depending on the setting of the marker attribute ASF values,
the \fImarker_color\fP,
\fImarker_type\fP, and \fImarker_scale\fP attributes are
either obtained directly from the current marker attribute values
or from the \fImarker_bundle_index\fP'th entry in the
renderer's \fImarker_bundle\fP.

.Or "Marker 2D"
.Op points LISTofCOORD_2D
.IP
.2d "marker"

.Or "Text 3D"
.Op origin COORD_3D
.Op vector1 VECTOR_3D
.Op vector2 VECTOR_3D
.Op string STRING
.IP
When processed by a renderer,
this command will cause a text string to be rendered.
The parameter
\fIstring\fP contains the text string to be rendered.
The text string is located on a plane defined by its position and
direction vectors.
The origin of the string is a point in modeling
coordinates indicated by \fIorigin\fP, and the string's
direction is indicated by the direction vectors \fIvector1\fP and
\fIvector2\fP.
\fIVector1\fP defines the positive \fIx\fP-axis of
the text local coordinate system.
\fIVector2\fP defines the positive \fIy\fP-axis of
the text local coordinate system.
If the two vectors are parallel, or if one of the two vectors is
zero length, the values <1,0,0> and <0,1,0> will be used instead.
.IP
Depending on the setting of the text attribute ASF values,
the \fItext_color\fP,
\fItext_precision\fP,
\fIchar_expansion\fP,
\fIchar_spacing\fP, and
\fItext_font_index\fP attributes are
either obtained directly from the current text attribute values or from the
\fItext_bundle_index\fP'th entry in the renderer's
\fItext_bundle\fP.
The
\fIchar_height\fP,
\fIchar_up_vector\fP,
\fItext_path\fP, and
\fItext_alignment\fP attributes
are also used when drawing the text primitive.
An attempt is made to render the text string as accurately
as possible with the font named by the current \fItext_font_index\fP.
The directions specified by
\fIchar_up_vector\fP and \fItext_path\fP
will be relative to the text local coordinate system.
.IP
During the rendering process, each string's position is transformed
to a position in device coordinates.  The string's color is transformed 
only
by the depth-cueing computation (the light-source shading
stage of the rendering pipeline affects only surfaces)
and mapped to a device color.  
The text string is clipped depending on the current text precision value.
If the text precision is \fIString\fP, clipping is done in an
implementation-dependent fashion.
If the text precision is \fIChar\fP, clipping is done on at least a
character-by-character basis.
If the text precision is \fIStroke\fP, clipping is performed at the clipping
boundaries for each character.

.Or "Text 2D"
.Op origin COORD_2D
.Op string STRING
.IP
.2d "text"

.Or "Annotation text 3D"
.Op origin COORD_3D
.Op offset COORD_3D
.Op string STRING
.IP
When processed by a renderer,
this command will cause an annotation text string to be rendered.
The parameter
\fIstring\fP contains the text string to be rendered.
The origin of the string is a point in modeling
coordinates indicated by \fIorigin\fP.
An offset value in normalized projection coordinates is specified
by \fIoffset\fP.
The point at which the annotation text string is to be placed is
called the annotation point, and is
computed by adding \fIoffset\fP to the
transformed \fIorigin\fP point.
The \fIz\fP-component of the annotation point specifies the
the \fIx-y\fP plane in normalized projection coordinate space on
which the annotation text string will be placed.
.IP
Depending on the setting of the text attribute ASF values,
the \fItext_color\fP,
\fItext_precision\fP,
\fIchar_expansion\fP,
\fIchar_spacing\fP, and
\fItext_font_index\fP attributes are
either obtained directly from the current text attribute values or from the
\fItext_bundle_index\fP'th entry in the renderer's
\fItext_bundle\fP.
The
\fIatext_height\fP,
\fIatext_path\fP,
\fIatext_h_alignment\fP,
\fIatext_v_alignment\fP,
\fIatext_up_vector\fP,
\fIatext_style\fP,
attributes are also used when rendering the text string.
.IP
The annotation text string's color is transformed 
only
by the depth-cueing computation (the light-source shading
stage of the rendering pipeline affects only surfaces)
and mapped to a device color.  
The entire annotation text primitive is clipped if \fIorigin\fP is clipped.  If
\fIorigin\fP is not clipped, 
the annotation text will be clipped
according to text clipping rules and the connection line, if present,
will be clipped according to polyline clipping rules, except that
modeling clipping will be ignored.

.Or "Annotation text 2D"
.Op origin COORD_2D
.Op offset COORD_2D
.Op string STRING
.IP
.2d "annotation text"

.Or "Polyline 3D"
.Op vertices LISTofCOORD_3D
.IP
When processed by a renderer,
this command will cause a polyline to be rendered.
The polyline is defined by the list of vertices that are specified
in \fIvertices\fP, each of which is a coordinate in the modeling
coordinate system.
The vertices are joined together
by line segments.  The first vertex of a polyline is connected to the
second, the second connected to the third, and so on.  The last vertex
is \fInot\fP connected to the first.
.IP
Depending on the setting of the line attribute ASF values,
\fIline_color\fP,
\fIline_type\fP, and
\fIline_width\fP attributes are
either obtained directly from the current line attribute values or from the
\fIline_bundle_index\fP'th entry in the renderer's
\fIline_bundle\fP.
.IP
Polylines have no geometric width,
only length, so transformations will affect only the displayed length
of a polyline.
The polyline colors are transformed only
by the depth-cueing computation (the light-source shading
stage of the rendering pipeline affects only surfaces)
and mapped to device colors.  
Polylines are not displayed if they are
outside the currently defined clipping volume.
Polylines that cross the
clipping volume are clipped, and only the portion(s) inside the clipping
volume is (are) displayed.
.IP
A polyline with less than two vertices is considered degenerate and
is treated in an implementation-dependent manner.

.Or "Polyline 2D"
.Op vertices LISTofCOORD_2D
.IP
.2d "polyline"

.Or "Polyline set 3D with data"
.Op color_type COLOR_TYPE
.Op vert_attributes BITMASK
.Op vertices LISTofLISTofVERTEX
.IP
When processed by a renderer,
this command will cause a series of polylines to be rendered.
The behavior of this primitive is identical to that of the
3D polyline primitive, except that multiple polylines can be drawn,
and additional information can be specified at each polyline vertex.
Color values that are passed will either be \fIIndexed\fP or \fIDirect\fP,
depending on \fIcolor_type\fP.
The parameter \fIvert_attributes\fP indicates the attributes which are
specified at each polyline vertex.  The components of the vertex attributes
bitmask are, in order:
.DS
	color		COLOR
.DE
If any of the attribute bits is set, the corresponding attributes
must be present for each vertex, and they must
be passed after the coordinate data for each vertex in the
order that they appear in the list above.
.IP
If color values are passed per vertex, they are considered to be part
of the primitive and are used instead of the \fIline_color\fP attribute.
In addition, the use of per-vertex colors is affected by the
\fIpolyline_interp\fP attribute, which is obtained directly
from the \fIpolyline_interp\fP value if the
\fIpolyline_interp_asf\fP attribute is set to \fIIndividual\fP or from the
\fIline_bundle_index\fP'th entry in the renderer's \fIline_bundle\fP.
The \fIpolyline_interp\fP attribute defines how color values between
the vertices are to be computed.

.Or "Parametric curve"
.Op basis CURVE_BASIS
.Op order CARD16
.Op type COORD_TYPE
.Op points LISTofCOORD
.IP
When processed by a renderer,
this command will cause a parametric polynomial
curve to be rendered.
The renderer will draw the
piecewise parametric
curve as a function of uniform samples in the parametric coordinate space.  
The curve shape is specified as a list of control points in the 
modeling coordinate system. 
.IP
The \fItype\fP parameter specifies
whether the curve is \fIRational\fP
or \fINonRational\fP.
If the \fItype\fP is \fIRational\fP, then the
point list must be provided as homogeneous modeling coordinates
(COORD_4D), otherwise 
the point list must be provided as non-homogeneous modeling
coordinates (COORD_3D). 
.IP
\fIOrder\fP specifies the order of the polynomial expression, and
\fIbasis\fP specifies the basis function.
The registered curve basis functions
are described in the "Extension Information"
section under the discussion of enumerated types.
.IP
Depending on the setting of the line attribute ASF values, the
\fIline_color\fP,
\fIline_type\fP,
\fIline_width\fP, and
\fIcurve_approx\fP attributes are
either obtained directly from the current line attribute values or from the
\fIline_bundle_index\fP'th entry in the renderer's
\fIline_bundle\fP.

.Or "Non-uniform B-spline curve" 3
.Op order CARD16
.Op type COORD_TYPE
.Op tmin FLOAT
.Op tmax FLOAT
.Op knots LISTofFLOAT
.Op points LISTofCOORD
.IP
When processed by a renderer,
this command will cause a non-uniform B-spline
curve to be rendered.
The \fIorder\fP is specified as a positive integer.
The spline shape is specified using
a list of knots in the parametric coordinate 
space, plus a list of control points that are specified
in modeling coordinates.
In general, the number of control points must be at least as large as
the order.  The number of control points plus the spline order must
equal the number of knots.
The \fIknots\fP sequence must form
a non-decreasing sequence of numbers.
.IP
The \fItype\fP parameter specifies whether the curve is \fIRational\fP
or \fINonRational\fP.
If the \fItype\fP is \fIRational\fP, then
the point list must be provided as homogeneous modeling coordinates (COORD_4D),
otherwise the the point list must be provided as non-homogeneous
modeling coordinates (COORD_3D). 
.IP
The parameter range values \fItmin\fP and \fItmax\fP specify the range
over which the B-spline curve is evaluated.  \fITmin\fP must be less than
\fItmax\fP, \fItmin\fP must be greater than or equal to the \fIorder\fP'th
knot value, and \fItmax\fP must be less than or equal to the
(k+1-\fIorder\fP)'th knot value, where k is the number of knots.
.IP
Depending on the setting of the line attribute ASF values,
\fIline_color\fP,
\fIline_type\fP,
\fIline_width\fP, and
\fIcurve_approx\fP attributes are
either obtained directly from the current line attribute values or from the
\fIline_bundle_index\fP'th entry in the renderer's
\fIline_bundle\fP.

.Or "Fill area 3D"
.Op shape SHAPE
.Op ignore_edges BOOLEAN
.Op vertices LISTofCOORD_3D
.IP
When processed by a renderer,
this command will cause a fill area primitive to be rendered.
A fill area is defined by a list of vertices which are to be joined together
to form a planar surface.  (Fill areas are not strictly
required to be planar, but strange shading artifacts can occur if
a fill area is not planar or nearly so.)
The first vertex of a fill area is connected to the
second, the second connected to the third, and so on.  The last vertex
is implicitly connected to the first.
.IP
During the rendering process, the fill area vertices are transformed
to positions in device coordinates.
The surface colors are transformed
by the light source shading computation (which utilizes the interior style
and the reflectance model) and are further modified by the
depth-cueing computation
and mapped to device colors.  
Fill areas are not displayed if they are
outside the currently-defined clipping volume.
Fill areas that cross the
clipping volume are clipped, and only the portion(s) inside the clipping
volume is (are) displayed.
.IP
A fill area with less than three vertices is considered degenerate and
is treated in an implementation-dependent manner.  A fill area can
cross over itself to create a complex shape.  The odd-even rule is
used for determining the points that lie in the interior of a fill area.
The \fIshape\fP parameter is passed as a hint as to the type of fill
area that is defined by the \fIvertices\fP.
A shape hint of \fIUnknown\fP means that nothing is known about the
shape of the fill area.  A shape of \fIComplex\fP means that the
fill area edges may self-intersect.  A shape of \fINonConvex\fP means
that the edges do not self-intersect, but the fill area is not wholly
convex.  \fIConvex\fP means that all of the interior angles of the fill
area are convex.  Fill areas that are of a higher complexity than indicated
by their shape hint are drawn in an implementation-dependent manner.
PEX server extensions may ignore the shape
hint and treat all fill area primitives
as shape \fIUnknown\fP.
The \fIignore_edges\fP parameter specifies
whether or not surface edge attributes are to be applied to the fill
area primitives.  If it is \fITrue\fP, no surface edges will ever be
drawn for the \fIfill area\fP.  If \fIFalse\fP, surface edges will be
drawn using the current surface edge attributes if the surface edge flag
is \fIOn\fP.
Depending on the setting of the surface edge attribute ASF values, the
\fIsurface_edges\fP,
\fIsurface_edge_color\fP,
\fIsurface_edge_type\fP, and 
\fIsurface_edge_width\fP attributes are
either obtained directly from the current surface edge
attribute values or from the
\fIedge_bundle_index\fP'th entry in the renderer's
\fIedge_bundle\fP.
.IP
Depending on the setting of the surface attribute ASF values, the
\fIsurface_color\fP,
\fIinterior_style\fP,
\fIinterior_style_index\fP,
\fIsurface_interp\fP, and
\fIreflection_model\fP attributes are
either obtained directly from the current surface attribute values or from the
\fIinterior_bundle_index\fP'th entry in the renderer's
\fIinterior_bundle\fP.
If, when rendered, the fill area is determined to be front-facing with
respect to the point of view, the
\fIsurface_color\fP (obtained as previously described),
\fIambient_coef\fP,
\fIdiffuse_coef\fP,
\fIspecular_coef\fP,
\fIspecular_color\fP,
\fIspecular_conc\fP, and
\fItransmission_coef\fP attributes are used to compute the color(s) of the
fill area.
If the fill area is determined to be back-facing with
respect to the point of view, the
\fIbf_surface_color\fP,
\fIbf_ambient_coef\fP,
\fIbf_diffuse_coef\fP,
\fIbf_specular_coef\fP,
\fIbf_specular_color\fP,
\fIbf_specular_conc\fP,
\fIbf_transmission_coef\fP attributes are used instead.
Regardless of the orientation of the fill area, if the \fIinterior_style\fP
is \fIPattern\fP, the
\fIpattern_size\fP,
\fIpattern_ref_pt\fP,
\fIpattern_ref_vec1\fP, and
\fIpattern_ref_vec2\fP attributes may be used to
pattern the fill area.

.Or "Fill area 2D"
.Op shape SHAPE
.Op ignore_edges BOOLEAN
.Op vertices LISTofCOORD_2D
.IP
.2d "fill area"

.Or "Fill area 3D with data"
.Op shape SHAPE
.Op ignore_edges BOOLEAN
.Op color_type COLOR_TYPE
.Op facet_attributes BITMASK
.Op vert_attributes BITMASK
.Op facet FACET
.IP
When processed by a renderer,
this command will cause a fill area to be rendered.
The behavior of this primitive is identical to that of the
3D fill area primitive, except that
additional information can be specified
for the fill area itself and for
each vertex.
Color values that are passed will either be \fIIndexed\fP or \fIDirect\fP,
depending on \fIcolor_type\fP.
.IP
The parameter \fIfacet_attributes\fP indicates the attributes which are
specified for the fill area.  The components of the facet attributes
bitmask are, in order:
.DS
	color		COLOR
	normal	VECTOR_3D
.DE
If any of the attribute bits is set, the corresponding attribute
must be present in the data that defines the fill area facet and they
must be passed in the
order that they appear in the list above.  If a color value is
passed per facet, it is taken to be the intrinsic color of the front face
of the facet.  If a normal is passed per facet, it is taken to be
the normal to the facet.  (Normals need not be normalized.)
.IP
The parameter \fIvert_attributes\fP specifies the attributes which are
specified at each fill area vertex.  The components of the vertex attributes
bitmask are, in order:
.DS
	color		COLOR
	normal	VECTOR_3D
.DE
If any of the attribute bits is set, the corresponding attributes
must be present for each vertex, and they must
be passed after the coordinate data for each vertex in the
order that they appear in the list above.
.IP
If color values are passed per vertex, they are considered to be part
of the primitive and are used instead of the \fIsurface_color\fP attribute.
If normals are passed per vertex, they are taken to be
the normals at the vertices of the fill area.
In addition, the use of per-vertex colors is affected by the
\fIsurface_interp\fP attribute, which is obtained directly
from the \fIsurface_interp\fP value if the
\fIsurface_interp_asf\fP attribute is set to \fIIndividual\fP or from the
\fIinterior_bundle_index\fP'th entry in the renderer's
\fIinterior_bundle\fP.
The \fIsurface_interp\fP attribute defines how color values between
the vertices are to be computed.
.IP
The \fIshape\fP parameter is passed as a hint as to the type of fill
area that is defined by the vertices.
A shape hint of \fIUnknown\fP means that nothing is known about the
shape of the fill area.  A shape of \fIComplex\fP means that the
fill area edges may self-intersect.  A shape of \fINonConvex\fP means
that the edges do not self-intersect, but the fill area is not wholly
convex.  \fIConvex\fP means that all of the interior angles of the fill
area are convex.  Fill areas that are of a higher complexity than indicated
by their shape hint are drawn in an implementation-dependent manner.
PEX server extensions may ignore the shape
hint and treat all fill area primitives
as shape \fIUnknown\fP.
The \fIignore_edges\fP parameter specifies
whether or not surface edge attributes are to be applied to the fill
area primitives.  If it is \fITrue\fP, no surface edges will ever be
drawn for the \fIfill area\fP.  If \fIFalse\fP, surface edges will be
drawn using the current surface edge attributes if the surface edge flag
is \fIOn\fP.


.Or "Fill area set 3D"
.Op shape SHAPE
.Op ignore_edges BOOLEAN
.Op vertices LISTofLISTofCOORD_3D
.IP
When processed by a renderer,
this command will cause a fill area set primitive to
be drawn.  This type of primitive is essentially a set of fill area
primitives.  Together, this set of fill areas defines a polygon with
islands or holes.  The \fIshape\fP and \fIignore_edges\fP
parameters will be applied to all of
the fill areas in the fill area set.

.Or "Fill area set 2D"
.Op shape SHAPE
.Op ignore_edges BOOLEAN
.Op vertices LISTofLISTofCOORD_2D
.IP
.2d "fill area set"

.Or "Fill area set 3D with data"
.Op shape SHAPE
.Op ignore_edges BOOLEAN
.Op color_type COLOR_TYPE
.Op facet_attributes BITMASK
.Op vert_attributes BITMASK
.Op facet_data OPT_DATA
.Op vertices LISTofLISTofVERTEX
.IP
When processed by a renderer,
this command will cause a fill area set to be rendered.
The behavior of this primitive is identical to that of the
3D fill area set primitive, except that
additional information can be specified
for of the fill area set, for each edge, and for
each vertex.
Color values that are passed will either be \fIIndexed\fP or \fIDirect\fP,
depending on \fIcolor_type\fP.
.IP
The parameter \fIfacet_attributes\fP indicates the attributes which are
specified in the \fIfacet_data\fP parameter.
The components of the facet attributes bitmask are, in order:
.DS
	color		COLOR
	normal	VECTOR_3D
.DE
If any of the attribute bits is set, the corresponding attributes
must be present in the \fIfacet_data\fP parameter and
must be passed in the
order that they appear in the list above.  If a color value is
passed as part of \fIfacet_data\fP, it is taken to be the intrinsic color
of the front face of the fill area set.
.IP
The parameter \fIvert_attributes\fP specifies the attributes which are
specified at each fill area set vertex.  The components of the vertex
attributes bitmask are, in order:
.DS
	color		COLOR
	normal	VECTOR_3D
	edges		SWITCH
.DE
If any of the attribute bits is set, the corresponding attributes
must be present for each vertex, and they must
be passed after the coordinate data for each vertex in the
order that they appear in the list above.
.IP
If color values are passed as part of \fIfacet_data\fP or as part of the
\fIvertices\fP list, they are considered to be part
of the primitive and are used instead of the \fIsurface_color\fP attribute.
If normals are passed per vertex, they are taken to be
the normals at the vertices of the fill area.
If surface edge flags are specified per vertex, each flag specifies
whether to draw the edge from the vertex with which the flag is specified
to the next vertex.  (E.g., for a facet with four vertices, the edge
flag associated with vertex #1 indicates whether to draw edge #1-#2,
edge flag #2 specifies edge #2-#3, edge flag #3 specifies edge #3-#4,
and edge flag #4 specifies edge #4-#1.)  Surface edges are always drawn
with the surface edge color, never with per facet or per vertex colors.
.IP
In addition, the use of per-vertex colors is affected by the
\fIsurface_interp\fP attribute, which is obtained directly
from the \fIsurface_interp\fP value if the
\fIsurface_interp_asf\fP attribute is set to \fIIndividual\fP or from the
\fIinterior_bundle_index\fP'th entry in the renderer's
\fIinterior_bundle\fP.
The \fIsurface_interp\fP attribute defines how color values between
the vertices are to be computed.

.Or "Triangle strip"
.Op color_type COLOR_TYPE
.Op facet_attributes BITMASK
.Op vert_attributes BITMASK
.Op facet_data LISTofOPT_DATA
.Op vertices LISTofVERTEX
.IP
When processed by a renderer,
this command will cause a triangle strip primitive to
be drawn.
Color values that are passed will either be \fIIndexed\fP or \fIDirect\fP,
depending on \fIcolor_type\fP.
The parameter \fIfacet_attributes\fP indicates the attributes which are
specified for each facet of the triangular strip.
The components of the facet attributes bitmask are, in order:
.DS
	color		COLOR
	normal	VECTOR_3D
.DE
If any of the attribute bits is set, the corresponding attribute
must be present in \fIfacet_data\fP, which is
the data that defines each triangular facet.
The attributes that are passed in this way must be passed in the
order that they appear in the list above.  If a color value is
passed per facet, it is taken to be the intrinsic color of the front face
of the facet.  If a normal is passed per facet, it is taken to be
the normal to the facet.  (Normals need not be normalized.)
There will be n-2 entries in the \fIfacet_data\fP list, where n is
the number of entries in the \fIvertices\fP list.
.IP
The parameter \fIvert_attributes\fP specifies the attributes which are
specified at each triangle strip vertex.  The components of the vertex
attributes bitmask are, in order:
.DS
	color		COLOR
	normal	VECTOR_3D
.DE
If any of the attribute bits is set, the corresponding attribute
must be present for each vertex, and it must
be passed after the coordinate data for each vertex.  The
attributes that are passed in this way must be passed in the
order that they appear in the list above.
.IP
If color values are passed per vertex, they are considered to be part
of the primitive and are used instead of the \fIsurface_color\fP attribute.
If normals are passed per vertex, they are taken to be
the normals at the vertices of the facet.
.IP
The triangular strip is created
from the vertex array.  The strip is composed
of n-2 triangles, where n is the number of vertices.  The first triangle
is formed from the first three vertices in the list, the second triangle
is formed by the second through the fourth vertices in the list, etc., up
to the last triangle, which is formed by the last three vertices in the
list.  A strip with less than three vertices is considered degenerate
and is treated in an implementation-dependent manner.
.IP
All attributes that affect the representation of fill area sets also
affect the representation of the triangle strip primitive.

.Or "Quadrilateral mesh"
.Op color_type COLOR_TYPE
.Op m_pts CARD16
.Op n_pts CARD16
.Op facet_attributes BITMASK
.Op vert_attributes BITMASK
.Op facet_data LISTofOPT_DATA
.Op vertices LISTofVERTEX
.IP
When processed by a renderer,
this command will cause a quadrilateral mesh primitive
to be rendered.
Color values that are passed will either be \fIIndexed\fP or \fIDirect\fP,
depending on \fIcolor_type\fP.
The parameter \fIfacet_attributes\fP indicates the attributes which are
specified for each facet of the quadrilateral mesh.
The components of the facet attributes bitmask are, in order:
.DS
	color		COLOR
	normal	VECTOR_3D
.DE
If any of the attribute bits is set, the corresponding attribute
must be present in \fIfacet_data\fP, which is
the data that defines each quadrilateral facet.
The attributes that are passed in this way must be passed in the
order that they appear in the list above.  If a color value is
passed per facet, it is taken to be the intrinsic color of the front face
of the facet.  If a normal is passed per facet, it is taken to be
the normal to the facet.  (Normals need not be normalized.)
.IP
The parameter \fIvert_attributes\fP specifies the attributes which are
specified at each quadrilateral mesh vertex.  The components of the vertex
attributes bitmask are, in order:
.DS
	color		COLOR
	normal	VECTOR_3D
.DE
If any of the attribute bits is set, the corresponding attribute
must be present for each vertex, and it must
be passed after the coordinate data for each vertex.  The
attributes that are passed in this way must be passed in the
order that they appear in the list above.
.IP
If color values are passed per vertex, they are considered to be part
of the primitive and are used instead of the \fIsurface_color\fP attribute.
If normals are passed per vertex, they are taken to be
the normals at the vertices of the facet.
.IP
The surface will be created
from the vertex array.  The
(ith,jth), (i+1th,jth), (i+1th,j+1th) and (ith,j+1th) vertices are connected
to create a single facet. 
Adjacent vertices are interconnected until the entire
facet network is processed.
It is allowable for the boundary of a single facet to 
not reside in a single plane.  The treatment of the vertex attributes
in this case is implementation-dependent.  
If either array dimension is zero, the treatment of
the primitive is implementation-dependent.
.IP
All attributes that affect the representation of fill area sets also
affect the representation the quadrilateral mesh primitive.

.Or "Indexed polygons"
.Op shape SHAPE
.Op color_type COLOR_TYPE
.Op facet_attributes BITMASK
.Op vert_attributes BITMASK
.Op edge_attributes BITMASK
.Op facet_counts LISTofCARD16
.Op facet_data LISTofOPT_DATA
.Op edge_data LISTofVERTEX_INDEX
.Op vertices LISTofVERTEX
.IP
When processed by a renderer,
this command will
draw a set of polygons that are connected:  polygons may share geometry
and attribute information at vertices.  This request is provided to save
space and allow increased performance for a very common type of surface.
Shading calculations and transformations may need only be performed once
per shared vertex instead of once for every polygon that shares the vertex.
Similarly, data can be transmitted across the network once per unique
vertex instead of once for every polygon sharing the vertex.
The \fIshape\fP parameter is passed as a hint as to the type of polygons
that comprise the primitive.
A shape hint of \fIUnknown\fP means that nothing is known about the
shape of the constituent polygons.  A shape of \fIComplex\fP means that the
some polygons may have edges that self-intersect.
A shape of \fINonConvex\fP means that none of the polygons
have edges that self-intersect, but some may not wholly
convex.  \fIConvex\fP means that all of the interior angles of all of
the polygons are convex.
Polygons that are of a higher complexity than indicated
by their shape hint are drawn in an implementation-dependent manner.
PEX server extensions may ignore the shape
hint and treat all constituent polygons
as shape \fIUnknown\fP.
Color values that are passed will either be \fIIndexed\fP or \fIDirect\fP,
depending on \fIcolor_type\fP.
.IP
The parameter \fIfacet_attributes\fP indicates the attributes which are
specified for each facet of the indexed polygon.
The components of the facet attributes bitmask are, in order:
.DS
	color		COLOR
	normal	VECTOR_3D
.DE
If any of the attribute bits is set, the corresponding attribute
must be present in \fIfacet_data\fP, which contains the per-facet data
for each facet.
The attributes that are passed in this way must be passed in the
order that they appear in the list above.  If a color value is
passed per facet, it is taken to be the intrinsic color of the front face
of the facet.  If a normal is passed per facet, it is taken to be
the normal to the facet.  (Normals need not be normalized.)
.IP
The parameter \fIvert_attributes\fP specifies the attributes which are
specified at each indexed polygon vertex.  The components of the vertex
attributes bitmask are, in order:
.DS
	color		COLOR
	normal	VECTOR_3D
.DE
If any of the attribute bits is set, the corresponding attribute
must be present for each vertex in the \fIvertices\fP list, and it must
be passed after the coordinate data for each vertex.  The
attributes that are passed in this way must be passed in the
order that they appear in the list above.
If color values are passed per vertex, they are considered to be part
of the primitive and are used instead of the \fIsurface_color\fP attribute.
If normals are passed per vertex, they are taken to be
the normal at the indicated vertex, and will be used by all facets that
share the vertex.
.IP
The facets of the primitive are defined using the \fIfacet_counts\fP and
\fIedge_data\fP arrays.
The number of vertices in the first polygon is contained as the first
entry in the \fIfacet_count\fP array.  If this number is \fIn\fP, then
the first \fIn\fP entries in the \fIedge_data\fP array are used to
determine the vertices of the first polygon.
The number of vertices in the second polygon is contained as the second
entry in the \fIfacet_count\fP array, and if this number is \fIn\fP, then
the next \fIn\fP entries in the \fIedge_data\fP array are used to
determine the vertices of the second polygon.  Thus, the sum of the
values in the \fIfacet_count\fP array should be the same as the number
of entries in the \fIedge_data\fP array.
.IP
Optional "per-facet" data is passed in the \fIfacet_data\fP parameter.
This list contains one entry for each polygon, so it is the same length
as the \fIfacet_counts\fP array.  If \fIfacet_attributes\fP is null,
the \fIfacet_data\fP list will be null as well.  Otherwise, each entry
in the \fIfacet_data\fP array will
contain a color, a normal, or a color and a normal (in that order),
depending on the value of the \fIfacet_attributes\fP parameter.
.IP
Vertices are numbered indexed starting from zero (i.e., the first vertex
is referenced as vertex 0).
If an out-of-range vertex index is encountered
in the connection list, the vertex will be skipped and a Value error
will be generated.
.IP
The parameter \fIedge_attributes\fP specifies the attributes that are
specified at each indexed polygon edge.  The components of the attributes
bitmask are, in order:
.DS
	edges	SWITCH
.DE
If any of the attribute bits is set, the corresponding attribute
must be present for each edge in the connection list \fIedge_data\fP.
Therefore, each entry in \fIedge_data\fP consists of an index into
the vertex array, and an optional edge switch.
If surface edge flags are specified, each flag specifies
whether to draw the edge from the vertex with which the flag is specified
to the next vertex.  (E.g., for a facet with four vertices, the edge
flag associated with vertex #1 indicates whether to draw edge #1-#2,
edge flag #2 specifies edge #2-#3, edge flag #3 specifies edge #3-#4,
and edge flag #4 specifies edge #4-#1.)  Surface edges are always drawn
with the surface edge color, never with per facet or per vertex colors.
.IP
All attributes that affect the representation of fill area sets also
affect the representation of the indexed polygon primitive.

.Or "Parametric polynomial surface"
.Op basis CURVE_BASIS
.Op type COORD_TYPE
.Op u_order CARD16
.Op v_order CARD16
.Op points LISTofCOORD
.IP
When processed by a renderer,
this command will draw a parametric polynomial surface.
It generates the parametric surface as a function of
the parametric variables u and v.
The surface shape is specified as a mesh of control points in the
modeling coordinate system.
.IP
The \fItype\fP parameter specifies whether the surface is \fIRational\fP
or \fINonRational\fP.
If the \fItype\fP is \fIRational\fP, then
the point list must be provided as homogeneous modeling coordinates (COORD_4D),
otherwise 
the point list must be provided as non-homogeneous modeling coordinates
(COORD_3D). 
.IP
The \fIu_order\fP and \fIv_order\fP parameters specify the order
of the polynomial 
expression, and the \fIbasis\fP parameter specifies the basis function.
The registered surface basis functions
are described in the "Extension Information"
section under the discussion of enumerated types.
.IP
All attributes that affect the representation of fill area sets also
affect the representation of the parametric polynomial surface primitive.

.Or "Non-uniform B-spline surface" 3
.Op type COORD_TYPE
.Op u_order CARD16
.Op v_order CARD16
.Op umin FLOAT
.Op umax FLOAT
.Op vmin FLOAT
.Op vmax FLOAT
.Op u_knots LISTofFLOAT
.Op v_knots LISTofFLOAT
.Op points LISTofCOORD
.Op trim_curves LISTofLISTofTRIM_CURVE
.IP
When processed by a renderer,
this command will draw a non-uniform B-spline surface.
It generates the spline surface as a function of
the parametric variables u and v.  \fIU_order\fP and \fIv_order\fP
indicate the order of the parametric variables and 
are specified as positive integers.
The spline shape is specified using
two lists of knots in the parametric coordinate 
space, plus an array of control points that are specified
in modeling coordinates.
The \fIu_knots\fP sequence and the \fIv_knots\fP sequence must each form
a non-decreasing sequence of numbers.
.IP
The parameter range values \fIumin, umax, vmin,\fP and \fIvmax\fP specify
the range over which the B-spline surface is evaluated, and \fIumin\fP must
be less than \fIumax\fP and \fIvmin\fP must be less than \fIvmax\fP.
For the \fIu_knots\fP sequence,
\fIumin\fP must be greater than or equal to the \fIu_order\fP'th knot value,
and \fIumax\fP must be less than or equal to the (k+1-\fIu_order\fP)'th knot
value, where k is the number of knots in the \fIu_knots\fP sequence.
Similarly, for the \fIv_knots\fP sequence,
\fIvmin\fP must be greater than or equal to the \fIv_order\fP'th knot value,
and \fIvmax\fP must be less than or equal to the (j+1-\fIv_order\fP)'th knot
value, where j is the number of knots in the \fIv_knots\fP sequence.
.IP
The \fItype\fP parameter specifies whether the surface is \fIRational\fP
or \fINonRational\fP.
If the \fIsurface_type\fP is \fIRational\fP, then
the point list must be provided as homogeneous modeling coordinates (COORD_4D),
otherwise the point list must be provided as non-homogeneous
modeling coordinates (COORD_3D). 
.IP
In addition to the parametric bounds, a list of
trimming loops may be specified.  A trimming loop is a list of TRIM_CURVE.
Trimming loops serve to further restrict the region in 
parametric coordinate space over which the 
B-spline surface is to be evaluated.
When no trimming loops are
specified, the rectangular parameter limits of the surface are rendered
as the edges of the surface based on the edge flag attribute.
Each trimming loop is defined as
a list of one or more B-spline trimming
curve segments that are connected head-to-tail.
The list must be explicitly closed, so that the tail of the last B-spline curve 
segment joins the head of the first B-spline curve 
segment in each trimming loop.
Each B-spline curve
segment is parameterized independently.  If there is a floating point
inaccuracy in closure or in head-to-tail connectivity between B-spline curve
segments, closure or connectivity will be assumed.
B-spline curve segments for trimming loops are defined in the
parameter space of the surface and may not go outside the parameter
space of the surface.
Each separate B-spline curve segment must not
intersect itself.  The B-spline curve segments in a trimming loop,
as a collection, also must not intersect
themselves, except for the joining at the endpoints.
.IP
Each B-spline curve segment has a visibility flag that controls its visibility
for the purposes of surface edge display.  Depending on the settings of
a renderer's surface edge attributes and interior style, and the visibility
flags associated with trim curves, the B-spline curve segments in trimming
loops may be drawn as surface edges.
.IP
All attributes that affect the representation of fill area sets also
affect the representation of the non-uniform B-spline surface primitive.
In addition, the \fIsurface_approx\fP and \fItrim_curve_approx\fP attributes
are used to determine how to approximate the B-spline surface.

.Or "Cell array 3D"
.Op point1 COORD_3D
.Op point2 COORD_3D
.Op point3 COORD_3D
.Op dx CARD32
.Op dy CARD32
.Op colors LISTofTABLE_INDEX
.IP
When processed by a renderer,
this command will cause a cell array primitive to be rendered.
Color values that are passed will be of type \fIIndexed\fP.
A cell array is a parallelogram of equal-sized cells, each of which is
a parallelogram and has a single color.
Each cell has a width defined by:
.DS C
width = sqrt((point1.x - point2.x)**2 + (point1.y - point2.y)**2 + (point1.z - point2.z)**2) / dx
.DE
.IP
and a height defined by:
.DS C
height = sqrt((point1.x - point3.x)**2 + (point1.y - point3.y)**2 + (point1.z - point3.z)**2) / dy
.DE
The colors are specified in a one-dimensional array of size \fIdx * dy\fP.
The color of each cell is specified by the index of the corresponding
element in the \fIcolors\fP array.
Colors are stored in this array by rows, that is, the column number varies
fastest as colors are stored into the array.  The first color in the
array is the color at the cell at the corner of \fIpoint1\fP, and subsequent
colors represent the colors of cells proceeding to to \fIpoint2\fP.

.Or "Cell array 2D"
.Op color_type COLOR_TYPE
.Op point1 COORD_2D
.Op point2 COORD_2D
.Op dx CARD32
.Op dy CARD32
.Op colors LISTofCOLOR
.IP
.2d "cell array"
In addition, the cell array is defined by two points which define a
rectangle that is taken to be aligned with the modeling coordinate axes.

.Or "Extended cell array 3D"
.Op color_type COLOR_TYPE
.Op point1 COORD_3D
.Op point2 COORD_3D
.Op point3 COORD_3D
.Op dx CARD32
.Op dy CARD32
.Op colors LISTofCOLOR
.IP
When processed by a renderer,
this command has the same effect as the "cell array 3D" primitive,
except that the colors may be passed as \fIIndexed\fP or \fIDirect\fP
color values, depending on the setting of \fIcolor_type\fP.

.Or "GDP 3D"
.Op gdp_id CARD32
.Op points LISTofCOORD_3D
.Op data LISTofCARD8
.IP
When processed by a renderer,
the effect of this command is implementation-dependent.
Because of floating point and color format discrepancies across
a network interface, it is not anticipated that the GDP 3D will provide
a useful extension mechanism, but
it is provided for PHIGS
compatibility purposes.

.Or "GDP 2D"
.Op gdp_id CARD32
.Op points LISTofCOORD_2D
.Op data LISTofCARD8
.IP
When processed by a renderer,
the effect of this command is implementation-dependent.
Because of floating point and color format discrepancies across
a network interface, it is not anticipated that the GDP 2D will provide
a useful extension mechanism, but
It is provided for PHIGS
compatibility purposes.

.bp
.AC "Lookup Tables" 1
.LP
.RU
.LP
A \fIlookup table\fP is a PEX resource that allows clients
to create tables of values for various purposes.  Lookup
tables are used to support a level of indirection for some
output primitive  attributes as well as for storing view information,
light source descriptions, depth-cue information, etc.
.LP
Tables may be sparse, therefore tables consist of index/entry
pairs.  The index is the number that will be used to reference
that entry.  The range of allowable indices for each type of
table is given in the description of each table type.
An entry is the collection of information (or the data record) that
is defined for each type of table.  The table descriptions in this section
include the definition of an entry for each type of table.
A table index refers to an \fIundefined entry\fP if no table entry
has ever been associated with that index, or if the associated table
entry has been deleted.
A table entry may contain one or more values, depending on the table
type.  For instance, in the \fIMarkerBundle\fP table type, each entry
in the table consists of an index, a marker type value, a marker scale
value and a marker color value.
.LP
A lookup table may have predefined entries.  These are table entries for
certain table index values that
are filled in automatically by the server when the table is created.
Predefined table entries may be deleted or overwritten.
Each type of table has a specific index value that indicates the
\fIdefault table value\fP.
If a table index references an undefined table entry, the contents
of the default table
entry will be used.  If the contents of the
default table entry is not defined, then
the default attribute values (as listed in Appendix D)
will be used as the default entry.
The default entry for all tables
is one, except for the view, depth cue, RGB approximation,
and intensity approximation
tables whose default entry is zero.
.LP
The allowable table types, the range of allowable index values (\fIn\fP is the
largest permissible index value for the table type), the default entry,
and the format of a table entry for each table type are as follows:
 

.Bl "LineBundle   (1..n, default entry = 1)"
This type of lookup table is used
to maintain attributes for drawing polyline and curve primitives.
Depending on the setting of the aspect source flag
attributes, polyline and curve attributes may be obtained from a line
bundle table.
Each entry in this type of table consists of the following:
.DS
.ta 1.0i 2.5i
	line_type	LINE_TYPE
	polyline_interp	POLYLINE_INTERP
	curve_approx	CURVE_APPROX
	line_width	FLOAT
	line_color	COLOR_SPECIFIER
.ta
.DE
The attributes stored in a line bundle table are defined and used in
the same fashion as the pipeline context attribute of the same name.


.Bl "MarkerBundle   (1..n, default entry = 1)"
This type of lookup table is used
to maintain attributes for drawing marker primitives.
Depending on the setting of the aspect source flag
attributes, marker attributes may be obtained from a marker bundle table.
Each entry in this type of table consists of the following:
.DS
.ta 1.0i 2.5i
	marker_type	MARKER_TYPE
	marker_scale	FLOAT
	marker_color	COLOR_SPECIFIER
.ta
.DE
The attributes stored in a marker bundle table are defined and used in
the same fashion as the pipeline context attribute of the same name.


.Bl "TextBundle   (1..n, default entry = 1)"
This type of lookup table is used
to maintain attributes for drawing text and annotation text primitives.
Depending on the setting of the aspect source flag
attributes, text and annotation text attributes may be obtained from a
text bundle table.
Each entry in this type of table consists of the following:
.DS
.ta 1.0i 2.5i
	text_font_index	TABLE_INDEX
	text_precision	TEXT_PRECISION
	char_expansion	FLOAT
	char_spacing	FLOAT
	text_color	COLOR_SPECIFIER
.ta
.DE
The attributes stored in a text bundle table are defined and used in
the same fashion as the pipeline context attribute of the same name.


.Bl "InteriorBundle   (1..n, default entry = 1)"
This type of lookup table is used
to maintain attributes for drawing surface primitives.
Depending on the setting of the aspect source flag
attributes, surface attributes may be obtained from an interior bundle table.
Each entry in this type of table consists of the following:
.DS
.ta 1.0i 2.5i
	interior_style	INTERIOR_STYLE
	interior_style_index	TYPE_OR_TABLE_INDEX
	surface_color	COLOR_SPECIFIER
	reflection_attr	REFLECTION_ATTRIBUTES
	reflection_model	REFLECTION_MODEL
	surface_interp	SURFACE_INTERP
	bf_interior_style	INTERIOR_STYLE
	bf_interior_style_index	TYPE_OR_TABLE_INDEX
	bf_surface_color	COLOR_SPECIFIER
	bf_reflection_attr	REFLECTION_ATTRIBUTES
	bf_reflection_model	REFLECTION_MODEL
	bf_surface_interp	SURFACE_INTERP
	surface_approx	SURFACE_APPROX
	trim_curve_approx	CURVE_APPROX
.ta
.DE
The attributes stored in an interior bundle table are defined and used in
the same fashion as the pipeline context attribute of the same name.


.Bl "EdgeBundle   (1..n, default entry = 1)"
This type of lookup table is used
to maintain attributes for drawing edges of surface primitives.
Depending on the setting of the aspect source flag
attributes, surface edge attributes may be obtained from an edge bundle table.
Each entry in this type of table consists of the following:
.DS
.ta 1.0i 2.5i
	surface_edges	SWITCH
	surface_edge_type	SURFACE_EDGE_TYPE
	surface_edge_width	FLOAT
	surface_edge_color	COLOR_SPECIFIER
.ta
.DE
The attributes stored in an edge bundle table are defined and used in
the same fashion as the pipeline context attribute of the same name.


.Bl "Pattern   (1..n, default entry = 1)"
This type of lookup table can be used to maintain patterns for use
when \fIinterior_style\fP is set to \fIPattern\fP.
.DS
.ta 1.0i 2.5i
	color_type	COLOR_TYPE
	numx	CARD16
	numy	CARD16
	colors	LISTofCOLOR
.ta
.DE
A pattern rectangle is comprised of \fInumx\fP by \fInumy\fP cells.
\fIColor_type\fP indicates whether the color values are stored as
indexed or direct color values.  The colors are stored in the array
row-by-row.  The upper left hand cell in the pattern rectangle is the
first one in the list of colors, followed by the remaining cells in
the first row.  The color values for cells in the second row follow,
and so on.


.Bl "Color   (0..n, default entry = 1)"
This type of lookup table can be used to resolve indirect
color references.  Consequently, all color values in this type
of table must be specified as direct colors.
.DS
.ta 1.0i 2.5i
	color	DIRECT_COLOR
.ta
.DE


.Bl "TextFont   (1..n, default entry = 1)"
This type of lookup table is used to maintain a list of font
resource id's.  Fonts may be either PEX fonts or X11 fonts, although
only PEX fonts are guaranteed to fully realize all of the PEX text attributes.
Specifically, scaling and rotation operations on text strings are not
guaranteed to affect text primitives
if an X11 font is used, but they are guaranteed to work if a PEX font is used.
Font values are specified as indices when using
output commands.  A font index can be used with a table of this type
in order to obtain the actual font to be used.
.DS
.ta 1.0i 2.5i
	font	{PEX_FONT_ID, X11_FONT_ID}
.ta
.DE


.Bl "View   (0..n, default entry = 0)"
This type of lookup table is used to maintain viewing information.
"Views" are then specified as indices, which are used to look up the
appropriate information in a view lookup table.
See the \fIPEX Introduction and Overview\fP document for a description
of how the viewing parameters are utilized in the rendering computations.
.DS
.ta 1.0i 2.5i
	clip_flags	BITMASK
	clip_limits	NPC_SUBVOLUME
	orientation	MATRIX
	mapping	MATRIX
.ta
.DE
\fIOrientation\fP is a matrix which maps geometry in world coordinates
to view reference (a.k.a., eye or viewing) coordinates.
\fIMapping\fP is a matrix which maps geometry in view reference coordinates
to normalized projection coordinates.
The \fIclip_limits\fP specify the minimum and maximum of a rectangular
volume in normalized projection coordinates.
\fIClip_flags\fP contains three bits that indicate whether or not clipping
should be performed
against the sides, back, and front planes of the
volume specified by \fIclip_limits\fP.
The NPC subvolume, along with the clip indicators and clip limits,
determines the actual clipping volume for each view.



.Bl "Light   (1..n, default entry = 1)"
This type of lookup table is used
to maintain light source definitions for use in light source shading
computations.
See the \fIPEX Introduction and Overview\fP document for a description
of how the light parameters are utilized in the rendering computations.
.DS
.ta 1.0i 2.5i
	light_type	LIGHT_TYPE
	direction	VECTOR_3D
	point	COORD_3D
	concentration	FLOAT
	spread_angle	FLOAT
	attenuation	[factor1, factor2 : FLOAT]
	color 	COLOR_SPECIFIER
.ta
.DE
Depending on the type of light, some of the values in a table entry
may be ignored.


.Bl "DepthCue   (0..n, default entry = 0)"
This type of lookup table is used
to maintain depth-cueing information.
See the \fIPEX Introduction and Overview\fP document for a description
of how the depth-cue parameters are utilized in the rendering computations.
.DS
.ta 1.0i 2.5i
	mode	SWITCH
	front_plane	FLOAT
	back_plane	FLOAT
	front_scaling	FLOAT
	back_scaling	FLOAT
	color	COLOR_SPECIFIER
.ta
.DE


.Bl "RGBApprox   (0..n, default entry = 0)" 
This type of lookup table is used
to define the way that a
renderer will transform rendering pipeline color values
into pixel values in the case where the target is an RGB frame buffer
of some type.
The information in this type of table is bound to a renderer when
the renderer is created.
The only entry that is ever used for a table of this
type is the entry with index value equal to zero.
.DS
.ta 1.0i 2.5i
	red_max	CARD16
	green_max	CARD16
	blue_max	CARD16
	red_mult	CARD32
	green_mult	CARD32
	blue_mult	CARD32
	base_pixel	CARD32
	dither		SWITCH
.ta
.DE
When this type of color approximation lookup table is bound
to a renderer or a PHIGS workstation,
each color that has been computed in the rendering pipeline is
converted to red, green, and blue intensity values.  Each of
the three intensity values is then mapped to an integer value
as follows:
.DS I
red = red intensity from pipeline mapped into the range [0, \fIred_max\fP]
green = green intensity from pipeline mapped into the range [0, \fIgreen_max\fP]
blue = blue intensity from pipeline mapped into the range [0, \fIblue_max\fP]
.DE
Then, a single pixel value is formed by computing:
.DS
pixel = \fIred_mult\fP * red + \fIgreen_mult\fP * green + \fIblue_mult\fP * blue + \fIbase_pixel\fP
.DE
The use of addition rather than logical OR for composing pixel values
permits allocations where red, green, and blue values are not allocated
into distinct bitplanes.
\fIDither\fP is treated as a hint to the renderer as to whether
or not some attempt at dithering should be performed.  Whether
or not dithering is supported and the dithering algorithm that
is used are implementation-dependent.


.Bl "IntensityApprox   (0..n, default entry = 0)"
This type of lookup table is used
to define the way that a
renderer will transform rendering pipeline color values
into pixel values in the case where the target is an intensity-valued
frame buffer of some type.
.DS
.ta 1.0i 2.5i
	intensity_max	CARD16
	base_pixel	CARD32
	dither	SWITCH
.ta
.DE
When this type of color approximation lookup table is bound
to a renderer or a PHIGS workstation,
each color that has been computed in the rendering pipeline is
converted to an intensity value in the range [0, 1].
The result is multplied by \fIintensity_max\fP and added to \fIbase_pixel\fP
to produce the pixel value to be written.
\fIDither\fP is treated as a hint to the renderer as to whether
or not some attempt at dithering should be performed.  Whether
or not dithering is supported and the dithering algorithm that
is used are implementation-dependent.
.sp
This type of table may have multiple entries.  The entry to be
used depends on the type of primitive being rendered and the
current color for that primitive.
If the current color type
for the output primitive is \fIDirect\fP, entry zero in the
\fIIntensityApprox\fP table will always be used to convert
pipeline color values into pixels.
If the current color type
for the output primitive is \fIIndexed\fP, the color index will
be used as the index into the
\fIIntensityApprox\fP table to determine which entry of
the table will be used to convert
pipeline color values into pixels.
.bp

.AC "Lookup Table Resource Management" 2
.LP                   
The lookup table is an X11 resource and carries all of the 
responsibilities and
access rights of X11 resources.  These requests manage the creation,
freeing, and copying of lookup table resources.

.AC "Create Lookup Table" 3
.Fs
.Na PEXCreateLookupTable
.Rq
.Pa drawable_example DRAWABLE_ID
.Pa lut_id LOOKUP_TABLE_ID
.Pa table_type TABLE_TYPE
.Se
IDChoice, Drawable, Value, Alloc
.Ds                     
This request creates a lookup table resource for the specified
\fIlut_id\fP, for use with drawables with the same root window and depth
as the example drawable specified by \fIdrawable_example\fP. 
The \fItable_type\fP parameter indicates the type of lookup
table that is to be created.
Some entries of a lookup table may be defined at the time the resource
is created.  The number of predefined entries and their contents are
dependent on the type of table and are
implementation-dependent.
.Fe



.AC "Copy Lookup Table" 3
.Fs
.Na PEXCopyLookupTable
.Rq
.Pa src_lut_id LOOKUP_TABLE_ID
.Pa dest_lut_id LOOKUP_TABLE_ID
.Se
LookupTable, Match
.Ds            
This request copies the source lookup table
\fIsrc_lut_id\fP to a destination lookup table \fIdest_lut_id\fP,
after first deleting all the entries in the destination lookup table.
The \fIdest_lut_id\fP must already exist as a valid resource and
it must be of the same type as \fIsrc_lut_id\fP.
.Fe
.bp

.AC "Free Lookup Table" 3
.Fs
.Na PEXFreeLookupTable
.Rq
.Pa lut_id LOOKUP_TABLE_ID
.Se
LookupTable
.Ds            
This request deletes the association between the resource id
and the lookup table.  The lookup table storage will be
freed when no other resource references it.
.Fe
.bp

.AC "Lookup Table Inquiry" 2
.LP
These requests inquire lookup table attributes.
.AC "Get Table Info" 3
.Fs
.Na PEXGetTableInfo
.Rq
.Pa drawable_example DRAWABLE_ID
.Pa table_type TABLE_TYPE
.Re
.Pa definable_entries CARD16
.Pa num_predefined CARD16
.Pa predefined_min TABLE_INDEX
.Pa predefined_max TABLE_INDEX
.Se
Drawable, Value
.Ds       
This request will return information about lookup tables of the
specified \fItable_type\fP if they were to be used with drawables
of the same root and depth as \fIdrawable_example\fP.
\fIDefinable_entries\fP is the maximum number of entries that
can be defined in this type of table, and
includes the number of predefined entries.  Predefined entries
can be redefined by the client.  All the entries between
\fIpredefined_min\fP and \fIpredefined_max\fP are guaranteed to
be defined initially (i.e., predefined entries must have contiguous indices).
.Fe
.bp

.AC "Get Predefined Entries" 3
.Fs
.Na PEXGetPredefinedEntries
.Rq
.Pa format FORMAT
.Pa drawable_example DRAWABLE_ID
.Pa table_type TABLE_TYPE
.Pa start TABLE_INDEX
.Pa count CARD16
.Re
.Pa entries LISTofTABLE_ENTRY
.Se
Drawable, Value, FloatingPointFormat, DirectColorFormat
.Ds       
This request will return the values for predefined table
entries of the specified \fItable_type\fP if they were to be
used with drawables
of the same root and depth as \fIdrawable_example\fP.
The default entry will be returned for each entry in the range
that is not predefined.
\fICount\fP table entries will be returned in \fIentries\fP, starting
with the table entry specified by \fIstart\fP.  The values in
\fIentries\fP will be in the format defined for \fItable_type\fP.
Floating point values in \fIentries\fP will be returned in the floating
point format specified in \fIformat\fP.
Similarly, direct color values in \fIentries\fP will be returned
in the direct color format specified in \fIformat\fP.
.Fe


.AC "Get Defined Indices" 3
.Fs
.Na PEXGetDefinedIndices
.Rq
.Pa lut_id LOOKUP_TABLE_ID
.Re
.Pa defined_indices LISTofTABLE_INDEX
.Se
LookupTable
.Ds       
This request will return in \fIdefined_indices\fP
a list of all the indices that are currently defined in the lookup
table resource specified by \fIlut_id\fP.  The entries returned
include those predefined by the server and those that have been
defined by clients.
.Fe
.bp


.AC "Get Table Entry" 3
.Fs
.Na PEXGetTableEntry
.Rq
.Pa format FORMAT
.Pa lut_id LOOKUP_TABLE_ID
.Pa index TABLE_INDEX
.Re
.Pa status "{\fIDefined, Default\fP}"
.Pa entry TABLE_ENTRY
.Se
LookupTable, FloatingPointFormat, DirectColorFormat
.Ds       
This request will return
the lookup table entry specified by \fIindex\fP.
The entry will be obtained from the lookup table specified
by \fIlut_id\fP and will be of the format indicated by \fIlut_id\fP's
table type.  If the entry in the lookup table
is defined, its contents will be returned
in \fIentry\fP and \fIstatus\fP will be set to \fIDefined\fP.
If the entry in the lookup table
is not defined, the values for the default entry for that table type
will be returned
in \fIentry\fP and \fIstatus\fP will be set to \fIDefault\fP.
Floating point values in \fIentry\fP will be returned in the floating
point format specified in \fIformat\fP.
Similarly, direct color values in \fIentry\fP will be returned
in the direct color format specified in \fIformat\fP.
.Fe


.AC "Get Table Entries" 3
.Fs
.Na PEXGetTableEntries
.Rq
.Pa format FORMAT
.Pa lut_id LOOKUP_TABLE_ID
.Pa start TABLE_INDEX
.Pa count CARD16
.Re
.Pa entries LISTofTABLE_ENTRY
.Se
LookupTable, Value, FloatingPointFormat, DirectColorFormat
.Ds       
This request will return \fIcount\fP table entries from the lookup
table specified by \fIlut_id\fP, starting at the entry specified
by \fIstart\fP.  The default entry will be returned for any entry
in the requested range that is not defined.
Floating point values in \fIentries\fP will be returned in the floating
point format specified in \fIformat\fP.
Similarly, direct color values in \fIentries\fP will be returned
in the direct color format specified in \fIformat\fP.
.Fe
.bp

.AC "Lookup Table Modification" 2
.LP
This section contains requests that modify lookup table resources.


.AC "Set Table Entries" 3
.Fs
.Na PEXSetTableEntries
.Rq
.Pa format FORMAT
.Pa lut_id LOOKUP_TABLE_ID
.Pa start TABLE_INDEX
.Pa count CARD16
.Pa entries LISTofTABLE_ENTRY
.Se
LookupTable, Value, FloatingPointFormat, DirectColorFormat
.Ds       
This request will set \fIcount\fP lookup table entries in
the lookup table resource specified by \fIlut_id\fP, starting
at the entry indicated by \fIstart\fP.
The values to use when setting the entries in the lookup table
are provided in \fIentries\fP, and are in the format specified
for a lookup table of \fIlut_id\fP's type.
Floating point values in \fIentries\fP will be in the floating
point format specified in \fIformat\fP.
Similarly, direct color values in \fIentries\fP will be 
in the direct color format specified in \fIformat\fP.
.Fe




.AC "Delete Table Entries" 3
.Fs
.Na PEXDeleteTableEntries
.Rq
.Pa lut_id LOOKUP_TABLE_ID
.Pa start TABLE_INDEX
.Pa count CARD16
.Se
LookupTable, Value
.Ds       
This request will delete \fIcount\fP lookup table entries in
the lookup table resource specified by \fIlut_id\fP, starting
at the entry indicated by \fIstart\fP.
.Fe
.bp


.AC "Pipeline Contexts" 1
.LP
.RU
.LP
A \fIpipeline context\fP is a PEX resource that contains an instance of the
attributes that describe a rendering pipeline.  The attributes
in a pipeline context are copied to a renderer resource whenever
a \fBPEXBeginRendering\fP request is executed.
Pipeline contexts
are semi-lightweight resources - they contain a relatively large
number of attributes that can be modified.
This section
describes pipeline context attributes and the operations that can be performed
on pipeline context resources.
.LP
Some of the requests in this section affect attributes of a pipeline
context.
The \fIitem_mask\fP and \fIitem_list\fP parameters
specify which components are to be affected.
Each bit in the \fIitem_mask\fP indicates whether or not
the corresponding attribute is affected.  In the cases where
pipeline context attributes are being set or queried,
there is a corresponding entry in the \fIitem_list\fP
for each set bit in \fIitem_mask\fP.
It is therefore possible
to affect one or many pipeline context attributes with a single request.
.LP
Some of the attributes in a pipeline context
are references to other resources.  In general, the semantics of
dealing with references to nonexistent resources is implementation-dependent.
"Reasonable" implementations might choose to treat references to
nonexistent name sets resources as though they were references to a
name set resource that contains a null name list.
As another example,
if a lookup table resource id is null, any references to an entry
in that table might map to a default predefined entry for that type of table.
Also, the resource id returned when such an attribute is queried
is not guaranteed to be valid, since the resource with that id
may already have been freed.  It is up to the client to manage
all references to a resource when it is freed so that this situation
does not occur.
.LP
The pipeline context components, in order, are listed in the following table.
.LP
.ID
.ta 0.4i 2.4i 3.9i
	\fBAttribute Name	Data Type	Default Value\fP
.ta
.ta 0.5i 2.2i 4.0i
    \fIMarker attributes\fP
	marker_type	MARKER_TYPE	3
	marker_scale	FLOAT	1.0
	marker_color	COLOR_SPECIFIER	{\fIIndexed\fP, 1}
	marker_bundle_index	TABLE_INDEX	1
    \fIText attributes\fP
	text_font	TABLE_INDEX	1
	text_precision	TEXT_PRECISION	\fIString\fP
	char_expansion	FLOAT	1.0
	char_spacing	FLOAT	0.0
	text_color	COLOR_SPECIFIER	{\fIIndexed\fP, 1}
	char_height	FLOAT	0.01
	char_up_vector	VECTOR_2D	<0.0 1.0>
	text_path	TEXT_PATH	\fIRight\fP
	text_alignment	TEXT_ALIGNMENT	{\fINormal, Normal\fP}
	atext_height	FLOAT	0.01
	atext_up_vector	VECTOR_2D	<0.0 1.0>
	atext_path	TEXT_PATH	\fIRight\fP
	atext_alignment	TEXT_ALIGNMENT	{\fINormal, Normal\fP}
	atext_style	ATEXT_STYLE	1
	text_bundle_index	TABLE_INDEX	1
    \fILine and curve attributes\fP
	line_type	LINE_TYPE	1
	line_width	FLOAT	1.0
	line_color	COLOR_SPECIFIER	{\fIIndexed\fP, 1}
	curve_approx	CURVE_APPROX	{0, 1.0}
	polyline_interp	POLYLINE_INTERP	1
	line_bundle_index	TABLE_INDEX	1
    \fISurface attributes\fP
	interior_style	INTERIOR_STYLE	1
	interior_style_index	TYPE_OR_TABLE_INDEX	1
	surface_color	COLOR_SPECIFIER	{\fIIndexed\fP, 1}
	reflection_attr	REFLECTION_ATTR	{1.0, 1.0, 1.0, 0.0, 0.0, (\fIIndexed\fP, 1)}
	reflection_model	REFLECTION_MODEL	1
	surface_interp	SURFACE_INTERP	1
	bf_interior_style	INTERIOR_STYLE	1
	bf_interior_style_index	TYPE_OR_TABLE_INDEX	1
	bf_surface_color	COLOR_SPECIFIER	{\fIIndexed\fP, 1}
	bf_reflection_attr	REFLECTION_ATTR	{1.0, 1.0, 1.0, 0.0, 0.0, (\fIIndexed\fP, 1)}
	bf_reflection_model	REFLECTION_MODEL	1
	bf_surface_interp	SURFACE_INTERP	1
	surface_approx	SURFACE_APPROX	{0, 1.0, 1.0}
	trim_curve_approx	CURVE_APPROX	{0, 1.0}
	culling_mode	CULL_MODE	\fIBackFaces\fP
	distinguish	BOOLEAN	\fIFalse\fP
	normalflip	BOOLEAN	\fIFalse\fP
	pattern_size	COORD_2D	(1.0, 1.0)
	pattern_ref_pt	COORD_3D	(0.0, 0.0, 0.0)
	pattern_ref_vec1	VECTOR_3D	<1 0 0>
	pattern_ref_vec2	VECTOR_3D	<0 1 0>
	interior_bundle_index	TABLE_INDEX	1
    \fISurface edge attributes\fP
	surface_edges	SWITCH	\fIOff\fP
	surface_edge_type	SURFACE_EDGE_TYPE	1
	surface_edge_width	FLOAT	1.0
	surface_edge_color	COLOR_SPECIFIER	{\fIIndexed\fP, 1}
	edge_bundle_index	TABLE_INDEX	1
    \fIGeometry transformation attributes\fP
	local_transform	MATRIX	identity
	global_transform	MATRIX	identity
	model_clip	SWITCH	\fIOff\fP
	model_clip_volume	LISTofHALF_SPACE	\fINull\fP
	view_index	TABLE_INDEX	0
    \fIColor transformation attributes\fP
	light_state	BITMASK	all zeros
	depth_cue_index	TABLE_INDEX	0
    \fIASF attributes\fP
	asfs	ASF_SPECIFIER	{0, all \fIIndividual\fP}
    \fIMiscellaneous attributes\fP
	pick_id	CARD32	0
	HLHSR_identifier	CARD32	0
	name_set \(dg	NAME_SET_ID	\fINone\fP
.FS
\(dg When pipeline context attributes are copied to a renderer (e.g., whenever
a \fBPEXBeginRendering\fP request occurs),
the actual \fIcontents\fP of the name set resource is copied, and
not the resource id of the name set.
.FE

The bits in the \fIasf_flags\fP field of an ASF_SPECIFIER are defined as:

	marker_type_asf	ASF_VALUE	\fIIndividual\fP
	marker_scale_asf	ASF_VALUE	\fIIndividual\fP
	marker_color_asf	ASF_VALUE	\fIIndividual\fP
	text_font_index_asf	ASF_VALUE	\fIIndividual\fP
	text_precision_asf	ASF_VALUE	\fIIndividual\fP
	char_expansion_asf	ASF_VALUE	\fIIndividual\fP
	char_spacing_asf	ASF_VALUE	\fIIndividual\fP
	text_color_asf	ASF_VALUE	\fIIndividual\fP
	line_type_asf	ASF_VALUE	\fIIndividual\fP
	line_width_asf	ASF_VALUE	\fIIndividual\fP
	line_color_asf	ASF_VALUE	\fIIndividual\fP
	curve_approx_asf	ASF_VALUE	\fIIndividual\fP
	polyline_interp_asf	ASF_VALUE	\fIIndividual\fP
	interior_style_asf	ASF_VALUE	\fIIndividual\fP
	interior_style_index_asf	ASF_VALUE	\fIIndividual\fP
	surface_color_asf	ASF_VALUE	\fIIndividual\fP
	reflection_model_asf	ASF_VALUE	\fIIndividual\fP
	surface_interp_asf	ASF_VALUE	\fIIndividual\fP
	reflection_attr_asf	ASF_VALUE	\fIIndividual\fP
	bf_interior_style_asf	ASF_VALUE	\fIIndividual\fP
	bf_interior_style_index_asf	ASF_VALUE	\fIIndividual\fP
	bf_surface_color_asf	ASF_VALUE	\fIIndividual\fP
	bf_reflection_model_asf	ASF_VALUE	\fIIndividual\fP
	bf_surface_interp_asf	ASF_VALUE	\fIIndividual\fP
	bf_reflection_attr_asf	ASF_VALUE	\fIIndividual\fP
	surface_approx_asf	ASF_VALUE	\fIIndividual\fP
	trim_curve_approx_asf	ASF_VALUE	\fIIndividual\fP
	surface_edges_asf	ASF_VALUE	\fIIndividual\fP
	surface_edge_type_asf	ASF_VALUE	\fIIndividual\fP
	surface_edge_width_asf	ASF_VALUE	\fIIndividual\fP
	surface_edge_color_asf	ASF_VALUE	\fIIndividual\fP
.ta

.DE

.LP
The attributes of the pipeline context resource are defined as follows:

.Bl "marker_type"
This attribute contains the marker type to use when drawing marker primitives.
See the "Extension Information" section for descriptions of the registered
marker types.

.Bl "marker_scale"
This attribute contains the marker scale factor
to use when drawing marker primitives.

.Bl "marker_color"
This attribute contains the color value to use when drawing marker primitives.

.Bl "marker_bundle_index"
This attribute contains the lookup table index to be used to obtain
bundled marker attributes from the marker bundle table.

.Bl "text_font_index"
This attribute contains the lookup table index to be used to
obtain the font id for drawing text
and annotation text primitives.

.Bl "text_precision"
This attribute contains the text precision to use when drawing text
and annotation text primitives.

.Bl "char_expansion"
This attribute contains the character expansion
to use when drawing text primitives.
The character 
expansion factor is the deviation of the width to height
ratio of the characters from the ratio indicated by the 
font designer.

.Bl "char_spacing"
This attribute contains the character spacing
to use when drawing text primitives.
Character spacing
specifies how much additional space is to be inserted between
two adjacent character bodies and is specified as a fraction of the
font-nominal character height.

.Bl "text_color"
This attribute contains the color value to use when drawing text
and annotation text primitives.

.Bl "char_height"
This attribute contains the character height
to use when drawing text primitives.
The character height
is specified in modeling coordinates.

.Bl "char_up_vector"
This attribute contains the character up vector
to use when drawing text primitives.
The up vector
is specified in modeling coordinates.

.Bl "text_path "
This attribute contains the text path to use when drawing text primitives
(i.e., the writing path of the text string).

.Bl "text_alignment"
This attribute contains the horizontal and vertical alignment
to use when drawing text primitives.

.Bl "atext_height"
This attribute contains the character height
to use when drawing annotation text primitives.
The character height
is specified in modeling coordinates.

.Bl "atext_up_vector"
This attribute contains the character up vector
to use when drawing annotation text primitives.
The up vector is specified in the text local coordinate system.

.Bl "atext_path"
This attribute contains the text path
to use when drawing annotation text primitives
(i.e. the writing path of the annotation text string).

.Bl "atext_alignment"
This attribute contains the horizontal and vertical alignment
to use when drawing annotation text primitives.

.Bl "atext_style"
This attribute contains the annotation text style
to use when drawing annotation text primitives.
See the "Extension Information" section for descriptions of the registered
annotation text styles.

.Bl "text_bundle_index"
This attribute contains the lookup table index to be used to obtain
bundled text attributes from the text bundle table.

.Bl "line_type"
This attribute contains the type to use when drawing polyline
and curve primitives.
See the "Extension Information" section for descriptions of the registered
line types.

.Bl "line_width"
This attribute contains the width to use when drawing polyline or
curve primitives.
This is the scale factor applied to the width of the polyline or curve
primitive when it
is to be rendered.  Line width is applied in 2D raster
coordinates after the primitive has been transformed from 3D
space to 2D raster space.
The range of line widths supported by the implementation should
be described in the implementation documentation.

.Bl "line_color"
This attribute contains the color value to use when drawing polyline
and curve primitives.

.Bl "curve_approx"
This attribute contains the curve approximation
to use when drawing curve primitives.  It sets the curve approximation
method and
the tolerance value for drawing curves.
See the "Extension Information" section for descriptions of the registered
curve approximation methods and how the curve tolerance is used with each type.

.Bl "polyline_interp"
This attribute contains the polyline interpolation method
to use when drawing polyline primitives.
See the "Extension Information" section for descriptions of the registered
polyline interpolation methods.

.Bl "line_bundle_index"
This attribute contains the lookup table index to be used to obtain
bundled polyline and curve attributes from the line bundle table.

.Bl "interior_style"
This attribute contains the interior style
to use when drawing surface primitives.
See the "Extension Information" section for descriptions of the registered
interior styles.

.Bl "interior_style_index"
This attribute contains the index to use
if the interior style is of
type \fIPattern\fP or \fIHatch\fP.
The interior style index contains the table index of
the pattern table entry to be used
when the interior
style is \fIPattern\fP,
and the hatch table enumerated type index to be used
when the interior
style is \fIHatch\fP.

.Bl "surface_color"
This attribute contains the color value to use when drawing surface primitives.

.Bl "reflection_attr"
This attribute contains the ambient coefficient; the diffuse coefficient;
the specular coefficient, concentration, and color; and the transmission
coefficient that are to be used in
the light source shading computations when rendering surfaces
(area-defining primitives).
The specular color attribute provides an additional coefficient per primary
for use in the specular reflection computation.  This allows highlights
to be computed that are some color other than that of the light source.
The specular concentration
defines the sharpness
of the specular highlights or the "shininess" of a surface.  This
value is typically used as the exponent in the specular reflection
term of lighting equations.
If \fIspecular_conc\fP = zero, specular
highlights are very broad.  If \fIspecular_conc\fP is much greater than zero,
the highlights are very small and sharp, as if the surface
was very shiny.
The transmission coefficient indicates the amount of light that passes
through a surface.
A transmission coefficient of zero indicates that
the surface is opaque (lets no light through).
A transmission coefficient of 1.0 indicates that
the surface is totally invisible (lets all light through).

.Bl "reflection_model"
This attribute contains the reflection model
to use when drawing surface primitives.
See the "Extension Information" section for descriptions of the registered
reflection models.

.Bl "surface_interp"
This attribute contains the surface interpolation method
to use when drawing surface primitives.
See the "Extension Information" section for descriptions of the registered
surface interpolation methods.

.Bl "bf_interior_style"
This attribute contains the interior style
to use when drawing backfacing surface primitives.
See the "Extension Information" section for descriptions of the registered
interior styles.

.Bl "bf_interior_style_index"
This attribute contains the index to use for backfacing surface primitives
if the interior style is of
type \fIPattern\fP or \fIHatch\fP.
The interior style index contains the table index of
the pattern table entry to be used
when the interior
style is \fIPattern\fP,
and the hatch table enumerated type index to be used
when the interior
style is \fIHatch\fP.

.Bl "bf_surface_color"
This attribute contains the color value to use when rendering
backfacing surface primitives.

.Bl "bf_reflection_attr"
This attribute contains the reflection attributes to be used when rendering
backfacing surfaces.

.Bl "bf_reflection_model"
This attribute contains the reflection model
to use when drawing backfacing surface primitives.
See the "Extension Information" section for descriptions of the registered
reflection models.

.Bl "bf_surface_interp"
This attribute contains the surface interpolation method
to use when drawing backfacing surface primitives.
See the "Extension Information" section for descriptions of the registered
surface interpolation methods.

.Bl "surface_approx"
This attribute contains the surface approximation and the tolerance
to use when drawing surface primitives.
See the "Extension Information" section for descriptions of the registered
surface approximation methods and of how the surface tolerance is used with
each of them.

.Bl "trim_curve_approx"
This attribute contains the curve approximation method
to use for trim curves on surface primitives.
It sets the trim curve approximation and
the tolerance value for trim curves.
See the "Extension Information" section for descriptions of the registered
curve approximation methods and how the curve tolerance is used with each type.

.Bl "culling_mode"
This attribute contains the culling mode that is used in processing
backfacing surfaces.
If the culling mode
is \fIBackFaces\fP, all back-facing surfaces will be culled and
only front-facing surfaces will be rendered.
If the culling mode
is \fIFrontFaces\fP, all front-facing surfaces will be culled and
only back-facing surfaces will be rendered.
If the culling mode is
\fINone\fP, both front- and back-facing polygons will be rendered.

.Bl "distinguish"
This attribute contains the distinguish mode that is used in processing
backfacing surfaces.
This flag
selects whether back-facing surfaces are rendered with the back-face
surface attributes or the front-face surface attributes.
If distinguish is \fITrue\fP,
then back-face attributes are used to render the surface.
If \fIdistinguish\fP is \fIFalse\fP,
then front-face attributes are used to render the surface.
.IP

.Bl "normalflip"
This attribute contains the normalflip mode that is used in processing
backfacing surfaces.
\fINormalflip\fP
selects whether back-facing surfaces have their normals negated (flipped)
in order to perform the light source shading calculations.
If \fInormalflip\fP is \fITrue\fP,
the normal(s) of a back-facing surface will be flipped before the
light source shading calculations are performed.
If \fInormalflip\fP is \fIFalse\fP,
the normal(s) of a back-facing surface will not be flipped before the
light source shading calculations are performed.

.Bl "pattern_size"
This attribute contains the pattern size
to use when drawing surface primitives.
The value (\fIx\fP,0) will be used as the pattern width 
vector and
the value (0,\fIy\fP) will be used as the pattern height
vector.
If the interior style is \fIPattern\fP, the renderer
attempts to use 
these values, plus the pattern reference point and the pattern reference 
vector, to position, scale, and rotate the pattern on the surface. 

.Bl "pattern_ref_pt"
This attribute contains the pattern reference point
to use when drawing surface primitives.
If the interior style
is \fIPattern\fP, the renderer attempts
to use the pattern reference point, reference vectors, and
the pattern size to position and scale the pattern on the surface. 

.Bl "pattern_ref_vec1"
.IP
This attribute contains the first of two pattern reference vectors
to be used when interior style is \fIPattern\fP.
When the interior style is \fIPattern\fP,
the renderer attempts to use the two pattern reference vectors,
the pattern reference point, and
the pattern size to position, scale, and rotate the pattern on the 
surface. 

.Bl "pattern_ref_vec2"
.IP
This attribute contains the second of two pattern reference vectors
to be used when interior style is \fIPattern\fP.
When the interior style is \fIPattern\fP,
the renderer attempts to use the two pattern reference vectors,
the pattern reference point, and
the pattern size to position, scale, and rotate the pattern on the 
surface. 

.Bl "interior_bundle_index"
This attribute contains the lookup table index to be used to obtain
bundled interior attributes from the interior bundle table.

.Bl "surface_edges"
This attribute contains the surface edge flag attribute, which
is used to enable or disable surface edge drawing.  
If \fIonoff\fP is
\fIOff\fP, surface edge drawing is disabled.  If \fIonoff\fP 
is \fIOn\fP, surface edge
drawing is enabled.  Surface edges are drawn using the surface
edge color, surface edge type, and surface edge width.

.Bl "surface_edge_type"
This attribute contains the edge type
to use when drawing surface edges.
See the "Extension Information" section for descriptions of the registered
surface edge types.

.Bl "surface_edge_width"
This attribute contains the edge width
to use when drawing surface edges.
This is the scale factor applied to the width of a surface edge when a
surface edge is to be rendered.  It is applied in 2D raster
coordinates after a surface edge primitive has been transformed from 3D
space to 2D raster space.
The range of surface edge widths supported by the implementation should
be described in the implementation documentation.

.Bl "surface_edge_color"
This attribute contains the color value to use when drawing surface edges.

.Bl "edge_bundle_index"
This attribute contains the lookup table index to be used to obtain
bundled surface edge attributes from the surface edge bundle table.

.Bl "local_transform"
This attribute contains the local modeling transformation matrix that is used
when drawing output primitives.

.Bl "global_transform"
This attribute contains the global modeling transformation matrix that is used
when drawing output primitives.

.Bl "model_clip"
This attribute contains the model clipping flag that indicates whether
or not to perform modeling clipping
when drawing output primitives.

.Bl "model_clip_volume"
This attribute contains the model clipping volume that is used
whenever modeling clipping is enabled.

.Bl "view_index"
This attribute contains the lookup table index to be used to obtain
viewing attributes from the view table.

.Bl "light_state"
This attribute contains a bit mask that defines which lights are on
and which are off.  Values of zero indicate lights that are off, values
of one indicate lights that are on.

.Bl "depth_cue_index"
This attribute contains the lookup table index to be used to obtain
bundled depth-cue attributes from the depth-cue bundle table.

.Bl "asf_flags"
This attribute contains an aspect source flags (asf) for each attribute
that can be obtained from a bundle lookup table.
When rendering, if the value for an asf
is set to \fIIndividual\fP, the value for the corresponding
attribute will be obtained directly from the current value within
the renderer.
If the value for the asf is set to \fIBundled\fP, the value for the
attribute will be obtained from the bundle lookup table.
When setting asf's, a separate mask (\fIenables\fP) is used to
indicate which asf's are actually to be modified.  The value to which an
asf is to be modified will then be taken from the corresponding
bit in the \fIasfs\fP bitmask.  The \fIenables\fP field of the
ASF_SPECIFIER is only used when creating or changing attributes
of a pipeline context.  During copying, all ASF values are copied,
and when queried, all ASF values are returned (i.e., the \fIenables\fP
field is not saved as part of a pipeline context's state).

.Bl "pick_id     "
This attribute contains the pick id, which
is used in conjunction with picking operations.

.Bl "HLHSR_identifier"
This attribute contains an HLHSR identifier.
The HLHSR identifier has an implementation-dependent
meaning.  Conceptually, this attribute is bound to
all output primitives as they enter the rendering
pipeline.

.Bl "name_set"
This attribute contains a reference to a name set resource.
When attributes of a pipeline context are copied to a renderer,
the \fIcontents\fP of this nameset are copied to the renderer.

.bp

.AC "Pipeline Context Resource Management" 2
.LP                   
The pipeline context is an X11 resource and carries all of the 
responsibilities and
access rights of X11 resources.  These requests manage the creation,
freeing, and copying of pipeline contexts.

.AC "Create Pipeline Context" 3
.Fs
.Na PEXCreatePipelineContext
.Rq      
.Pa format FORMAT
.Pa pc_id PIPELINE_CONTEXT_ID
.Pa item_mask PC_BITMASK
.Pa item_list LISTofVALUE
.Se
IDChoice, Value, FloatingPointFormat, DirectColorFormat, Alloc
.Ds                     
This request creates a pipeline context resource for the specified
\fIpc_id\fP.  
The \fIitem_mask\fP defines those pipeline context attributes
that are to be explicitly set at the time the resource is created.
The \fIitem_list\fP 
contains the corresponding
list of values used to modify the newly-created pipeline context.
Floating point values in \fIitem_list\fP will be in the floating
point format specified in \fIformat\fP.
Similarly, direct color values in \fIitem_list\fP will be
in the direct color format specified in \fIformat\fP.
.Fe



.AC "Copy Pipeline Context" 3
.Fs
.Na PEXCopyPipelineContext
.Rq                 
.Pa src_pc_id PIPELINE_CONTEXT_ID
.Pa dest_pc_id PIPELINE_CONTEXT_ID
.Pa item_mask PC_BITMASK
.Se
PipelineContext
.Ds            
This request copies the source pipeline context
\fIsrc_pc_id\fP to a destination pipeline context \fIdest_pc_id\fP.
The \fIdest_pc_id\fP must already exist as a valid resource.
The \fIitem_mask\fP     
indicates which values
in the pipeline context will be copied.
.Fe
.bp


.AC "Free Pipeline Context" 3
.Fs
.Na PEXFreePipelineContext
.Rq                 
.Pa pc_id PIPELINE_CONTEXT_ID
.Se
PipelineContext
.Ds            
This request deletes the association between the resource id
and the pipeline context.  The pipeline context storage will be
freed when no other resource references it.
.Fe
.bp


.AC "Pipeline Context Inquiry" 2
.LP
This section defines the requests that can be used
to inquire pipeline context attributes.
.AC "Get Pipeline Context" 3
.Fs
.Na PEXGetPipelineContext
.Rq
.Pa format FORMAT
.Pa pc_id PIPELINE_CONTEXT_ID
.Pa item_mask PC_BITMASK
.Re
.Pa item_list LISTofVALUE
.Se
PipelineContext, FloatingPointFormat, DirectColorFormat
.Ds       
This request will return components of
the pipeline context specified by \fIpc_id\fP.
The \fIitem_mask\fP specifies which components are to be inquired and returned.
The specified attributes of the pipeline context will be returned in
\fIitem_list\fP.
Floating point values in \fIitem_list\fP will be returned in the floating
point format specified in \fIformat\fP.
Similarly, direct color values in \fIitem_list\fP will be returned
in the direct color format specified in \fIformat\fP.
.Fe


.AC "Pipeline Context Modification" 2
.LP
This section defines the requests that can be used
to modify attributes of pipeline context resources.
.AC "Change Pipeline Context" 3
.Fs
.Na PEXChangePipelineContext
.Rq
.Pa format FORMAT
.Pa pc_id PIPELINE_CONTEXT_ID
.Pa item_mask PC_BITMASK
.Pa item_list LISTofVALUE
.Se
PipelineContext, Value, FloatingPointFormat, DirectColorFormat
.Ds       
This request will modify components of
the pipeline context specified by \fIpc_id\fP.
The \fIitem_mask\fP specifies which components are to be modified.
The values for the attributes that are to be modified are contained in
\fIitem_list\fP.
Floating point values in \fIitem_list\fP will be in the floating
point format specified in \fIformat\fP.
Similarly, direct color values in \fIitem_list\fP will be
in the direct color format specified in \fIformat\fP.
.Fe
.bp

.AC "Renderers" 1
.LP
.RU
.LP
A \fIrenderer\fP is a PEX resource that can be created for
the purpose of doing 3D rendering.  A renderer consists of resource id's
for various tables and name sets,
the resource id of a pipeline context from
which the initial
rendering pipeline attributes will be copied,
and other attributes.
A renderer also manages the HLHSR
buffer needed for some hidden line/hidden surface algorithms.
If there are lots of primitives stored in this buffer, the renderer
resource can be very heavyweight.  Once the buffer is emptied, this
resource again becomes fairly lightweight.
.LP
Some renderer resource requests require an
\fIitem_mask\fP parameter.
Each bit in the \fIitem_mask\fP indicates whether or not
the corresponding attribute is to be set/queried.
There is a corresponding entry in the \fIitem_list\fP
for each set bit in \fIitem_mask\fP.
It is therefore possible
to set/query one or many renderer attributes with a single request.
.LP
During rendering operations,
if a renderer makes an attempt to access an attribute from a lookup table
whose resource id is \fINull\fP, the default attributes
for the lookup table
(as listed in Appendix D)
will be used.
If a renderer makes an attempt to read from a name set whose resource id
is \fINull\fP, the result will be as if the name set was empty.
Attempts to modify a name set whose resource id is \fINull\fP will be ignored.
If the renderer's pipeline context attribute contains the resource id
\fINull\fP, the default values for pipeline context attributes will be copied
into the renderer whenever a \fBPEXBeginRendering\fP request is performed.
.LP
The renderer components, in order, are listed in the following table.
The abbreviation "imp. dep." means that the default value is
implementation-dependent.
.LP
.ID
.ta 0.5i 2.4i 3.8i
	\fBAttribute Name	Data Type	Default Value\fP
.ta
.ta 0.5i 2.2i 4.0i
	pipeline_context	PIPELINE_CONTEXT_ID	\fINull\fP
	current_path	LISTofELEMENT_REF	\fINull\fP
	renderer_state	RENDERER_STATE	\fIIdle\fP
	marker_bundle	LOOKUP_TABLE_ID	\fINull\fP
	text_bundle	LOOKUP_TABLE_ID	\fINull\fP
	line_bundle	LOOKUP_TABLE_ID	\fINull\fP
	interior_bundle	LOOKUP_TABLE_ID	\fINull\fP
	edge_bundle	LOOKUP_TABLE_ID	\fINull\fP
	view_table	LOOKUP_TABLE_ID	\fINull\fP
	color_table	LOOKUP_TABLE_ID	\fINull\fP
	depth_cue_table	LOOKUP_TABLE_ID	\fINull\fP
	light_table	LOOKUP_TABLE_ID	\fINull\fP
	color_approx_table	LOOKUP_TABLE_ID	\fINull\fP
	pattern_table	LOOKUP_TABLE_ID	\fINull\fP
	text_font_table	LOOKUP_TABLE_ID	\fINull\fP
	highlight_inclusion	NAME_SET_ID	\fINull\fP
	highlight_exclusion	NAME_SET_ID	\fINull\fP
	invisibility_inclusion	NAME_SET_ID	\fINull\fP
	invisibility_exclusion	NAME_SET_ID	\fINull\fP
	HLHSR_mode	HLHSR_MODE	1
	NPC_subvolume	NPC_SUBVOLUME	{(0,0,0),(1,1,1)}
	viewport	VIEWPORT	{imp. dep., imp. dep., True}
.ta
.DE
.LP
The attributes of the renderer resource are defined as follows:

.Bl "pipeline_context_id"
This attribute specifies the resource id of the pipeline context
from which initial rendering pipeline attribute values will be copied whenever
a \fBPEXBeginRendering\fP request is executed.

.Bl "current_path"
This attribute contains a list of element references for
keeping track of paths for client-side traversal.

.Bl "renderer_state"
This attribute contains the current state of the renderer.  The
\fIrenderer_state\fP is set to \fIRendering\fP whenever a
\fBPEXBeginRendering\fP request is processed, and to \fIIdle\fP whenever a
\fBPEXEndRendering\fP request is processed.

.Bl "marker_bundle"
This attribute contains the resource id of the marker bundle lookup table
to be used when rendering.

.Bl "text_bundle"
This attribute contains the resource id of the text bundle lookup table to
be used when rendering.

.Bl "line_bundle	"
This attribute contains the resource id of the line bundle lookup table to
be used when rendering.

.Bl "interior_bundle"
This attribute contains the resource id of the interior bundle lookup table to
be used when rendering.

.Bl "edge_bundle"
This attribute contains the resource id of the edge bundle lookup table to
be used when rendering.

.Bl "view_table"
This attribute contains the resource id of the view lookup table to
be used when rendering.

.Bl "color_table"
This attribute contains the resource id of the color lookup table to
be used to resolve references to indexed colors.

.Bl "depth_cue_table"
This attribute contains the resource id of the depth-cue lookup table to
be used when rendering.

.Bl "light_table"
This attribute contains the resource id of the light lookup table to
be used when rendering.

.Bl "color_approx_table"
This attribute contains the resource id of the lookup table to
be used during the color approximation stage of the rendering pipeline.
The lookup table may either be of type \fIRGBApprox\fP or
\fIIntensityApprox\fP.  Definitions for both types of tables can
be found in the section dealing with lookup table requests.

.Bl "pattern_table"
This attribute contains the resource id of the lookup table to
be used when referencing patterns.

.Bl "text_font_table"
This attribute contains the resource id of the lookup table to
be used when referencing text fonts.

.Bl "highlight_inclusion"
This attribute contains the resource id of the name set to be used
as the highlight inclusion set.

.Bl "highlight_exclusion"
This attribute contains the resource id of the name set to be used
as the highlight exclusion set.

.Bl "invisibility_inclusion"
This attribute contains the resource id of the name set to be used
as the invisibility inclusion set.

.Bl "invisibility_exclusion"
This attribute contains the resource id of the name set to be used
as the invisibility exclusion set.

.Bl "HLHSR_mode"
This attribute contains the hidden line/hidden surface method
used when resolving visibility of overlapping primitives.
The effect of setting a renderer's \fIHLHSR_mode\fP while its
\fIrenderer_state\fP attribute is set to \fIRendering\fP
is implementation-dependent.

.Bl "NPC_subvolume"
This attribute contains the normalized project coordinates for the
sub-volume space that is to be mapped to the viewport.

.Bl "viewport"
This is used to describe the area within a drawable in which 3D graphics
primitives may appear.  The viewport coordinates are specified with an
x,y offset (in pixels) from the upper left corner of the drawable.
It is permissible to specify a viewport with boundaries outside of the
drawable.  Geometry that is mapped to values outside the drawable will
be clipped.
Viewport z values must be in the range [0-1.0], where z=0 maps to the
device-coordinate z value representing objects that are furthest from
the viewing position, and z=1 maps to the device-coordinate value representing
objects that are closest to the viewing position.
If the viewport's \fIuse_drawable\fP flag is set to \fITrue\fP and the
renderer is in the \fIIdle\fP state,
the new viewport \fImin\fP and \fImax\fP values
will be computed at the time of, and from the size of the drawable specified
in the next \fBPEXBeginRendering\fP request.
If the viewport's \fIuse_drawable\fP flag is set to \fITrue\fP and the
renderer is in the \fIRendering\fP state,
the new viewport \fImin\fP and \fImax\fP values
will be computed immediately
from the current size of the drawable associated
with the renderer.
In either of these two cases, min z and max z will be set to 0 and 1,
respectively, and
the viewport will be set to the largest rectangle, anchored at the
lower left corner, that achieves an isotropic mapping
to that renderer's \fINPC_subvolume\fP.
If the viewport's \fIuse_drawable\fP flag is \fIFalse\fP, the new viewport
\fImin\fP and \fImax\fP values are immediately
set to the specified values.
.bp

.AC "Renderer Resource Management" 2
.LP                   
The renderer is an X11 resource and carries all of the 
responsibilities and
access rights of X11 resources.  These requests manage the creation and
freeing of renderer resources.

.AC "Create Renderer" 3
.Fs
.Na PEXCreateRenderer
.Rq      
.Pa fp_format FLOAT_FORMAT
.Pa rdr_id RENDERER_ID
.Pa drawable_example DRAWABLE_ID
.Pa item_mask BITMASK
.Pa item_list LISTofVALUE
.Se
IDChoice, Drawable, PipelineContext, NameSet, LookupTable, FloatingPointFormat,
Value, Alloc, Match
.Ds                     
This request creates a renderer resource for the specified
\fIrdr_id\fP.  It can be used to render onto drawables with the
same root window and depth as the example drawable specified
by \fIdrawable_example\fP.
The \fIitem_mask\fP defines those renderer attributes
that are to be explicitly set at the time the resource is created.
The \fIitem_list\fP 
contains the corresponding
list of values used to modify the newly-created renderer.
Floating point values in \fIitem_list\fP will be in the floating
point format specified in \fIformat\fP.
.Fe


.AC "Free Renderer" 3
.Fs
.Na PEXFreeRenderer
.Rq                 
.Pa rdr_id RENDERER_ID
.Se
Renderer
.Ds
This request
deletes the specified renderer resource and frees the storage
associated with it.
If the renderer's \fIrenderer_state\fP attribute is set to \fIRendering\fP
when this request is processed, an implicit \fBPEXEndRendering\fP
request will be performed before the renderer is freed.
.Fe
.bp
.AC "Renderer Modification" 2
.LP
The requests in this section
can be used to modify attributes of renderer resources.
.AC "Change Renderer" 3
.Fs
.Na PEXChangeRenderer
.Rq
.Pa fp_format FLOAT_FORMAT
.Pa rdr_id RENDERER_ID
.Pa item_mask BITMASK
.Pa item_list LISTofVALUE
.Se
Renderer, Value, FloatingPointFormat, NameSet, LookupTable,
PipelineContext, Match
.Ds       
This request changes components of a renderer.  
The \fIitem_mask\fP and \fIitem_list\fP
specify which components are to be changed.
Each bit in the \fIitem_mask\fP indicates whether or not
there is a corresponding entry in the \fIitem_list\fP.
It is therefore possible
to modify one or many renderer attributes with a
\fBPEXChangeRenderer\fP request.
A renderer's \fIcurrent_path\fP and \fIrenderer_state\fP attribute are
read-only, therefore
attempts to modify it will be ignored.
Floating point values in \fIitem_list\fP will be in the floating
point format specified in \fIformat\fP.
.Fe

.AC "Renderer Inquiry" 2
.LP
The requests in this section can be used to
inquire renderer attributes.
.AC "Get Renderer Attributes" 3
.Fs
.Na PEXGetRendererAttributes
.Rq
.Pa fp_format FLOAT_FORMAT
.Pa rdr_id RENDERER_ID
.Pa item_mask BITMASK
.Re
.Pa item_list LISTofVALUE
.Se
Renderer, FloatingPointFormat
.Ds       
This request will return components of
the renderer specified by \fIrdr_id\fP.
The \fIitem_mask\fP specifies which components are to be inquired and returned.
The specified attributes of the renderer will be returned in
\fIitem_list\fP.
Floating point values in \fIitem_list\fP will be returned in the floating
point format specified in \fIformat\fP.
.Fe
.bp

.AC "Client-Side Traversal Support" 2
.LP
These requests provide support for client-side structure
traversal.  PEX currently provides only rendering support
for client-side traversal.  Picking and searching functionality
must be done by the client.

.AC "Begin Rendering" 3
.Fs
.Na PEXBeginRendering
.Rq
.Pa rdr_id RENDERER_ID
.Pa drawable_id DRAWABLE_ID
.Se
Renderer, Drawable, Match
.Ds 
This request causes rendering to begin on the drawable specified by
\fIdrawable_id\fP.  The output of the renderer specified by \fIrdr_id\fP
is bound to that drawable until a \fBPEXEndRendering\fP request is
processed.  The initial rendering pipeline attributes are copied into
the renderer
from the pipeline context specified by the renderer's \fIpipeline_context\fP
attribute.  If \fIpipeline_context\fP is \fINull\fP, the default values
for all of the attributes in a pipeline context are copied into the renderer
instead.  The
renderer's \fIrenderer_state\fP attribute is set to \fIRendering\fP and
its \fIcurrent_path\fP attribute is set to the null list.
.LP
If the specified drawable does not have the same root and depth as
the drawable that was passed in the request to create the renderer,
a Match error will be generated.
If the renderer's \fIrender_state\fP attribute is currently
set to \fIRendering\fP, an implicit \fIPEXEndRendering\fP request
is performed prior to executing the request.
.Fe


.AC "End Rendering" 3
.Fs
.Na PEXEndRendering
.Rq
.Pa rdr_id RENDERER_ID
.Se
Renderer
.Ds       
This request causes any pending output for the renderer specified
by \fIrdr_id\fP to be rendered onto the drawable.  The \fIrender_state\fP
attribute of the renderer is set to \fIIdle\fP.  (\fINote: the precise
semantics of how \fBPEXBeginRendering\fP and \fBPEXEndRendering\fP deal
with z-buffers and multi- or double-buffering are being deferred until
more progress is made for supporting multi- or double-buffering in the
X environment.)
.Fe
.bp

.AC "Begin Structure" 3
.Fs
.Na PEXBeginStructure
.Rq
.Pa rdr_id RENDERER_ID
.Pa s_id CARD32
.Se
Renderer
.Ds       
This request causes the rendering pipeline attributes in the
renderer specified by \fIrdr_id\fP to be saved.
The attributes of the renderer resource itself
(i.e., the
attributes of a renderer that can be set/queried,
including table and name set resource id's)
are not saved.
The element offset of the last entry in the renderer's
\fIcurrent_path\fP is incremented (to account for the
client-side "execute structure" command), then
the name specified by \fIs_id\fP together
with an element offset of zero is appended to the
\fIcurrent_path\fP attribute.  Each subsequent output command
will cause the element offset to be bumped by one until the
next \fBPEXBeginStructure\fP request or the next
\fBPEXEndStructure\fP request.
.LP
After saving the current rendering pipeline attributes,
the \fIglobal_transform\fP attribute is set
to the matrix computed by concatenating
the current \fIlocal_transform\fP and the
current \fIglobal_transform\fP matrices.  Then
the \fIlocal_transform\fP matrix is set
to the identity matrix.
.Fe



.AC "End Structure" 3
.Fs
.Na PEXEndStructure
.Rq
.Pa rdr_id RENDERER_ID
.Se
Renderer
.Ds       
This request restores the last-saved rendering pipeline attributes
in the renderer specified by \fIrdr_id\fP.
In addition, the last element reference in the renderer's \fIcurrent_path\fP
is removed, and subsequent output commands will cause the element
offset of the element reference at the end of the list to be incremented.
This request itself does not cause an increment to \fIcurrent_path\fP.
.Fe
.bp


.AC "Rendering Commands" 2
.LP
These requests cause output commands to be processed by a renderer.

.AC "Render Output Commands" 3
.Fs
.Na PEXRenderOutputCommands
.Rq
.Pa format FORMAT
.Pa rdr_id RENDERER_ID
.Pa cmds LISTofOUTPUT_CMD
.Se
Renderer, FloatingPointFormat, DirectColorFormat, Value
.Ds       
If the \fIrender_state\fP attribute of the
renderer specified by \fIrdr_id\fP is set to \fIRender\fP,
the output commands in \fIcmds\fP will be immediately processed.
If the \fIrender_state\fP attribute is set to \fIIdle\fP, the
commands will be ignored.
Floating point values in \fIcmds\fP will be in the floating
point format specified in \fIformat\fP.
Similarly, direct color values in \fIcmds\fP will be in the direct color
format specified in \fIformat\fP.
The formats for the various types of output commands
can be found in the "Output Commands" section.
.Fe



.AC "Render Network" 3
.Fs
.Na PEXRenderNetwork
.Rq
.Pa rdr_id RENDERER_ID
.Pa drawable_id DRAWABLE_ID
.Pa s_id STRUCTURE_ID
.Se
Renderer, Drawable, Structure
.Ds       
This request causes the structure network rooted at \fIs_id\fP
to be traversed and rendered on \fIdrawable_id\fP, using the renderer
specified by \fIrdr_id\fP.
.LP
This functionality is equivalent to the following (pseudo-)requests:
.ID
\fIPEXBeginRendering\fP(\fIr_id\fP, \fIdrawable_id\fP)
\fIPEXRenderOutputCmds\fP(execute structure(\fIs_id\fP))
\fIPEXEndRendering\fP(\fIr_id\fP)
.DE
.Fe
.bp


.AC "Structures" 1
.LP
.RU
.LP
This section details the usage and management of structure resources.
A structure is a resource which stores output commands for later
execution.
Structures have two settable attributes and a number of attributes
that can only be inquired.  The modifiable attributes are:

.Bl "element_ptr"
This attribute contains the offset of an element in the structure.
The element pointer
determines the position in the structure at which the next editing
or element query operation will occur.
Whenever a structure
is used as a destination in a structure editing
request, its element pointer attribute
will be updated as a side effect of the operation.

.Bl "editing_mode"
The editing mode attribute specifies how editing operations will affect
the structure.
If the mode is \fIStructureInsert\fP, 
subsequent requests to create structure elements
will cause elements to be inserted into
the structure.  Elements will be
\fIinserted\fP into the structure
\fIafter\fP the structure element specified by the
element pointer.  The element pointer will then be
incremented by the number of elements inserted.
If the mode is \fIStructureReplace\fP, output
requests used to create structure elements
will cause structure elements to
\fIreplace\fP elements starting at the location specified by the
element pointer.

.LP
A structure's non-modifiable attributes include its size
(number of elements and length in four byte units if it were to be
returned to the client) and the number of times it is
referenced by other structures.  Additional information
about structures (ancestors, descendants, etc.) is also available
and can be inquired separately.

.AC "Structure Resource Management" 2
.LP
A structure is an X11 resource and carries all of the 
responsibilities and
access rights of X11 resources.  These requests manage the creation,
deletion, and general manipulation of structures.


.AC "Create Structure" 3
.Fs
.Na PEXCreateStructure
.Rq                  
.Pa s_id STRUCTURE_ID
.Se
IDChoice, Alloc
.Ds      
This request creates a structure resource with the specified \fIs_id\fP.
.Fe
.bp
.AC "Copy Structure" 3
.Fs
.Na PEXCopyStructure
.Rq                  
.Pa src_s_id STRUCTURE_ID
.Pa dest_s_id STRUCTURE_ID
.Se
Structure
.Ds      
The structure elements in \fIsrc_s_id\fP are copied to \fIdest_s_id\fP.
Any structure elements in \fIdest_s_id\fP are deleted prior to the copy
operation.  The destination structure must already exist as a valid resource.
\fISrc_s_id\fP's element pointer and editing mode are also copied to
\fIdest_s_id\fP.
.Fe

.AC "Free Structure" 3
.Fs
.Na PEXFreeStructure
.Rq                  
.Pa s_id STRUCTURE_ID
.Se
Structure
.Ds      
This request deletes the association between the resource id
and the structure.  The structure storage will be
freed when no other resource references it.
.Fe

.AC "Delete Structures" 3
.Fs
.Na PEXDeleteStructures
.Rq                  
.Pa list LISTofSTRUCTURE_ID
.Pa delete_refs BOOLEAN
.Se
Structure, Value
.Ds 
This request effectively performs a \fIPEXFreeStructure\fP request
on each of the structures specified in \fIlist\fP.  In addition,
if \fIdelete_refs\fP is set to \fITrue\fP,
any structure element in any of the remaining structures
in the server that references one of the structures in \fIlist\fP will
be deleted.
Note: Any structure that has elements
deleted in this fashion will have its element pointer set to zero.

.Fe
.bp

.AC "Structure Inquiry" 2
.LP
These requests inquire attributes and other information about structures.

.AC "Get Structure Info" 3
.Fs
.Na PEXGetStructureInfo
.Rq
.Pa s_id STRUCTURE_ID
.Re
.Pa editing_mode EDIT_MODE
.Pa element_ptr CARD32
.Pa num_elements CARD32
.Pa total_length CARD32
.Pa num_refs CARD32
.Se
Structure
.Ds       
This request returns information about the structure specified by \fIs_id\fP.
The current value of the structure's editing mode attribute will be returned
in \fIediting_mode\fP. 
The current value of the structure's element pointer
attribute will be returned in \fIelement_ptr\fP.
The number of structure elements in the specified
structure will be returned in \fInum_elements\fP.
If the structure
is empty, \fInum_elements\fP will be zero.
The total number of four-byte units necessary to store
all elements of the structure (on the client side) will be returned
in \fItotal_length\fP.
(This provides the
client the information needed to allocate memory prior
to doing a \fBPEXFetchElements\fP request.)
The number of "execute structure" elements in other structure resources
in the server that reference \fIs_id\fP will
be returned in \fInum_refs\fP.
.Fe
.bp


.AC "Get Element Info" 3
.Fs
.Na PEXGetElementInfo
.Rq
.Pa s_id STRUCTURE_ID
.Pa range ELEMENT_RANGE
.Re
.Pa info LISTofELEMENT_INFO
.Se
Structure, Value
.Ds       
This request returns information about elements in
the structure specified by \fIs_id\fP.
The offsets that define the range of elements about which information is
to be obtained
are computed using the positions in \fIrange\fP in the following fashion.
If \fIwhence\fP is \fIBeginning\fP, the computed offset is just
the value specified by \fIoffset\fP.
If \fIwhence\fP is \fICurrent\fP, the offset is computed by adding
\fIoffset\fP to \fIs_id\fP's element pointer.
If \fIwhence\fP is \fIEnd\fP, the offset is computed
by adding \fIoffset\fP to the number of elements in the structure.
\fIOffset\fP can be a negative number.
.LP
If either computed offset is less than zero, it will be set to zero before
obtaining the element information.
If either computed offset is greater than the number
of elements in the structure, it will be set to the offset
of the last structure element in the structure.
The request returns each element's ELEMENT_TYPE field, and the length
of the element in units of four bytes.  The sum of the lengths of all
elements in the structure will be equal to the length that can be inquired with
the \fIPEXGetStructureInfo\fP request.
The element pointer attribute of \fIs_id\fP is not affected by this request.
.Fe
.bp

.AC "Get Structures In Network" 3
.Fs
.Na PEXGetStructuresInNetwork
.Rq
.Pa s_id STRUCTURE_ID
.Pa which "{\fIAll, Orphans\fP}"
.Re
.Pa structures LISTofSTRUCTURE_ID
.Se
Structure, Value
.Ds
This request returns a list of unique structure resource id's that are
referenced in the structure network rooted at \fIs_id\fP.
If \fIwhich\fP is \fIAll\fP, all of the structure resources
referenced in the structure network rooted at \fIs_id\fP will
be returned in the list \fIstructures\fP.
If \fIwhich\fP is \fIOrphans\fP, the id's of all of the structure resources
that would become orphans (no longer referenced should the network be
deleted) are returned.
.Fe
.AC "Get Ancestors" 3
.Fs
.Na PEXGetAncestors
.Rq
.Pa s_id STRUCTURE_ID
.Pa path_order "{\fITopFirst, BottomFirst\fP}"
.Pa path_depth CARD32
.Re
.Pa paths LISTofLISTofELEMENT_REF
.Se
Structure, Value
.Ds
This request returns all of the paths which reference the structure
specified by \fIs_id\fP.  At a minimum, each path will
contain an ELEMENT_REF with structure_id = \fIs_id\fP and offset = 0.
The \fIpath_depth\fP indicates the maximum length
of each LISTofELEMENT_REF, except that \fIpath_depth\fP = 0 means
that the full path is to be returned.  The \fIpath_order\fP indicates how
each LISTofELEMENT_REF is to be ordered.
If \fIpath_order\fP = \fITopFirst\fP, each path that is returned in
\fIpaths\fP will begin with the root structure of the structure network
that contains \fIs_id\fP.
If \fIpath_order\fP = \fIBottomFirst\fP, each path that is returned in
\fIpaths\fP will begin with \fIs_id\fP and proceed up the structure
network tree until the root structure is reached.
.LP
For instance, specifying \fIpath_depth\fP = 0 and \fIpath_order\fP =
\fITopFirst\fP would cause all paths to \fIs_id\fP to be returned in
the order that they would be traversed.  
Specifying \fIpath_depth\fP = 1 and \fIpath_order\fP =
\fITopFirst\fP would cause all the structures at the top of each structure
network containing \fIs_id\fP to be returned.
Specifying \fIpath_depth\fP = 2 and \fIpath_order\fP =
\fIBottomFirst\fP would cause all the parents of
\fIs_id\fP to be returned.
Specifying \fIpath_depth\fP = 1 and \fIpath_order\fP =
\fIBottomFirst\fP could be used to determine the number of references
to \fIs_id\fP.
.Fe
.bp

.AC "Get Descendants" 3
.Fs
.Na PEXGetDescendants
.Rq
.Pa s_id STRUCTURE_ID
.Pa path_order "{\fITopFirst, BottomFirst\fP}"
.Pa path_depth CARD32
.Re
.Pa paths LISTofLISTofELEMENT_REF
.Se
Structure, Value
.Ds
This request returns all of the paths which are referenced by the structure
specified by \fIs_id\fP.  At a minimum, each path will
contain an ELEMENT_REF with a structure_id equal to the
bottom-most element of the path and an offset of zero.
The \fIpath_depth\fP indicates the maximum length
of each LISTofELEMENT_REF, except that \fIpath_depth\fP = 0 means
that the full path is to be returned.  The \fIpath_order\fP indicates how
each LISTofELEMENT_REF is to be ordered.
If \fIpath_order\fP = \fITopFirst\fP, each path that is returned in
\fIpaths\fP will begin with the structure specified by \fIs_id\fP.
If \fIpath_order\fP = \fIBottomFirst\fP, each path that is returned in
\fIpaths\fP will begin with the structure that is a leaf node in
the structure network tree that is rooted at \fIs_id\fP.
.LP
For instance, specifying \fIpath_depth\fP = 0 and \fIpath_order\fP =
\fITopFirst\fP would cause all paths from \fIs_id\fP to the leaf
nodes in the structure network tree to be returned in
the order that they would be traversed.  
Specifying \fIpath_depth\fP = 2 and \fIpath_order\fP =
\fITopFirst\fP would cause all the children of
\fIs_id\fP to be returned.
Specifying \fIpath_depth\fP = 1 and \fIpath_order\fP =
\fIBottomFirst\fP could be used to determine all of the bottom-most
structures of the structure network rooted at \fIs_id\fP.
.Fe
.bp
.AC "Fetch Elements" 3
.Fs
.Na PEXFetchElements
.Rq
.Pa format FORMAT
.Pa s_id STRUCTURE_ID
.Pa range ELEMENT_RANGE
.Re
.Pa elements LISTofOUTPUT_CMD
.Se
Structure, FloatingPointFormat, DirectColorFormat
.Ds       
This request returns a range of structure elements
in the structure specified by \fIs_id\fP.
The offsets that define the range of elements to be fetched
are computed using the positions in \fIrange\fP in the following fashion.
If \fIwhence\fP is \fIBeginning\fP, the computed offset is just
the value specified by \fIoffset\fP.
If \fIwhence\fP is \fICurrent\fP, the offset is computed by adding
\fIoffset\fP to \fIs_id\fP's element pointer.
If \fIwhence\fP is \fIEnd\fP, the offset is computed
by adding \fIoffset\fP to the number of elements in the structure.
\fIOffset\fP can be a negative number.
.LP
If either computed offset is less than zero, it will be set to zero before
the fetch occurs.  If either computed offset is greater than the number
of elements in the source structure, it will be set to the offset
of the last structure element in the source structure.
The element pointer attribute of \fIs_id\fP is not affected by the
fetch operation.
The data for each structure element will be returned in
the same format as described in the "Output Commands" section.
.LP
Floating point values in \fIelements\fP will be returned in the floating
point format specified in \fIformat\fP (if it is supported by the PEX
implementation).
Similarly, direct color values in \fIelements\fP will be returned
in the direct color
format specifed by \fIformat\fP.
.Fe
.bp

.AC "Structure Resource Attribute Modification" 2
.LP
This section contains requests that can be used to modify structure resource
attributes.

.AC "Set Editing Mode" 3
.Fs
.Na PEXSetEditingMode
.Rq                  
.Pa s_id STRUCTURE_ID
.Pa mode EDIT_MODE
.Se
Structure, Value
.Ds 
This request modifies \fIs_id\fP's editing mode attribute.
The editing mode attribute specifies how editing operations will affect
the structure.
If the editing mode is set to \fIStructureInsert\fP, 
subsequent requests to create structure elements
will cause elements to be inserted into
the structure.  Elements will be
\fIinserted\fP into the structure
\fIafter\fP the structure element specified by the
element pointer.  The element pointer will then be
incremented by the number of elements inserted.
If the mode is \fIStructureReplace\fP, output
requests used to create structure elements
will cause structure elements to
\fIreplace\fP elements starting at the location specified by the
element pointer.
.Fe


.AC "Set Element Pointer" 3
.Fs
.Na PEXSetElementPointer
.Rq           
.Pa s_id STRUCTURE_ID
.Pa position ELEMENT_POS
.Se
Structure, Value
.Ds       
This request
sets the element pointer attribute of the structure specified by \fIs_id\fP.
The element pointer attribute of the structure will be set to
the position specified by \fIposition\fP, which contains a \fIwhence\fP
and \fIoffset\fP pair.
If \fIwhence\fP is \fIBeginning\fP, the element pointer is set to
the specified \fIoffset\fP.
If \fIwhence\fP is \fICurrent\fP, the new element pointer value
is computed by adding \fIoffset\fP
to the current value of the element pointer.
If \fIwhence\fP is \fIEnd\fP, the new element pointer value
is computed by adding the specified \fIoffset\fP
to the offset of the last element in the structure.
\fIOffset\fP can be a negative number.
.LP            
If the resultant value of the element pointer
is less than zero, the element pointer is set to zero.  If the resultant value
of the element pointer 
is greater than the
number of elements in the structure, then the element pointer
is set to the offset of the last element in the structure.
.Fe            
.bp


.AC "Set Element Pointer At Label" 3
.Fs
.Na PEXSetElementPointerAtLabel
.Rq
.Pa s_id STRUCTURE_ID
.Pa label CARD32
.Pa offset INT32
.Se
Structure, Label
.Ds
This request
sets the element pointer attribute of the structure specified by \fIs_id\fP.
A search is conducted for
the next occurence of a "label" structure element containing \fIlabel\fP.
The search for the label starts
at the current element pointer plus one, and proceeds in the forward direction.
If a "label" structure element containing \fIlabel\fP is found,
the element pointer for the structure is set
to the offset of the located label plus \fIoffset\fP.
If no occurence of the specified label is found, the structure's
element pointer is left unchanged.
.Fe
.bp

.AC "Element Search" 3
.Fs
.Na PEXElementSearch
.Rq
.Pa s_id STRUCTURE_ID
.Pa position ELEMENT_POS
.Pa direction "{\fIForward, Backward\fP}"
.Pa incl LISTofELEMENT_TYPE
.Pa excl LISTofELEMENT_TYPE
.Re
.Pa status "{\fIFound, NotFound\fP}"
.Pa found_offset CARD32
.Se
Structure, Value
.Ds
This request conducts a search
for the first occurrence of the specified
element type in the structure specified by \fIs_id\fP.
The offset at which to begin searching is computed using the
\fIwhence\fP and \fIoffset\fP found in \fIposition\fP.
If \fIwhence\fP is \fIBeginning\fP, the search will begin at
the element specified by \fIoffset\fP.
If \fIwhence\fP is \fICurrent\fP, the specified \fIoffset\fP
is added to the current value of \fIs_id\fP's element pointer to determine
the element at which to begin the search.
If \fIwhence\fP is \fIEnd\fP, the element at which to begin the search
is computed by adding the specified \fIoffset\fP
to the offset of the last element in the structure.
\fIOffset\fP can be a negative number.
.LP
If the computed offset is less than zero, the search will begin at
the first element in the structure.
If the computed offset
is greater than the
number of elements in the structure, then the search will begin at
the last element in the structure.
The search always includes the starting element.
.LP
An element will be selected if its element type is not contained in
\fIexcl\fP
and its element type is included in 
\fIincl\fP.
An element type of \fIAll\fP causes all element types to match.
If a
structure element type is in both the inclusion and exclusion sets, it will
be excluded.
.LP
The search terminates if a match is found or
if the limits of the structure are reached.  The search progresses from
the start point and proceeds either forward in the structure or backward,
depending on \fIdirection\fP.
This is a non-descending search (i.e., the search does not include
any structures referenced by "execute structure" elements).
If the search succeeds in finding a match, a status of \fIFound\fP is
returned, and the offset of the matching element is returned in
\fIfound_offset\fP.
If the search is unsuccessful, a status of \fINotFound\fP is
returned, and a value of zero is returned in
\fIfound_offset\fP.
.LP
The element pointer attribute of \fIs_id\fP
is updated to point to the selected element if a match was found, the
first element in the structure if the direction was \fIBackward\fP and
no match was found, or the last element in the structure if the direction
was \fIForward\fP and no match was found.
.Fe
.bp

.AC "Structure Editing" 2
.LP
This section contains requests that can be used to modify structure resources.


.AC "Store Elements" 3
.Fs
.Na PEXStoreElements
.Rq
.Pa format FORMAT
.Pa s_id STRUCTURE_ID
.Pa elements LISTofOUTPUT_CMD
.Se
Structure, FloatingPointFormat, DirectColorFormat, Value
.Ds       
This request causes elements to be stored in the
structure whose resource id is specified by \fIs_id\fP.
If the \fIediting_mode\fP attribute of the structure is
set to \fIStructureInsert\fP, each entry
in \fIelements\fP is used to create a structure element
in the structure after the element specified
by the structure's \fIelement_ptr\fP attribute.
The element pointer is
incremented by one for each such insertion.  Therefore,
at the conclusion of the request, the element pointer is
left pointing at the last inserted element.
.LP
If the \fIediting_mode\fP attribute is
set to \fIStructureReplace\fP, a range of elements is
first deleted from the structure.  The number of elements
deleted is equal to the number of output commands in
\fIelements\fP.  If there are fewer elements between
the structure's element pointer and the end of the structure
than there are output commands in \fIelements\fP, then
only the elements between the element pointer and the
end of the structure will be deleted.
The element pointer
will be left pointing at the element preceding the deleted
range.
After the deletion,
the output commands specified in \fIelements\fP are 
inserted at the element pointer position as described above.
.LP
Floating point values in \fIelements\fP will be in the floating
point format specified in \fIformat\fP.
Similarly, direct color values in \fIelements\fP will be in the direct color
format specified in \fIformat\fP.
The formats for the various types of output commands
can be found in the "Output Commands" section.
.Fe
.bp

.AC "Delete Elements" 3
.Fs
.Na PEXDeleteElements
.Rq
.Pa s_id STRUCTURE_ID
.Pa range ELEMENT_RANGE
.Se
Structure, Value
.Ds                              
This request
deletes elements in \fIrange\fP from
the structure whose id is specified in \fIs_id\fP.
The range of elements to be deleted is computed using
the \fIwhence\fP and \fIoffset\fP values of \fIposition1\fP and
\fIposition2\fP.
.LP
The offsets that define the range of elements to be deleted
are each computed using the positions in \fIrange\fP in the following fashion.
If \fIwhence\fP is \fIBeginning\fP, the computed offset is just
the value specified by \fIoffset\fP.
If \fIwhence\fP is \fICurrent\fP, the offset is computed by adding
\fIoffset\fP to \fIs_id\fP's element pointer.
If \fIwhence\fP is \fIEnd\fP, the offset is computed
by adding \fIoffset\fP to the number of elements in the structure.
\fIOffset\fP can be a negative number.
.LP
If either computed offset is less than zero, it will be set to zero before
the deletion occurs.  If either computed offset is greater than the number
of elements in the structure, it will be set to the offset
of the last structure element.
It is not necessary for the first offset to be less than the second.
The deletion is inclusive, meaning that
the elements at the boundary of the deletion range are also deleted.
Deleting element zero
is effectively a noop.
After the deletion operation, the structure's element pointer
will be set to the element
preceding the range of deleted elements.
.Fe
.bp


.AC "Delete Elements To Label" 3
.Fs
.Na PEXDeleteElementsToLabel
.Rq
.Pa s_id STRUCTURE_ID
.Pa position ELEMENT_POS
.Pa label CARD32
.Se
Structure, Label, Value
.Ds
This request deletes all elements between a computed offset and
a specified \fIlabel\fP in the structure whose id is specified in \fIs_id\fP.
The offset is computed using \fIposition\fP in the following fashion.
If \fIwhence\fP is \fIBeginning\fP, the computed offset is just
the value specified by \fIoffset\fP.
If \fIwhence\fP is \fICurrent\fP, the offset is computed by adding
\fIoffset\fP to \fIs_id\fP's element pointer.
If \fIwhence\fP is \fIEnd\fP, the offset is computed
by adding \fIoffset\fP to the number of elements in the structure.
\fIOffset\fP can be a negative number.
.LP
If the computed offset is less than zero, it will be set to zero before
the deletion occurs.  If the computed offset is greater than the number
of elements in the structure, it will be set to the offset
of the last structure element.
Elements are deleted starting at the element immediately after the computed
offset up to the
next occurrence of the \fIlabel\fP.
The label itself is not deleted.  The
structure's element pointer is set to point at the element immediately
preceding the range of deleted elements.
If the specified label is not found, no deletion occurs and the
structure's element pointer is left unchanged.
.Fe

.AC "Delete Elements Between Labels" 3
.Fs
.Na PEXDeleteElementsBetweenLabels
.Rq
.Pa s_id STRUCTURE_ID
.Pa label1 CARD32
.Pa label2 CARD32
.Se
Structure, Label
.Ds
This request
deletes all elements between \fIlabel1\fP and \fIlabel2\fP
in the structure whose id is specified in \fIs_id\fP.
A search for
\fIlabel1\fP is first performed starting at the element whose offset
is specified by the structure's element pointer.  A search
for \fIlabel2\fP is then performed, starting at the element after
\fIlabel1\fP.  The range of elements between the two labels is then
deleted.
The two label elements themselves are not deleted.  The
structure's element pointer is set to point at the element immediately
preceding the range of deleted elements (the element containing \fIlabel1\fP).
.LP
If either of the two specified labels is not found between starting
point of the search and the end of the structure,
no deletion occurs and the
structure's element pointer is left unchanged.
.Fe
.bp


.AC "Copy Elements" 3
.Fs
.Na PEXCopyElements
.Rq
.Pa src_s_id STRUCTURE_ID
.Pa src_range ELEMENT_RANGE
.Pa dest_s_id STRUCTURE_ID
.Pa dest_position ELEMENT_POS
.Se
Structure, Value
.Ds       
This request copies elements in \fIsrc_range\fP from
from the structure specified in \fIsrc_s_id\fP
to the \fIdest_position\fP in the structure specified in \fIdest_s_id\fP.
The range of elements to be copied is computed using
the \fIwhence\fP and \fIoffset\fP values of \fIposition1\fP and
\fIposition2\fP in \fIsrc_range\fP.
.LP
The offsets that define the range of elements to be copied
are each computed using the positions in
\fIsrc_range\fP in the following fashion.
If \fIwhence\fP is \fIBeginning\fP, the computed offset is just
the value specified by \fIoffset\fP.
If \fIwhence\fP is \fICurrent\fP, the offset is computed by adding
\fIoffset\fP to \fIsrc_s_id\fP's element pointer.
If \fIwhence\fP is \fIEnd\fP, the offset is computed
by adding \fIoffset\fP to the number of elements in the structure.
\fIOffset\fP can be a negative number.
.LP
If either computed offset is less than zero, it will be set to zero before
the copy occurs.  If either computed offset is greater than the number
of elements in the source structure, it will be set to the offset
of the last structure element in the source structure.
.LP
The position to which the elements will be copied is computed using
\fIdest_position\fP in the following fashion.
If \fIwhence\fP is \fIBeginning\fP, the computed destination offset is just
the value specified by \fIoffset\fP.
If \fIwhence\fP is \fICurrent\fP, the offset is computed by adding
\fIoffset\fP to \fIdest_s_id\fP's element pointer.
If \fIwhence\fP is \fIEnd\fP, the offset is computed
by adding \fIoffset\fP to the number of elements in the destination structure.
\fIOffset\fP can be a negative number.
.LP
It is permissible for \fIsrc_s_id\fP and \fIdest_s_id\fP to be the same.
If this is the case, the copy operation performs
as if the indicated range is copied to a temporary location,
and then inserted relative to the destination position.
.LP
After the copy operation, the destination structure's element pointer
is updated to point at the last element inserted in the destination
structure.  The editing mode attribute of \fIdest_s_id\fP is ignored
during this request - copied elements are always inserted into the
destination structure, never used to replace existing structure elements.
.Fe
.bp


.AC "Change Structure References" 3
.Fs
.Na PEXChangeStructureReferences
.Rq
.Pa old_s_id STRUCTURE_ID
.Pa new_s_id STRUCTURE_ID
.Se
Structure
.Ds              
This request changes any "execute structure" elements in the server
that reference the structure specified by
\fIold_s_id\fP into "execute structure" elements that 
reference the structure specified by
\fInew_s_id\fP.
.LP
Any references to the structure \fInew_s_id\fP that existed before this
request are not affected.  If there were references to the structure
resource specified by \fIold_s_id\fP and the structure resource specified by
\fInew_s_id\fP does not exist, an error is returned and no action is taken.
.Fe
.bp                                                     
.AC "Name Sets" 1
.LP
.RU
.LP
A \fIname set\fP is a PEX resource that is used to filter output
commands during rendering, picking, and searching operations.
Name sets
are fairly lightweight resources, but they are of variable size
so can vary depending on their contents.

.AC "Name Set Resource Management" 2
.LP                   
The name set is an X11 resource and carries all of the 
responsibilities and
access rights of X11 resources.  These requests manage the creation,
freeing, and copying of name set resources.

.AC "Create Name Set" 3
.Fs
.Na PEXCreateNameSet
.Rq      
.Pa ns_id NAME_SET_ID
.Se
IDChoice, Alloc
.Ds                     
This request creates a name set resource for the specified
\fIns_id\fP.  The name set is initialized to an empty list when
the resource is created.
.Fe




.AC "Copy Name Set" 3
.Fs
.Na PEXCopyNameSet
.Rq                 
.Pa src_ns_id NAME_SET_ID
.Pa dest_ns_id NAME_SET_ID
.Se
NameSet
.Ds            
This request copies the source name set
\fIsrc_ns_id\fP to a destination name set \fIdest_ns_id\fP
after first emptying the contents of \fIdest_ns_id\fP.
The \fIdest_ns_id\fP must already exist as a valid resource.
.Fe
.bp


.AC "Free Name Set" 3
.Fs
.Na PEXFreeNameSet
.Rq                 
.Pa ns_id NAME_SET_ID
.Se
NameSet
.Ds            
This request deletes the association between the resource id
and the name set.  The name set storage will be
freed when no other resource references it.
.Fe
.bp

.AC "Name Set Inquiry" 2
.LP
These requests inquire name set resource attributes.

.AC "Get Name Set" 3
.Fs
.Na PEXGetNameSet
.Rq
.Pa ns_id NAME_SET_ID
.Re
.Pa names LISTofNAME
.Se
NameSet
.Ds       
This request will return the contents of the name set specified by
\fIns_id\fP.
.Fe




.AC "Name Set Modification" 2
.LP
These requests can be used to modify the contents of name set resources.

.AC "Change Name Set" 3
.Fs
.Na PEXChangeNameSet
.Rq
.Pa ns_id NAME_SET_ID
.Pa action "{\fIReplace, Add, Remove\fP}"
.Pa names LISTofNAME
.Se
NameSet, Value
.Ds       
This request changes the contents of a name set resource.
If \fIaction\fP is \fIAdd\fP, the specified list of names
is added to the name set.
If \fIaction\fP is \fIRemove\fP, the specified list of names
is removed from the name set.
If \fIaction\fP is \fIReplace\fP, all the names in the name set are
removed, then the specified list of names
is added to the name set.
.Fe
.bp
.AC "Search Contexts" 1
.LP
.RU
.LP
A \fIsearch context\fP is a PEX resource that allows clients
to perform searching operations on structure networks.
Search contexts
are lightweight resources.
This section
describes the operations that can be performed
on search context resources
and the operations that can be performed using search context resources.
PEX currently provides no support for searching of client-side
structure networks.
.LP
Some of the requests in this section affect attributes of a search
context.
The \fIitem_mask\fP and \fIitem_list\fP parameters
specify which components are to be affected.
Each bit in the \fIitem_mask\fP indicates whether or not
the corresponding attribute is affected.  In the cases where
search context attributes are being set or queried,
there is a corresponding entry in the \fIitem_list\fP
for each set bit in \fIitem_mask\fP.
It is therefore possible
to affect one or many search context attributes with a single request.
.LP
Some of the attributes in a search context
are references to other resources.  In general, the semantics of
dealing with references to nonexistent resources is implementation-dependent.
"Reasonable" implementations might choose to treat references to
nonexistent name sets resources as though they were references to a
name set resource that contains a null name list.
Also, the resource id returned when such an attribute is queried
is not guaranteed to be valid, since the resource with that id
may already have been freed.  It is up to the client to manage
all references to a resource when it is freed so that this situation
does not occur.
.LP
The search context components, in order, are listed in the following table.
.ID
.ta 0.05i 2.1i 3.5i
	\fBAttribute Name	Data Type	Default Value\fP
.ta
.ta 0.2i 1.9i 3.7i
	search_pos	COORD_3D	(0,0,0)
	search_dist	FLOAT	0
	search_ceiling	CARD16	0
	start_path	LISTofELEMENT_REF	\fINull\fP
	incl_list	LISTofNAME_SET_ID	\fINull\fP
	excl_list	LISTofNAME_SET_ID	\fINull\fP
.ta
.DE
The attributes of the search context resource are defined as follows:

.Bl "search_pos"
This attribute specifies the search reference position in world coordinates.

.Bl "search_dist"
This attribute specifies a distance from the search reference position.
A successful search occurs only when an output primitive element is found
that satisfies the search filter criteria \fIand\fP is within the
specified distance from the search reference point.

.Bl "search_ceiling"
This attribute defines the ceiling of the search operation.
The search ceiling is an index into the list contained in \fIstart_path\fP.
Searching stops when the end of the structure specified by
\fIsearch_ceiling\fP is reached.
If the ceiling is zero, the search operates without
a ceiling.

.Bl "start_path"
This attribute defines the structure network path that is to be used
as the starting point for the search.  Searching begins at the element
\fIfollowing\fP the one indicated by the start path.

.Bl "incl_list"
This attribute contains the list of name set resource id's to
be used as inclusion sets in the search operation.

.Bl "excl_list"
This attribute contains the list of name set resource id's to
be used as exclusion sets in the search operation.
.bp
.bp

.AC "Search Context Resource Management" 2
.LP                   
The search context is an X11 resource and carries all of the 
responsibilities and
access rights of X11 resources.  These requests manage the creation,
freeing, and copying of search contexts.

.AC "Create Search Context" 3
.Fs
.Na PEXCreateSearchContext
.Rq      
.Pa fp_format FLOAT_FORMAT
.Pa sc_id SEARCH_CONTEXT_ID
.Pa item_mask BITMASK
.Pa item_list LISTofVALUE
.Se
IDChoice, Value, FloatingPointFormat, Alloc
.Ds                     
This request creates a search context resource for the specified
\fIsc_id\fP.  
The \fIitem_mask\fP defines those search context attributes
that are to be explicitly set at the time the resource is created.
The \fIitem_list\fP 
contains the corresponding
list of values used to modify the newly-created search context.
Floating point values in \fIitem_list\fP will be in the floating
point format specified in \fIformat\fP.
.Fe




.AC "Copy Search Context" 3
.Fs
.Na PEXCopySearchContext
.Rq                 
.Pa src_sc_id SEARCH_CONTEXT_ID
.Pa dest_sc_id SEARCH_CONTEXT_ID
.Pa item_mask BITMASK
.Se
SearchContext
.Ds            
This request copies the source search context
\fIsrc_sc_id\fP to a destination search context \fIdest_sc_id\fP.
The \fIdest_sc_id\fP must already exist as a valid resource.
The \fIitem_mask\fP     
indicates which values
in the search context will be copied.
.Fe
.bp


.AC "Free Search Context" 3
.Fs
.Na PEXFreeSearchContext
.Rq                 
.Pa sc_id SEARCH_CONTEXT_ID
.Se
SearchContext
.Ds            
This request
deletes the specified search context resource and frees the storage
associated with it.
.Fe
.bp
.AC "Search Context Inquiry" 2
.LP
The requests in this section can be used to
inquire search context attributes.

.AC "Get Search Context" 3
.Fs
.Na PEXGetSearchContext
.Rq
.Pa fp_format FLOAT_FORMAT
.Pa sc_id SEARCH_CONTEXT_ID
.Pa item_mask BITMASK
.Re
.Pa item_list LISTofVALUE
.Se
SearchContext, FloatingPointFormat
.Ds       
This request will return components of
the search context specified by \fIsc_id\fP.
The \fIitem_mask\fP specifies which components are to be inquired and returned.
The specified attributes of the search context will be returned in
\fIitem_list\fP.
Floating point values in \fIitem_list\fP will be returned in the floating
point format specified in \fIformat\fP.
.Fe

.AC "Search Context Modification" 2
.LP
The requests in this section can be used to
modify attributes of search context resources.

.AC "Change Search Context" 3
.Fs
.Na PEXChangeSearchContext
.Rq
.Pa fp_format FLOAT_FORMAT
.Pa sc_id SEARCH_CONTEXT_ID
.Pa item_mask BITMASK
.Pa item_list LISTofVALUE
.Se
SearchContext, Value, FloatingPointFormat
.Ds       
This request changes components of a search context.  
The \fIitem_mask\fP and \fIitem_list\fP
specify which components are to be changed.
Each bit in the \fIitem_mask\fP indicates whether or not
there is a corresponding entry in the \fIitem_list\fP.
It is therefore possible
to modify one or many search context attributes with a
\fBPEXChangeSearchContext\fP request.
Floating point values in \fIitem_list\fP will be in the floating
point format specified in \fIformat\fP.
.Fe
.bp

.AC "Structure Network Searching" 2
.LP
This section describes requests that use search context resources to
perform structure network searching operations.

.AC "Search Network" 3
.Fs
.Na PEXSearchNetwork
.Rq
.Pa sc_id SEARCH_CONTEXT_ID
.Re
.Pa found_path LISTofELEMENT_REF
.Se
SearchContext
.Ds       
This request causes a spatial search in world coordinates
to be performed on a structure
network.  The parameters of the searching operation are found in the
search context \fIsc_id\fP.
The search begins at the element \fIfollowing\fP
the one indicated by the \fIstart_path\fP attribute of \fIsc_id\fP.
The search is terminated once the end of the structure indicated
by \fIsearch_ceiling\fP has been reached.
The first element that meets the search criteria is returned in
\fIfound_path\fP.  If no element is found, \fIfound_path\fP will be
null.  After the search has completed, the \fIstart_path\fP attribute
of \fIsc_id\fP will be set to the value that is returned in \fIfound_path\fP.
.Fe
.bp

.AC "PHIGS Workstations" 1
.LP
.RU
.LP
A \fIPHIGS workstation\fP is a PEX resource that combines
other resources into a single entity that behaves in a manner
similar to the PHIGS abstraction of a "workstation".
The PHIGS workstation has built into it all of the capabilities
of the renderer resource described earlier.  A PHIGS workstation,
with its lookup tables and name sets, effectively contains an
instance of a renderer, but it contains functionality above and
beyond that found in a renderer resource.
.LP
This section
describes the operations that can be performed
on PHIGS workstation resources
and the operations that can be performed using PHIGS workstation resources.
In addition to the
attributes listed below, the PHIGS workstation resource also
contains an implementation-dependent number of 
pick device descriptors that support picking operations.
These can be set and queried with
requests found in the next section, "Picking".
.AC "PHIGS Workstation Resource Management" 2
.LP                   
The PHIGS workstation is an X11 resource and carries all of the 
responsibilities and
access rights of X11 resources.  These requests manage the creation,
freeing, and copying of PHIGS workstation resources.
.AC "Create PHIGS Workstation" 3
.Fs
.Na PEXCreatePhigsWKS
.Rq 
.Pa wks_id PHIGS_WKS_ID
.Pa drawable_id DRAWABLE_ID
.Pa line_bundle LOOKUP_TABLE_ID
.Pa marker_bundle LOOKUP_TABLE_ID
.Pa text_bundle LOOKUP_TABLE_ID
.Pa interior_bundle LOOKUP_TABLE_ID
.Pa edge_bundle LOOKUP_TABLE_ID
.Pa color_table LOOKUP_TABLE_ID
.Pa pattern_table LOOKUP_TABLE_ID
.Pa text_font_table LOOKUP_TABLE_ID
.Pa depth_cue_table LOOKUP_TABLE_ID
.Pa light_table LOOKUP_TABLE_ID
.Pa color_approx_table LOOKUP_TABLE_ID
.Pa highlight_incl NAME_SET_ID
.Pa highlight_excl NAME_SET_ID
.Pa invis_incl NAME_SET_ID
.Pa invis_excl NAME_SET_ID
.Se
IDChoice, Drawable, Match, LookupTable, NameSet, Alloc
.Ds                     
This request creates a PHIGS workstation resource for the specified
\fIwks_id\fP.  
The drawable specified by \fIdrawable_id\fP is associated with
the newly-created PHIGS workstation resource.
The named tables and namesets are also bound to the PHIGS workstation
resource for use during rendering.
A view table that supports current and requested view table entries
is allocated for the PHIGS workstation automatically at creation time.
The requests \fBPEXSetViewRep\fP and \fBPEXGetViewRep\fP can be used
to modify and query the PHIGS workstation view table.
.Fe
.bp

.AC "Free PHIGS Workstation" 3
.Fs
.Na PEXFreePhigsWKS
.Rq                 
.Pa wks_id PHIGS_WKS_ID
.Se
PhigsWKS
.Ds            
This request deletes the
PHIGS workstation resource
and frees the storage associated with it.
.Fe
.bp

.AC "PHIGS Workstation Inquiry" 2
.LP
This section defines requests that can be used to get information
about a PHIGS workstation resource.

.AC "Get PHIGS Workstation Info" 3
.Fs
.Na PEXGetWKSInfo
.Rq                 
.Pa fp_format FLOAT_FORMAT
.Pa wks_id PHIGS_WKS_ID
.Pa item_mask BITMASK
.Re
.Pa item_list LISTofVALUE
.Se
PhigsWKS, FloatingPointFormat
.Ds
This request returns attributes of the PHIGS workstation
resource indicated by \fIwks_id\fP.  Floating point values will be returned
in the floating point format specified by \fIformat\fP.  The parameter
\fIitem_mask\fP indicates which attributes are to be returned.  For each
bit that is set in \fIitem_mask\fP, a corresponding value is returned
in \fIitem_list\fP.
.LP
In the table below, the abbreviation
"create wks req." indicates that the parameter is set by the
\fBPEXCreatePhigsWKS\fP request.
The abbreviation
"imp. dep." means that the default value is implementation-dependent.
The attributes that may be returned, in order, are:
.ID
.ta 0.2i 1.9i 3.5i
	\fBAttribute Name	Data Type	Default\fP
.ta
.ta 0.3i 1.7i 3.3i
	display_update	DISPLAY_UPDATE	\fIVisualizeNone\fP
	visual_state	VISUAL_STATE	\fICorrect\fP
	display_surface	DISPLAY_STATE	\fIEmpty\fP
	view_update	UPDATE_STATE	\fINotPending\fP
	defined_views	LISTofTABLE_INDEX	View 0 defined
	wks_update	UPDATE_STATE	\fINotPending\fP
	req_NPC_subvolume	NPC_SUBVOLUME	(0,0,0),(1,1,1)
	cur_NPC_subvolume	NPC_SUBVOLUME	(0,0,0),(1,1,1)
	req_wks_viewpt	VIEWPORT	{imp. dep., imp. dep., True}
	cur_wks_viewpt	VIEWPORT	{imp. dep., imp. dep., True}
	HLHSR_update	UPDATE_STATE	\fINotPending\fP
	req_HLHSR_mode	HLHSR_MODE	1
	cur_HLHSR_mode	HLHSR_MODE	1
	drawable_id	DRAWABLE_ID	create wks req.
	line_bundle	LOOKUP_TABLE_ID	create wks req.
	marker_bundle	LOOKUP_TABLE_ID	create wks req.
	text_bundle	LOOKUP_TABLE_ID	create wks req.
	interior_bundle	LOOKUP_TABLE_ID	create wks req.
	edge_bundle	LOOKUP_TABLE_ID	create wks req.
	color_table	LOOKUP_TABLE_ID	create wks req.
	pattern_table	LOOKUP_TABLE_ID	create wks req.
	text_font_table	LOOKUP_TABLE_ID	create wks req.
	depth_cue_table	LOOKUP_TABLE_ID	create wks req.
	light_table	LOOKUP_TABLE_ID	create wks req.
	color_approx_table	LOOKUP_TABLE_ID	create wks req.
	highlight_incl	NAME_SET_ID	create wks req.
	highlight_excl	NAME_SET_ID	create wks req.
	invis_incl	NAME_SET_ID	create wks req.
	invis_excl	NAME_SET_ID	create wks req.
	posted_structs	LISTofSTRUCTURE_ID	\fINull\fP
.DE

.Bl "display_update"
Returns the PHIGS workstation's current display update mode.  This mode
specifies how the PHIGS workstation attempts to visualize changes,
and can be set with the \fBPEXSetDisplayUpdateMode\fP request.

.Bl "visual_state"
Returns the PHIGS workstation's current visual state.  The visual state
will be \fICorrect\fP if there are no deferred actions and no changes have
been simulated on the display surface.
The visual state will be \fIDeferred\fP if there are deferred
actions, or if there are deferred actions and some changes have
been simulated on the display surface.
The visual state will be \fISimulated\fP if there are no deferred
actions, but some changes have
been simulated on the display surface.

.Bl "display_surface"
Returns the current status of the PHIGS workstation's display surface.
The display surface will be \fIEmpty\fP if nothing has been rendered on the
drawable, \fINotEmpty\fP otherwise.

.Bl "view_update"
Returns \fIPending\fP or \fINotPending\fP, depending on whether there are
view modification requests that have yet to be made current.

.Bl "defined_views"
Returns the list of view table entries that are defined in the PHIGS
workstation's current view table.
The list of defined view indices will be returned
in the order of view priority.

.Bl "wks_update"
Returns \fIPending\fP or \fINotPending\fP, depending on whether there are
workstation transformation requests that have yet to be made current.

.Bl "req_NPC_subvolume"
Returns the value for the PHIGS workstation's NPC subvolume specification
that has been requested but has not yet been made current.

.Bl "cur_NPC_subvolume"
Returns the current value for the PHIGS workstation's NPC
subvolume specification.

.Bl "req_wks_viewpt"
Returns the value for the PHIGS workstation's viewport specification
that has been requested but has not yet been made current.

.Bl "cur_wks_viewpt"
Returns the current value for the PHIGS workstation's viewport specification.

.Bl "HLHSR_update"
Returns \fIPending\fP or \fINotPending\fP, depending on whether there are
HLHSR mode requests that have yet to be made current.

.Bl "req_HLHSR_mode"
Returns the value for the PHIGS workstation's HLHSR mode
that has been requested but has not yet been made current.

.Bl "cur_HLHSR_mode"
Returns the current value for the PHIGS workstation's HLHSR mode.

.Bl "drawable_id"
Returns the resource id of the drawable that is being used as the
display surface.

.Bl "line_bundle"
Returns the resource id of the PHIGS workstation's line bundle table.

.Bl "marker_bundle"
Returns the resource id of the PHIGS workstation's marker bundle table.

.Bl "text_bundle"
Returns the resource id of the PHIGS workstation's text bundle table.

.Bl "interior_bundle"
Returns the resource id of the PHIGS workstation's interior bundle table.

.Bl "edge_bundle"
Returns the resource id of the PHIGS workstation's edge bundle table.

.Bl "color_table"
Returns the resource id of the color lookup table that will be used
by the PHIGS workstation to dereference indexed color values.

.Bl "pattern_table"
Returns the resource id of the PHIGS workstation's pattern table.

.Bl "text_font_table"
Returns the resource id of the PHIGS workstation's text font table.

.Bl "depth_cue_table"
Returns the resource id of the PHIGS workstation's depth-cue table.

.Bl "light_table"
Returns the resource id of the PHIGS workstation's depth-cue table.

.Bl "color_approx_table"
Returns the resource id of the color approximation table that
will be used by the PHIGS workstation.  The color approximation table
may be either of type \fIIntensityApprox\fP or \fIRGBApprox\fP.

.Bl "highlight_incl"
Returns the resource id of the PHIGS workstation's highlight inclusion
name set.

.Bl "highlight_excl"
Returns the resource id of the PHIGS workstation's highlight exclusion
name set.

.Bl "invis_incl"
Returns the resource id of the PHIGS workstation's invisibility inclusion
name set.

.Bl "invis_excl"
Returns the resource id of the PHIGS workstation's invisibility exclusion
name set.

.Bl "posted_structs"
Returns the resource ids of structures in the PHIGS workstation's
posted structure list.
The list will be returned in structure priority order.
.Fe
.bp

.AC "Get Dynamics" 3
.Fs
.Na PEXGetDynamics
.Rq                 
.Pa drawable_id DRAWABLE_ID
.Re
.Pa view_rep DYNAMIC_TYPE
.Pa line_bundle DYNAMIC_TYPE
.Pa marker_bundle DYNAMIC_TYPE
.Pa text_bundle DYNAMIC_TYPE
.Pa interior_bundle DYNAMIC_TYPE
.Pa edge_bundle DYNAMIC_TYPE
.Pa pattern_table DYNAMIC_TYPE
.Pa color_table DYNAMIC_TYPE
.Pa wks_transform DYNAMIC_TYPE
.Pa highlight_filter DYNAMIC_TYPE
.Pa invisibility_filter DYNAMIC_TYPE
.Pa HLHSR_mode DYNAMIC_TYPE
.Pa structure_modify DYNAMIC_TYPE
.Pa post_structure DYNAMIC_TYPE
.Pa unpost_structure DYNAMIC_TYPE
.Pa delete_structure DYNAMIC_TYPE
.Pa reference_modify DYNAMIC_TYPE
.Se
Drawable
.Ds
This request returns information about the dynamics that
are supported by PHIGS workstations associated with drawables
of the type specified by \fIdrawable_id\fP.
The list of dynamics, in order, is as follows:
.DS
.ta 0.2i 2.0i
	\fBAttribute Name	Description\fP
.ta
.ta 0.3i 1.5i
	view_rep	Changes to view table
	line_bundle	Changes to line bundle
	marker_bundle	Changes to marker bundle
	text_bundle	Changes to text bundle
	interior_bundle	Changes to interior bundle
	edge_bundle	Changes to edge bundle
	pattern_table	Changes to pattern table
	color_table	Changes to color table
	wks_transform	Changes to workstation transformations
	highlight_filter	Changes to highlight name set
	invisibility_filter	Changes to invisibility name set
	HLHSR_mode	Changes to HLHSR mode
	structure_modify	Structure modifications (edits)
	post_structure	Additions to posted structure list
	unpost_structure	Deletions from posted structure list
	delete_structure	Deletion of structure resources
	reference_modify	Structure reference modifications
.ta
.DE
The value returned for each of the items in the list above can
be one of \fIIMM, IRG,\fP or \fICBS\fP, where
\fIIMM\fP
means that the specified action can be performed and the correct
image displayed immediately,
\fIIRG\fP
means that the specified action requires a regeneration of the image,
and \fICBS\fP
means that the specified action can be simulated immediately if the PHIGS
workstation's \fIdisplay_update\fP mode is set to \fISimulateSome\fP.
.Fe



.AC "Get View Representation" 3
.Fs
.Na PEXGetViewRep
.Rq                 
.Pa fp_format FLOAT_FORMAT
.Pa wks_id PHIGS_WKS_ID
.Pa index TABLE_INDEX
.Re
.Pa view_update "{Pending, NotPending}"
.Pa requested VIEW_REP
.Pa current VIEW_REP
.Se
PhigsWKS, FloatingPointFormat, Value
.Ds
This request returns
the value of the view update state and
the specified entries in the requested and current view
tables in the PHIGS workstation specified by \fIwks_id\fP.
The \fIview_update\fP will be \fIPending\fP
if a view change has been requested but not established.
If the specified entry is not defined, an error will
be generated and the contents of the reply parameters
will be undefined.  Floating point values will be returned
in the floating point format specified by \fIformat\fP.
.Fe
.bp
	
.AC "PHIGS Workstation Manipulation" 2
.LP
This section contains requests that modify PHIGS workstation resources.

.AC "Redraw All Structures" 3
.Fs
.Na PEXRedrawAllStructures
.Rq
.Pa wks_id PHIGS_WKS_ID
.Se
PhigsWKS
.Ds       
This request redraws all the posted structures contained in the
PHIGS workstation resource specified by \fIwks_id\fP.
First, if the PHIGS workstation's \fIdisplay_surface\fP attribute
is \fINonEmpty\fP,
its drawable is cleared to the color stored in
entry zero of its color lookup table.
Then, if any of its \fIview_update\fP, \fIwks_update\fP, or \fIHLHSR_update\fP
attributes is set to \fIPending\fP, the requested values are made
the current values and the attribute is set to \fINotPending\fP.
After this, all the posted structures are traversed
and rendered (in priority order).
Finally, the PHIGS workstation's \fIvisual_state\fP attribute is set
to \fICorrect\fP.
.Fe




.AC "Update Workstation" 3
.Fs
.Na PEXUpdateWorkstation
.Rq
.Pa wks_id PHIGS_WKS_ID
.Se
PhigsWKS
.Ds
This request will perform actions identical to \fBPEXRedrawAllStructures\fP
on the PHIGS workstation specified by \fIwks_id\fP
if its \fIvisual_state\fP attribute
is currently set to \fIDeferred\fP or \fISimulated\fP.
.Fe
.bp

.AC "Execute Deferred Actions" 3
.Fs
.Na PEXExecuteDeferredActions
.Rq
.Pa wks_id PHIGS_WKS_ID
.Se
PhigsWKS
.Ds       
This request causes all the deferred actions on the PHIGS workstation specified
by \fIwks_id\fP to be executed.
.Fe

.AC "Set View Priority" 3
.Fs
.Na PEXSetViewPriority
.Rq
.Pa wks_id PHIGS_WKS_ID
.Pa index1 TABLE_INDEX
.Pa index2 TABLE_INDEX
.Pa priority "{\fIHigher, Lower\fP}"
.Se
PhigsWKS
.Ds       
This request
sets the relative priorities of entries in \fIwks_id\fP's current view table.
The priority
of view table entry \fIindex1\fP with respect
to view table entry \fIindex2\fP is set to the next
\fIHigher\fP or \fILower\fP priority.
These priorities are used to determine the order in which view
table entries are tested when selecting the inverse viewing transformation
to use for transformation from device coordinates to world coordinates.
.Fe

.AC "Set Display Update Mode" 3
.Fs
.Na PEXSetDisplayUpdateMode
.Rq
.Pa wks_id PHIGS_WKS_ID
.Pa display_update DISPLAY_UPDATE
.Se
PhigsWKS, Value
.Ds       
This request sets the \fIdisplay_update\fP
attribute of the PHIGS workstation resource specified by \fIwks_id\fP.
This attribute defines how changes to the display surface will be visualized.
The list of permissible display update modes is
defined in the "Extension Information" section that describes
enumerated types.
.Fe
.bp

.AC "Map DC to WC" 3
.Fs
.Na PEXMapDCtoWC
.Rq
.Pa fp_format FLOAT_FORMAT
.Pa wks_id PHIGS_WKS_ID
.Pa dc_points LISTofDRAWABLE_COORD
.Re
.Pa wc_points LISTofCOORD_3D
.Pa view_index TABLE_INDEX
.Se
PhigsWKS, FloatingPointFormat
.Ds       
This request maps the device coordinate points in \fIdc_points\fP
to the world coordinate points in \fIwc_points\fP
using the PHIGS workstation resource specified
by \fIwks_id\fP.
Each view in the PHIGS workstation's current view table is checked to
see if it contains all the specified device coordinate
points.  The index of the view with the highest
view priority that contains all the points is
returned in \fIview_index\fP.  The points are transformed to world
coordinates by passing them through the inverse of
the view transform associated with the view index and returned in
\fIwc_points\fP.  Floating point values are passed and will be returned
in the floating point format specified by \fIformat\fP.
.Fe

.AC "Map WC to DC" 3
.Fs
.Na PEXMapWCtoDC
.Rq
.Pa fp_format FLOAT_FORMAT
.Pa wks_id PHIGS_WKS_ID
.Pa wc_points LISTofCOORD_3D
.Pa view_index TABLE_INDEX
.Re
.Pa dc_points LISTofDRAWABLE_COORD
.Se
PhigsWKS, FloatingPointFormat
.Ds       
This request maps the world coordinate points in \fIwc_points\fP
to the device coordinate points in \fIdc_points\fP using the PHIGS
workstation resource specified by \fIwks_id\fP and the view
specified by \fIview_index\fP.  The points are transformed to
device coordinates by passing them through the view transform
associated with the \fIview_index\fP.
Floating point values sent and received will be in the
floating point format specified by \fIfp_format\fP.
.Fe
.bp


.AC "PHIGS Workstation Update Requests" 2
.LP
This section defines requests that can be used to set "requested"
values for PHIGS workstation resources.

.AC "Set View Representation" 3
.Fs
.Na PEXSetViewRep
.Rq
.Pa fp_format FLOAT_FORMAT
.Pa wks_id PHIGS_WKS_ID
.Pa view_rep VIEW_REP
.Se
PhigsWKS, FloatingPointFormat
.Ds       
This request sets an entry in the view table of 
the PHIGS workstation specified by \fIwks_id\fP to
the view representation indicated by \fIview_rep\fP.
The PHIGS workstation's 
\fIview_update\fP attribute is set to \fIPending\fP.
All requested views will be made current
whenever the workstation is updated.
.Fe



.AC "Set Workstation Window" 3
.Fs
.Na PEXSetWKSWindow
.Rq
.Pa fp_format FLOAT_FORMAT
.Pa wks_id PHIGS_WKS_ID
.Pa NPC_subvolume NPC_SUBVOLUME
.Se
PhigsWKS, FloatingPointFormat
.Ds       
This request specifies
the NPC subvolume (PHIGS workstation window)
values that are to be used instead of the current values
in the workstation specified by \fIwks_id\fP.
If the PHIGS workstation's \fIdisplay_surface\fP attribute is \fIEmpty\fP,
or if the dynamic modification for its \fIwks_transform\fP is \fIIMM\fP,
its \fIcur_NPC_subvolume\fP attribute is modified with the values contained
in \fINPC_subvolume\fP.  Otherwise,
its \fIreq_NPC_subvolume\fP attribute is modified.  The next time
the PHIGS workstation is updated, the
\fIreq_NPC_subvolume\fP values will be copied to
\fIcur_NPC_subvolume\fP.
.Fe
.bp

.AC "Set Workstation Viewport" 3
.Fs
.Na PEXSetWKSViewport
.Rq
.Pa fp_format FLOAT_FORMAT
.Pa wks_id PHIGS_WKS_ID
.Pa viewport VIEWPORT
.Se
PhigsWKS, FloatingPointFormat
.Ds       
This request specifies the viewport values
that are to be used instead of the current values
in the workstation specified by \fIwks_id\fP.
If the PHIGS workstation's \fIdisplay_surface\fP attribute is \fIEmpty\fP,
or if the dynamic modification for its \fIwks_transform\fP is \fIIMM\fP,
its \fIcur_viewport\fP attribute is modified with the values contained
in \fIviewport\fP.  Otherwise,
its \fIreq_viewport\fP attribute is modified.  The next time
the PHIGS workstation is updated, the
\fIreq_viewport\fP values will be copied to
\fIcur_viewport\fP.
.Fe




.AC "Set HLHSR Mode" 3
.Fs
.Na PEXSetHLHSRMode
.Rq
.Pa wks_id PHIGS_WKS_ID
.Pa mode HLHSR_MODE
.Se
PhigsWKS, Value
.Ds       
This request specifies the HLHSR mode
that is to be used instead of the current value
in the workstation specified by \fIwks_id\fP.
If the PHIGS workstation's \fIdisplay_surface\fP attribute is \fIEmpty\fP,
or if the dynamic modification for its \fIHLHSR_mode\fP is \fIIMM\fP,
its \fIcur_HLHSR_mode\fP attribute is modified with the values contained
in \fIviewport\fP.  Otherwise,
its \fIreq_HLHSR_mode\fP attribute is modified.  The next time
the PHIGS workstation is updated, the
\fIreq_HLHSR_mode\fP values will be copied to
\fIcur_HLHSR_mode\fP.
.Fe
.bp

.AC "Posting/Unposting Structures" 2
.LP
This section describes the requests that can be used to post and
unpost structures on a PHIGS workstation resource.

.AC "Post Structure" 3
.Fs
.Na PEXPostStructure
.Rq
.Pa wks_id PHIGS_WKS_ID
.Pa s_id STRUCTURE_ID
.Pa priority CARD32
.Se
PhigsWKS, Structure
.Ds 
This request adds the structure specified by \fIs_id\fP
to the list of posted structures
in the PHIGS workstation \fIwks_id\fP.  A priority
is also provided to indicate the priority of the newly-posted
structure with respect to the structures
already in the posted structure list.
If multiple structures are posted for display to the same display
space location, the implementation will ensure the display of the
higher priority structure.
If two structures have the same priority, the last posted structure
has the higher priority.  If \fIs_id\fP is not a valid structure resource id,
the request is ignored.
.Fe




.AC "Unpost Structure" 3
.Fs
.Na PEXUnpostStructure
.Rq
.Pa wks_id PHIGS_WKS_ID
.Pa s_id STRUCTURE_ID
.Se
PhigsWKS, Structure
.Ds       
This request
removes the structure specified by \fIs_id\fP from 
\fIwks_id\fP's posted structure list.  If \fIs_id\fP is not found in
the posted structure list,
the request is ignored.
.Fe
.bp

.AC "Unpost All Structures" 3
.Fs
.Na PEXUnpostAllStructures
.Rq
.Pa wks_id PHIGS_WKS_ID
.Se
PhigsWKS
.Ds       
This request
removes all structures from
\fIwks_id\fP's posted structure list.
.Fe




.AC "Get PHIGS Workstation Postings" 3
.Fs
.Na PEXGetWKSPostings
.Rq
.Pa s_id STRUCTURE_ID
.Re
.Pa wks_id LISTofPHIGS_WKS_ID
.Se
Structure
.Ds       
This request returns a list of all of the PHIGS workstation
resources to which
\fIs_id\fP has been posted.
.Fe
.bp
.AC "Picking" 1
.LP
.RU
.LP
The discussion of picking includes both \fIpick device descriptors\fP, which
are found in PHIGS workstation resources, and \fIpick measures\fP, which
are themselves resources.
PEX currently provides no support for picking of client-side
structure networks.

.AC "Pick Device Descriptors" 2
.LP
Each PHIGS workstation resource maintains a list of \fIpick device\fP
descriptors.  Each entry in this list maintains state
values for a particular type of pick device, such as a mouse or a 3D tablet.
Together, the entries in the pick device descriptor list maintain
state values for all of the pick devices that are supported by the workstation
resource.  This list of values can be set or inquired for each of the
supported pick devices.
.LP
The pick device descriptor components, in order,
are listed in the following table.
The abbreviation
"pick dev. dep." stands for "pick-device-dependent", meaning that the
default value is determined by the pick device type.
The abbreviation "imp. dep."
means that the default value is implementation-dependent.
.LP
.ID
.ta 0.1i 1.7i 3.3i
	\fBAttribute Name	Data Type	Default Value\fP
.ta
.ta 0.2i 1.5i 3.4i
	pick_status	{\fINoPick, Ok\fP}	\fINoPick\fP
	pick_path	PICK_ELEMENT_REF	\fINull\fP
	pick_path_order	{\fITopFirst, BottomFirst\fP}	\fITopFirst\fP
	pick_inclusion	NAME_SET_ID	\fINull\fP
	pick_exclusion	NAME_SET_ID	\fINull\fP
	pick_data_rec	LISTofCARD8	pick dev. dep.
	prompt_echo_type	PROMPT_ECHO_TYPE	pick dev. dep.
	echo_volume	VIEWPORT	{imp. dep., imp. dep., True}
	echo_switch	{\fINoEcho, Echo\fP}	\fINoEcho\fP
.ta
.DE
.LP
The components of the pick device descriptor are defined as follows:

.Bl "pick_status"
This attribute contains the initial pick status that will be
bound to a pick measure resource.

.Bl "pick_path"
This attribute contains the initial pick path that will be
bound to a pick measure resource.

.Bl "pick_path_order"
This attribute specifies
the order in which elements of the picked path are to be written
into a pick measure resource.  If the order is \fITopFirst\fP,
elements of the pick measure's \fIpicked_path\fP attribute will
be listed in the order they would have been encountered during
a traversal, while if the order is \fIBottomFirst\fP they will
be listed in the opposite order.

.Bl "pick_inclusion"
This attribute specifies the resource id of the name set resource that is to be
used as the pick inclusion filter during picking operations.

.Bl "pick_exclusion"
This attribute specifies the resource id of the name set resource that is to be
used as the pick exclusion filter during picking operations.

.Bl "pick_data_rec"
This attribute contains
a pick-device-dependent data record used to initialize a pick measure
resource when it is created.

.Bl "prompt_echo_type"
This attribute
contains an enumerated type value that specifies the prompt/echo type
to be used during picking operations.  The allowable types are described
in the "Extension Information" section.

.Bl "echo_volume"
This attribute specifies
where prompting and/or echoing is to occur.
The default is that the echo volume will be defined to be
the size of the drawable that was bound to the the PHIGS workstation 
resource at the time it was created.

.Bl "echo_switch"
This attribute specifies the
initial echo state for a pick measure.
.LP
The requests in this section allow clients to set and inquire the values of
pick device descriptors that are stored in a PHIGS workstation resource.
.bp

.AC "Get Pick Device Descriptor" 3
.Fs
.Na PEXGetPickDevice
.Rq
.Pa fp_format FLOAT_FORMAT
.Pa wks_id PHIGS_WKS_ID
.Pa dev_type PICK_DEVICE_TYPE
.Pa item_mask BITMASK
.Re
.Pa item_list LISTofVALUE
.Se
PhigsWKS, Value, FloatingPointFormat
.Ds       
This request will return components of
a pick descriptor for the PHIGS workstation resource specified by \fIwks_id\fP.
The descriptor returned will be the currently-defined descriptor for
the pick device of the type specified by \fIdev_type\fP.
The \fIitem_mask\fP specifies which components are to be inquired and
returned.  The specified attributes of the pick device descriptor
will be returned in \fIitem_list\fP.
Floating point values in \fIitem_list\fP will be returned in the floating
point format specified in \fIformat\fP.
.Fe


.AC "Change Pick Device Descriptor" 3
.Fs
.Na PEXChangePickDevice
.Rq
.Pa fp_format FLOAT_FORMAT
.Pa wks_id PHIGS_WKS_ID
.Pa dev_type PICK_DEVICE_TYPE
.Pa item_mask BITMASK
.Pa item_list LISTofVALUE
.Se
PhigsWKS, Value, FloatingPointFormat
.Ds       
This request will modify components of
a pick descriptor for the PHIGS workstation resource specified by \fIwks_id\fP.
The descriptor to be modified will be the currently-defined descriptor for
the pick device of the type specified by \fIdev_type\fP.
The \fIitem_mask\fP specifies which components are to be changed.
The specified attributes of the pick device descriptor
will be set to the values contained in \fIitem_list\fP.
Floating point values in \fIitem_list\fP will be in the floating
point format specified in \fIformat\fP.
.Fe
.bp

.AC "Pick Measure Resource Management" 2
.LP
A \fIpick measure\fP resource must be created to actually perform
a pick operation.  A pick device type is specified at the time
a pick measure resource is created in order to provide the parameters
for the picking operation.  The pick measure resource accepts input
in the form of input records which are defined for each type of pick
device.  When a pick measure resource is passed a valid input record,
its attributes will be updated.
Pick measures
are lightweight resources, although the operations on a pick measure
resource are potentially lengthy since a great number of structure
elements may have to be processed in order to produce the pick results.
.LP
The pick measure resource components, in order,
are listed in the following table.
The abbreviation "from wks" indicates that the default
value is inherited from the pick device descriptor stored
in the PHIGS workstation resource when the pick measure is created.
.LP
.ID
.ta 0.1i 1.6i 3.2i
	\fBAttribute Name	Data Type	Default Value\fP
.ta
.ta 0.2i 1.3i 3.4i
	pick_status	{\fIOk, NoPick\fP}	from wks
	picked_prim	LISTofPICK_ELEMENT_REF	from wks
.ta
.DE
.LP
The attributes of the pick measure resource are defined as follows:

.Bl "pick_status"
This attribute contains the result of the last update operation that
was performed.  It is set to \fIOk\fP if a primitive was successfully
picked, and \fINoPick\fP if the pick operation was unsuccessful.

.Bl "picked_prim"
This attribute contains the path of the structure element that was
picked as a result of the last update operation.

.LP
The pick measure is an X11 resource and carries all of the 
responsibilities and
access rights of X11 resources.  The requests in this section
manage the creation and
freeing of pick measures.
.bp

.AC "Create Pick Measure" 3
.Fs
.Na PEXCreatePickMeasure
.Rq      
.Pa pm_id PICK_MEASURE_ID
.Pa wks_id PHIGS_WKS_ID
.Pa dev_type PICK_DEVICE_TYPE
.Se
IDChoice, PhigsWKS, Value, Alloc
.Ds                     
This request creates a pick measure resource of the type specified
by \fIdev_type\fP.  The resource id of the pick measure is specified
by \fIpm_id\fP.  The newly-created pick measure is initialized with the
values contained in the appropriate pick device descriptor stored
in the PHIGS workstation resource specified by \fIwks_id\fP.
.Fe



.AC "Free Pick Measure" 3
.Fs
.Na PEXFreePickMeasure
.Rq                 
.Pa pm_id PICK_MEASURE_ID
.Se
PickMeasure
.Ds            
This request deletes the
pick measure resource
and frees the storage associated with it.
.Fe
.bp
.AC "Pick Measure Inquiry" 2
.LP
The requests in this section can be used to
inquire pick measure attributes.

.AC "Get Pick Measure Attributes" 3
.Fs
.Na PEXGetPickMeasure
.Rq
.Pa pm_id PICK_MEASURE_ID
.Pa item_mask BITMASK
.Re
.Pa item_list LISTofVALUE
.Se
PickMeasure
.Ds       
This request will return components of
the pick measure specified by \fIpm_id\fP.
The \fIitem_mask\fP specifies which components are to be inquired and returned.
The specified attributes of the pick measure will be returned in
\fIitem_list\fP.
.Fe

.AC "Pick Operations" 2
.LP
These request cause pick operations to occur.
.AC "Update Pick Measure" 3
.Fs
.Na PEXUpdatePickMeasure
.Rq
.Pa pm_id PICK_MEASURE_ID
.Pa input_record LISTofCARD8
.Se
PickMeasure
.Ds       
This request will update the pick measure specified by \fIpm_id\fP using
the information found in \fIinput_record\fP.  If this update causes a
primitive to be picked, the pick measure's \fIpick_status\fP will be
set to \fIOk\fP and the \fIpicked_prim\fP will be set to the path of the
picked primitive.  If no primitive was picked, the \fIpick_status\fP
will be set to \fINoPick\fP.
.LP
The data in \fIinput_record\fP is dependent on the type of pick device for
which the pick measure resource was created.  For example, the input
record for a pick device that uses a mouse to pick a primitive may
contain a screen x,y pair.  Specific input record descriptions must
be documented in the implementation documentation for a particular PEX
implementation.  \fBPEXGetPickMeasure\fP can be used to return the results
of a \fBPEXUpdatePickMeasure\fP request.
.Fe
.bp
.AC "PEX Font Requests" 1
.LP
.RU
.LP
The PEX font manipulation mechanisms are the same mechanisms as those 
used for X11 fonts.  The PEX font resource is very similar to the
font resource created
by (and managed by) X11.  PEX fonts that are used with PEX string precision
text contain more functionality than is currently found in X11 fonts.
Specifically, string precision text requires scalable and rotatable
text fonts.  Because of the added capabilities of PEX fonts, PEX
has defined its own PEX font open, close, and query requests.
The X11 font manipulation requests and the corresponding PEX font
manipulation requests are listed below:
.DS
 
	OpenFont augmented by PEXOpenFont
	CloseFont augmented by PEXCloseFont
	ListFonts augmented by PEXListFonts
	ListFontsWithInfo augmented by PEXListFontsWithInfo
	QueryFont augmented by PEXQueryFont
	QueryTextExtents augmented by PEXQueryTextExtents
 
.DE           
.LP
X11 fonts and PEX fonts can be stored in the same location on the server.
PEX uses the X11 font path in order to find where PEX font files are located.
(The X11 request \fBSetFontPath\fP is used to set the current
font path and the X11
request \fBGetFontPath\fP is used to query the current font path.)
.bp
.AC "PEX Font Resource Management" 2
.LP
The PEX font is an X11 resource and carries all of the 
responsibilities and
access rights of X11 resources.  These requests manage the opening and closing
of PEX font resources.

.AC "Open PEX Font" 3
.Fs
.Na PEXOpenFont
.Rq      
.Pa f_id PEX_FONT_ID
.Pa name STRING
.Se
PEXFont, IDChoice, Alloc
.Ds                     
This request loads the specified PEX font, if necessary, and associates
identifier \fIf_id\fP with it.  The font name should use the ISO Latin-1
encoding, and upper/lower case does not matter.  PEX fonts are not associated
with a particular screen, and can be used with any renderer or PHIGS
workstation resources.
An error will be generated if the specified font
is not "PEX useable", that is, it is not capable of supporting the full
range of PEX text attributes.
.Fe



.AC "Close PEX Font" 3
.Fs
.Na PEXCloseFont
.Rq      
.Pa f_id PEX_FONT_ID
.Se
PEXFont
.Ds                     
This request deletes the association between the resource id
and the PEX font.  The PEX font itself will be
freed when no other resource references it.
.Fe
.bp

.AC "PEX Font Inquiry" 2
.LP
The PEX font requests generate replies with logical information specific
to a font.  The information is encoded in the following data structures.
.LP
PEX_CHARINFO is specified for each glyph of the font and
is defined as:
.DS
 
	left_bearing		: FLOAT
	right_bearing	: FLOAT
	width			: FLOAT
	ascent		: FLOAT
	descent		: FLOAT
 
.DE
.LP
PEX_FONTPROP is defined as:
.DS
 
	name			: ATOM
	value			: {CARD32, FLOAT}
 
.DE           
.LP
PEX_FONTINFO is defined as:
.DS
 
	first_glyph		: CARD16
	last_glyph		: CARD16
	all_glyphs_exist	: BOOLEAN
 	default_glyph	: CARD16
	min_bounds		: PEX_CHARINFO
	max_bounds	: PEX_CHARINFO
	cap_ratio		: FLOAT
	base_ratio		: FLOAT
	properties		: LISTofPEX_FONTPROP
 
.DE
.LP
The \fIfirst_glyph\fP, \fIlast_glyph\fP, and \fIdefault_glyph\fP
are either 1 byte or 2 byte indices to the first glyph, last
glyph and default glyph of the font.  The \fIdefault_glyph\fP
specifies the glyph that will be used when an undefined or non-existent
glyph is used.  If \fIall_glyphs_exist\fP is True, then all glyphs
within the range of \fIfirst_glyph\fP and \fIlast_glyph\fP have non-zero
bounded boxes (as specified by PEX_CHARINFO).  
The \fImin_bounds\fP and \fImax_bounds\fP contain the minimum  and maximum
values of each individual PEX_CHARINFO component over all glyphs of the
font.  The bounded box of the font is given by:
.DS
 
	x		: min_bounds.left_bearing
	y		: max_bounds.right_bearing
	width		: max_bounds.right_bearing - min_bounds.left_bearing
	height	: max_bounds.ascent + max_bounds.descent
 
.DE
where (\fIx\fP, \fIy\fP) is the lower left corner of the box, relative
to the origin.
The \fIcap_ratio\fP is the
ratio of the distance between the cap and top lines to the distance 
between the base and cap lines.  The \fIbase_ratio\fP is the
ratio of the distance between the bottom and base lines, to the
distance between the base and cap lines.
.LP
A font is
not guaranteed to have any \fIproperties\fP.  
Whether a property value
is a signed, unsigned or float must be derived from an a priori 
knowledge of the property.
.bp

.AC "Query PEX Font" 3
.Fs
.Na PEXQueryFont
.Rq      
.Pa fp_format FLOAT_FORMAT
.Pa f_id PEX_FONT_ID
.Re
.Pa font_info PEX_FONTINFO
.Pa char_info LISTofPEX_CHARINFO
.Se
PEXFont, FloatingPointFormat
.Ds                     
This request generates a reply which contains the logical information
about a PEX font.
.Fe


.AC "List PEX Fonts" 3
.Fs
.Na PEXListFonts
.Rq                    
.Pa pattern STRING
.Pa max_names CARD16
.Re
.Pa font_names LISTofSTRING
.Se
None
.Ds 
Like X11 \fBListFonts\fP except that this request only returns the
names of fonts that can support the full range of PEX text attributes
(i.e., those fonts that are "PEX usable").  This list may or may not
contain some of the same fonts returned by the X11 \fBListFonts\fP request.
This request returns a list of at most \fImax_names\fP
entries, each of which contains information about a font matching the
\fIpattern\fP.  \fIPattern\fP is a string that uses the ISO Latin-1
encoding, and upper/lower case does not matter.  In the pattern, the '?'
character (octal value 77) will match any single character, and the
character '*' (octal value 52) will match any number of characters.
The returned names are in lower case, and are also ISO Latin-1 encoded
strings.
.Fe
.bp
 

.AC "List PEX Fonts with Info" 3
.Fs
.Na PEXListFontsWithInfo
.Rq                    
.Pa fp_format FLOAT_FORMAT
.Pa pattern STRING
.Pa max_names CARD16
.Re
.Pa font_names LISTofSTRING
.Pa fonts LISTofPEX_FONTINFO
.Se
FloatingPointFormat
.Ds 
Like X11 \fBListFontsWithInfo\fP except that this request only returns
information about fonts that can support the full range of PEX text attributes
(i.e., those fonts that are "PEX useable").  This list may or may not
contain some of the same fonts returned by the X11 \fBListFonts\fP request.
This request returns a list of at most \fImax_names\fP
entries, each of which contains information about a font matching the
\fIpattern\fP.  \fIPattern\fP is a string that uses the ISO Latin-1
encoding, and upper/lower case does not matter.  In the pattern, the '?'
character (octal value 77) will match any single character, and the
character '*' (octal value 52) will match any number of characters.
The returned names are in lower case, and are also ISO Latin-1 encoded
strings.
.LP
The information returned for each font is identical
to what \fBPEXQueryFont\fP would return except that the per-glyph
metrics are NOT returned.
.Fe
 
 
.bp
.AC "Query PEX Text Extents" 3
.Fs
.Na PEXQueryTextExtents
.Rq         
.Pa fp_format FLOAT_FORMAT
.Pa f_id FONT_ID
.Pa pc_id PIPELINE_CONTEXT_ID
.Pa string STRING
.Re                  
.Pa overall_ascent FLOAT
.Pa overall_descent FLOAT
.Pa overall_width FLOAT
.Pa overall_left FLOAT
.Pa overall_right FLOAT
.Pa concat_point COORD_2D
.Se
PipelineContext, PEXFont, FloatingPointFormat
.Ds                     
This request generates a reply which contains the logical 
extents of the specified \fIstring\fP of glyphs.   The extents
are computed using the font specified by \fIf_id\fP and the
text attributes in the pipeline context specified by \fIpc_id\fP.
.LP
The \fIoverall_ascent\fP is the maximum ascent 
metric of all glyphs in the string, and \fIoverall_descent\fP is
the maximum of the descent metrics.  The \fIoverall_width\fP is the
sum of the glyph width metrics of all glyphs in the string.
For each glyph in \fIstring\fP, let \fIW\fP be the sum of the
glyph width metrics of all preceding glyphs,
let \fIL\fP be the \fIleft_bearing\fP metric of the glyph plus
\fIW\fP, and let \fIR\fP be the \fIright_bearing\fP metric of the glyph
plus \fIW\fP.  The \fIoverall_left\fP is the minimum \fIL\fP of
all glyphs in the \fIstring\fP, and \fIoverall_right\fP is
the maximum \fIR\fP.  All values are returned in modeling coordinates,
relative to a text origin of (0,0).
.LP
The \fIconcat_point\fP returns the point where the next glyph
should go if the string is to be extended. This is in modeling coordinates.
.LP
If the font specified
has no defined default_glyph, then undefined glyphs
in \fIstring\fP are taken to have all zero metrics.
.Fe
.bp
.AP "Appendix A: Definition of Standard PEX Subsets"
.SH
\s+3\f6Appendix A: Definition of Standard PEX Subsets\fP\s-3
.LP
.RU
.LP
The \fBPEXGetExtensionInfo\fP returns a 32-bit value (\fIsubset_info\fP)
containing information
about whether the PEX server is a full PEX implementation or one of the
defined standard subsets.  The top 16 bits of this 32-bit value are
reserved for use by vendors.  The bottom 16 bits contain information
about how fully the PEX extension implementation supports the PEX protocol.
Only two standard PEX subsets are currently
defined.
If all 32 bits of \fIsubset_info\fP are zero, the extension
can be assumed to be a complete PEX implementation.
If the low-order bit of \fIsubset_info\fP
is a one, then the PEX extension is an "immediate rendering
only" implementation.
If the next-to-low-order bit of \fIsubset_info\fP
is a one, then the PEX extension is a "PHIGS workstation only" implementation.
A PEX implementation is not allowed to return with both of these bits set.
.sp
.SH
\s+2\f6PHIGS Workstation Only Subset\fP\s-2
.LP
A "PHIGS workstation only" subset should fully support the following PEX 
resources:
.ID
\(bu  lookup tables
\(bu  name sets
\(bu  structures
\(bu  search contexts
\(bu  PHIGS workstations
\(bu  pick measures
\(bu  PEX fonts
.DE
and all of the output commands.
To qualify as a PHIGS workstation
only PEX subset, an implementation must support
at least the protocol requests in the following list.  Protocol requests
that are not supported should return a \fIBad
Implementation\fP error.
.ID 0.6i
.ta 2.5i
\fBPEXGetExtensionInfo	PEXCreateNameSet
PEXGetEnumeratedTypeInfo	PEXCopyNameSet
PEXGetImpDepConstants	PEXFreeNameSet
	PEXGetNameSet
PEXCreateLookupTable	PEXChangeNameSet
PEXCopyLookupTable
PEXFreeLookupTable	PEXCreateSearchContext
PEXGetTableInfo	PEXCopySearchContext
PEXGetPredefinedEntries	PEXFreeSearchContext
PEXGetDefinedIndices	PEXGetSearchContext
PEXGetTableEntry	PEXChangeSearchContext
PEXGetTableEntries	PEXSearchNetwork
PEXSetTableEntries	
PEXDeleteTableEntries	

PEXCreateStructure	PEXCreatePhigsWKS
PEXCopyStructure	PEXFreePhigsWKS
PEXFreeStructure	PEXGetWKSInfo
PEXDeleteStructures	PEXGetDynamics
PEXGetStructureInfo	PEXGetViewRep
PEXGetElementInfo	PEXRedrawAllStructures
PEXGetStructuresInNetwork	PEXUpdateWorkstation
PEXGetAncestors	PEXExecuteDeferredActions
PEXGetDescendants	PEXSetViewPriority
PEXFetchElements	PEXSetDisplayUpdateMode
PEXSetEditingMode	PEXMapDCtoWC
PEXSetElementPointer	PEXMapWCtoDC
PEXSetElementPointerAtLabel	PEXSetViewRep
PEXElementSearch	PEXSetWKSWindow
PEXStoreElements	PEXSetWKSViewport
PEXDeleteElements	PEXSetHLHSRMode
PEXDeleteElementsToLabel	PEXPostStructure
PEXDeleteElementsBetweenLabels	PEXUnpostStructure
PEXCopyElements	PEXUnpostAllStructures
PEXChangeStructureReferences	PEXGetWKSPostings

PEXGetPickDevice	PEXQueryFont
PEXChangePickDevice	PEXListFontsWithInfo
PEXCreatePickMeasure	PEXQueryTextExtents
PEXFreePickMeasure	PEXListFonts
PEXGetPickMeasure	PEXOpenFont
PEXUpdatePickMeasure	PEXCloseFont\fP
.ta
.DE
.ta 3.0i
.SH
\s+2\f6Immediate Rendering Only Subset\fP\s-2
.LP
An "immediate rendering only" subset should fully support the following PEX
resources:
.ID
\(bu  lookup tables
\(bu  name sets
\(bu  pipeline contexts
\(bu  renderers
\(bu  PEX fonts
.DE
and all
of the output commands (the "execute structure" output command will be
treated as a no-op).
To qualify as an immediate rendering
only PEX subset, an implementation must support
at least the protocol requests in the following list.  Protocol requests
that are not supported should return a \fIBad
Implementation\fP error.

.ID 0.6i
.ta 2.5i
\fBPEXGetExtensionInfo	PEXCreateRenderer
PEXGetEnumeratedTypeInfo	PEXFreeRenderer
PEXGetImpDepConstants	PEXChangeRenderer
	PEXGetRendererAttributes
PEXCreateLookupTable	PEXBeginRendering
PEXCopyLookupTable	PEXEndRendering
PEXFreeLookupTable	PEXBeginStructure
PEXGetTableInfo	PEXEndStructure
PEXGetPredefinedEntries	PEXRenderOutputCommands
PEXGetDefinedIndices	
PEXGetTableEntry	PEXCreateNameSet
PEXGetTableEntries	PEXCopyNameSet
PEXSetTableEntries	PEXFreeNameSet
PEXDeleteTableEntries	PEXGetNameSet
	PEXChangeNameSet
PEXCreatePipelineContext	
PEXCopyPipelineContext	PEXQueryFont
PEXFreePipelineContext	PEXListFontsWithInfo
PEXGetPipelineContext	PEXQueryTextExtents
PEXChangePipelineContext	PEXListFonts
	PEXOpenFont
	PEXCloseFont\fB
.ta
.DE
.bp
.AP "Appendix B: Minimum Support for PHIGS/PHIGS+"
.SH
\s+3Appendix B: Minimum Support for PHIGS/PHIGS+\s-3
.LP
.RU
.LP
In order to fully support a PHIGS client-side implementation and the
targeted PHIGS+ functionality, a PEX extension
implementation must meet or exceed the
following support criteria.  Other than the minimum support criteria
listed here and the
subset information listed in Appendix A, a
PEX extension implementation must fully support the functionality described
in the \fIPEX Protocol Specification\fP document.
.IP "\fBEnumerated Types\fP"
.nf
.ta 1.5i
MarkerType	at least types 1-5 (\fIDot, Cross, Asterisk, Circle, X\fP) must be supported
ATextStyle	at least types 1-2 (\fINotConnected, Connected\fP) must be supported
InteriorStyle	at least types 1,2,5 (\fIHollow, Solid, Empty\fP) must be supported
HatchStyle	it is not required that an implementation support any hatch styles
LineType	at least types 1-4 (\fISolid, Dashed, Dotted, DashDot\fP) must be supported
SurfaceEdgeType	at least type 1 (\fISolid\fP) must be supported
PickDeviceType	at least one type of pick device must be supported
PolylineInterpMethod	at least type 1 (\fINone\fP) must be supported
CurveApproxMethod	at least one of types 1-6 or an implementation-dependent method must
	be supported
CurveBasis	at least types 1-2 (\fIUniformBSpline, PiecewiseBezier\fP) must be supported
ReflectionModel	at least type 1 (\fINoShading\fP) must be supported
SurfaceInterpMethod	at least type 1 (\fINone\fP) must be supported
SurfaceApproxMethod	at least one of types 1-6 or an implementation-dependent method must
	be supported
SurfaceBasis	at least types 1-2 (\fIUniformBSpline, PiecewiseBezier\fP) must be supported
ModelClipOperator	at least types 1-2 (\fIReplace, Intersection\fP) must be supported
LightType	at least one of types 1-4 (\fIAmbient, WCS_Vector, WCS_Point, WCS_Spot\fP)
	must be supported
DirectColorFormat	at least one of types 1-6 (\fIRGBFloat, CIEFloat, HSVFloat, HLSFloat,
	RGBInt8, RGBInt16\fP) must be supported
FloatFormat	at least one of types 1-2 (\fIIEEE_754_32, DEC_F_Floating\fP) must be supported
HLHSRMode	at least type 1 (\fIOff\fP) and one other type (\fIZBuffer, Painters, Scanline,
	HiddenLineOnly,\fP or an implementation-dependent type) must be supported
PromptEchoType	at least type 1 (\fIEchoPrimitive\fP) must be supported
DisplayUpdateMode	at least type 1 (\fIVisualizeEach\fP) must be supported

.IP "\fBOutput Primitive Attributes\fP"
.nf
.ta 1.5i
marker_scale	marker scale factors other than 1.0 may be ignored
text_precision	all types (\fIStroke, Char, String\fP) must be supported
char_expansion	character expansion other than 1.0 may be ignored
char_height	character height other than 0.01 may be ignored
atext_height	annotation text character height other than 0.01 may be ignored
line_width	line widths other than 1.0 may be ignored
interior_style_index	this attribute may be ignored if neither \fIPattern\fP nor \fIHatch\fP style is supported
reflection_attr	transmission coefficient attribute may be ignored
bf_interior_style_index	this attribute may be ignored if neither \fIPattern\fP nor \fIHatch\fP style is supported
bf_reflection_attr	transmission coefficient attribute may be ignored
pattern_size	this attribute may be ignored if \fIPattern\fP style is not supported
pattern_ref_pt	this attribute may be ignored if \fIPattern\fP style is not supported
pattern_ref_vec1	this attribute may be ignored if \fIPattern\fP style is not supported
pattern_ref_vec2	this attribute may be ignored if \fIPattern\fP style is not supported
surface_edge_width	surface edge widths other than 1.0 may be ignored
model_clip_volume	must support the combining of at least six halfspaces to compute the
	modeling clipping volume
depth_cue attributes	depth cue attributes other than the default (depth cue off) may be ignored
HLHSR_identifier	may be ignored
specific GSE's	may be ignored

.IP "\fBOutput Primitives\fP"
.nf
.ta 1.5i
cell arrays	may be simulated by drawing the outline of the cell array
specific GDP's	may be ignored

.IP "\fBLookup Tables\fP"
.nf
.ta 1.5i
LineBundle	must support at least 20 entries
MarkerBundle	must support at least 20 entries
TextBundle	must support at least 20 entries
InteriorBundle	must support at least 20 entries
EdgeBundle	must support at least 20 entries
Pattern	must support at least 10 entries (if interior style \fIPattern\fP supported)
Color		must support at least 2 entries
TextFont	must support at least 2 entries
View		must support at least 6 entries
Light		must support at least 5 entries
DepthCue	must support at least 6 entries
RGBApprox	Color (tri-valued) RGB devices must support at least/at most one entry
IntensityApprox	Intensity (single-valued) devices must support at least one entry

.IP "\fBMiscellaneous\fP"
.nf
.ta 1.5i
color type	both Direct and Indexed colors must be supported
fonts	an implementation need not support drawing text primitives with X11 fonts
.ta
.bp
.AP "Appendix C: Definition of PEX Errors"
.SH
\s+3Appendix C: Definition of PEX Errors\s-3
.LP
.RU
.nf
\fBPEXGetExtensionInfo\fP
	no errors

\fBPEXGetEnumeratedTypeInfo\fP
	Drawable: specified drawable resource id is invalid
	Value: generated if the specified enumerated type number is invalid

\fBPEXGetImpDepConstants\fP
	Value: generated if a specified constant name is invalid
	FloatingPointFormat: device does not support the specified fp format
	Drawable: specified drawable resource id is invalid

\fBPEXCreateLookupTable\fP
	IDChoice: ID already in use or not in range assigned to client
	Drawable: specified drawable resource id is invalid
	Value: table_type value does not name a valid table type
	Alloc: server failed to allocate the resource for some reason

\fBPEXCopyLookupTable\fP
	LookupTable: either src_lut_id or dest_lut_id is an invalid resource id
	Match: src_lut_id and dest_lut_id must have been created for use on the
		same class of drawables, and must be the same type of lookup
		table

\fBPEXFreeLookupTable\fP
	LookupTable: lut_id contains an invalid lut resource id

\fBPEXGetTableInfo\fP
	Drawable: specified drawable resource id is invalid
	Value: table_type value does not name a valid table type
	
\fBPEXGetPredefinedEntries\fP
	Drawable: specified drawable resource id is invalid
	Value: table_type value does not name a valid table type
	Value: start < min predefined entry
	Value: start + count > max predefined entry
	FloatingPointFormat: device does not support the specified fp format
	DirectColorFormat: device does not support the specified color format

\fBPEXGetDefinedIndices\fP
	LookupTable: lut_id contains an invalid lut resource id

\fBPEXGetTableEntry\fP
	LookupTable: lut_id contains an invalid lut resource id
	FloatingPointFormat: device does not support the specified fp format
	DirectColorFormat: device does not support the specified color format

\fBPEXGetTableEntries\fP
	LookupTable: lut_id contains an invalid lut resource id
	Value: start + count is greater than 2**16
	FloatingPointFormat: device does not support the specified fp format
	DirectColorFormat: device does not support the specified color format

\fBPEXSetTableEntries\fP
	LookupTable: lut_id contains an invalid lut resource id
	Value: start + count > 2**16,
	Value: illegal value in one of the fields of a table entry
	Value: no more definable entries
	FloatingPointFormat: device does not support the specified fp format
	DirectColorFormat: device does not support the specified color format

\fBPEXDeleteTableEntries\fP
	LookupTable: lut_id contains an invalid lut resource id
	Value: start + count > 2**16

\fBPEXCreatePipelineContext\fP
	IDChoice: ID already in use or not in range assigned to client
	Value: an item in the item_list is out of range
	FloatingPointFormat: device does not support the specified fp format
	DirectColorFormat: device does not support the specified color format
	Alloc: server failed to allocate the resource for some reason

\fBPEXCopyPipelineContext\fP
	PipelineContext: pc_id contains an invalid pipeline context id

\fBPEXFreePipelineContext\fP
	PipelineContext: pc_id contains an invalid pipeline context id

\fBPEXGetPipelineContext\fP
	PipelineContext: pc_id contains an invalid pipeline context id
	FloatingPointFormat: device does not support the specified fp format
	DirectColorFormat: device does not support the specified color format

\fBPEXChangePipelineContext\fP
	PipelineContext: pc_id contains an invalid pipeline context id
	Value: an item in the item_list is out of range
	FloatingPointFormat: device does not support the specified fp format
	DirectColorFormat: device does not support the specified color format

\fBPEXCreateRenderer\fP
	IDChoice: ID already in use or not in range assigned to client
	Drawable: specified drawable resource id is invalid
	PipelineContext: a specified pipeline context resource id is invalid
	NameSet: a specified name set resource id is invalid
	LookupTable: a specified pipeline context resource id is invalid
	FloatingPointFormat: device does not support the specified fp format
	Value: an item in the item_list is out of range
	Alloc: server failed to allocate the resource for some reason
	Match: lookup table root/depth does not match example drawable's root/depth

\fBPEXFreeRenderer\fP
	Renderer: specified renderer resource id is invalid

\fBPEXChangeRenderer\fP
	Renderer: specified renderer resource id is invalid
	Match: specified lookup table resource was not created for drawables
		of the same root and depth as the specified renderer
	Value: an item in the item_list is out of range
	FloatingPointFormat: device does not support the specified fp format
	NameSet: a specified name set resource id is invalid
	LookupTable: a specified pipeline context resource id is invalid
	PipelineContext: a specified pipeline context resource id is invalid

\fBPEXGetRendererAttributes\fP
	Renderer: specified renderer resource id is invalid
	FloatingPointFormat: device does not support the specified fp format

\fBPEXBeginRendering\fP
	Renderer: specified renderer resource id is invalid
	Drawable: specified drawable resource id is invalid
	Match: specified renderer resource was not created for drawables
		of the same root and depth as the specified drawable

\fBPEXEndRendering\fP
	Renderer: specified renderer resource id is invalid

\fBPEXBeginStructure\fP
	Renderer: specified renderer resource id is invalid

\fBPEXEndStructure\fP
	Renderer: specified renderer resource id is invalid

\fBPEXRenderOutputCommands\fP
	Renderer: specified renderer resource id is invalid
	FloatingPointFormat: device does not support the specified fp format
	DirectColorFormat: device does not support the specified color format
	List of errors that can be generated by output commands is TBD

\fBPEXRenderNetwork\fP
	Renderer: specified renderer resource id is invalid
	Drawable: specified drawable resource id is invalid
	Structure: specified structure resource id is invalid

\fBPEXCreateStructure\fP
	IDChoice: ID already in use or not in range assigned to client
	Alloc: server failed to allocate the resource for some reason

\fBPEXCopyStructure\fP
	Structure: specified structure resource id is invalid

\fBPEXFreeStructure\fP
	Structure: specified structure resource id is invalid

\fBPEXDeleteStructures\fP
	Structure: specified structure resource id is invalid
	Value: bad value for "delete_refs" parameter

\fBPEXGetStructureInfo\fP
	Structure: specified structure resource id is invalid

\fBPEXGetElementInfo\fP
	Structure: specified structure resource id is invalid
	Value: bad value for "whence" parameter

\fBPEXGetStructuresInNetwork\fP
	Structure: specified structure resource id is invalid
	Value: bad value for "which" parameter

\fBPEXGetAncestors\fP
	Structure: specified structure resource id is invalid
	Value: bad value for "path_order" parameter

\fBPEXGetDescendants\fP
	Structure: specified structure resource id is invalid
	Value: bad value for "path_order" parameter

\fBPEXFetchElements\fP
	Structure: specified structure resource id is invalid
	FloatingPointFormat: device does not support the specified fp format
	DirectColorFormat: device does not support the specified color format
	Value: bad value for "whence" parameter

\fBPEXSetEditingMode\fP
	Structure: specified structure resource id is invalid
	Value: bad value for "mode" parameter

\fBPEXSetElementPointer\fP
	Structure: specified structure resource id is invalid
	Value: bad value for "whence" parameter

\fBPEXSetElementPointerAtLabel\fP
	Structure: specified structure resource id is invalid
	Label: no occurrences of specified label in structure

\fBPEXElementSearch\fP
	Structure: specified structure resource id is invalid
	Value: bad value for "whence" or "direction" parameters

\fBPEXStoreElements\fP
	Structure: specified structure resource id is invalid
	FloatingPointFormat: device does not support the specified fp format
	DirectColorFormat: device does not support the specified color format
	List of errors that can be generated by output commands is TBD

\fBPEXDeleteElements\fP
	Structure: specified structure resource id is invalid
	Value: bad value for "whence" parameter

\fBPEXDeleteElementsToLabel\fP
	Structure: specified structure resource id is invalid
	Value: bad value for "whence" parameter
	Label: no occurrences of specified label in structure

\fBPEXDeleteElementsBetweenLabels\fP
	Structure: specified structure resource id is invalid
	Label: no occurrences of specified label in structure

\fBPEXCopyElements\fP
	Structure: specified structure resource id is invalid
	Value: bad value for "whence" parameter

\fBPEXChangeStructureReferences\fP
	Structure: specified structure resource id is invalid

\fBPEXCreateNameSet\fP
	IDChoice: ID already in use or not in range assigned to client
	Alloc: server failed to allocate the resource for some reason

\fBPEXCopyNameSet\fP
	NameSet: specified name set resource id is invalid

\fBPEXFreeNameSet\fP
	NameSet: specified name set resource id is invalid

\fBPEXGetNameSet\fP
	NameSet: specified name set resource id is invalid

\fBPEXChangeNameSet\fP
	NameSet: specified name set resource id is invalid
	Value: bad value for "action" parameter

\fBPEXCreateSearchContext\fP
	IDChoice: ID already in use or not in range assigned to client
	Value: an item in the item_list is out of range
	FloatingPointFormat: device does not support the specified fp format
	Alloc: server failed to allocate the resource for some reason

\fBPEXCopySearchContext\fP
	SearchContext: specified search context resource id is invalid

\fBPEXFreeSearchContext\fP
	SearchContext: specified search context resource id is invalid

\fBPEXGetSearchContext\fP
	SearchContext: specified search context resource id is invalid
	FloatingPointFormat: device does not support the specified fp format

\fBPEXChangeSearchContext\fP
	SearchContext: specified search context resource id is invalid
	Value: an item in the item_list is out of range
	FloatingPointFormat: device does not support the specified fp format

\fBPEXSearchNetwork\fP
	SearchContext: specified search context resource id is invalid

\fBPEXCreatePhigsWKS\fP
	IDChoice: ID already in use or not in range assigned to client
	Drawable: specified drawable resource id is invalid
	Match: specified lookup table resource was not created for drawables
		of the same root and depth as the specified drawable
	LookupTable: a specified pipeline context resource id is invalid
	NameSet: a specified name set resource id is invalid
	Alloc: server failed to allocate the resource for some reason

\fBPEXFreePhigsWKS\fP
	PhigsWKS: specified PHIGS workstation resource id is invalid

\fBPEXGetWKSInfo\fP
	PhigsWKS: specified PHIGS workstation resource id is invalid
	FloatingPointFormat: device does not support the specified fp format

\fBPEXGetDynamics\fP
	Drawable: specified drawable resource id is invalid

\fBPEXGetViewRep\fP
	PhigsWKS: specified PHIGS workstation resource id is invalid
	FloatingPointFormat: device does not support the specified fp format
	Value: specified view table entry is not defined

\fBPEXRedrawAllStructures\fP
	PhigsWKS: specified PHIGS workstation resource id is invalid

\fBPEXUpdateWorkstation\fP
	PhigsWKS: specified PHIGS workstation resource id is invalid

\fBPEXExecuteDeferredActions\fP
	PhigsWKS: specified PHIGS workstation resource id is invalid

\fBPEXSetViewPriority\fP
	PhigsWKS: specified PHIGS workstation resource id is invalid
	Value: bad value for "priority" parameter

\fBPEXSetDisplayUpdateMode\fP
	PhigsWKS: specified PHIGS workstation resource id is invalid
	Value: bad value for "display_update" parameter

\fBPEXMapWCtoDC\fP
	PhigsWKS: specified PHIGS workstation resource id is invalid
	FloatingPointFormat: device does not support the specified fp format

\fBPEXMapDCtoWC\fP
	PhigsWKS: specified PHIGS workstation resource id is invalid
	FloatingPointFormat: device does not support the specified fp format

\fBPEXSetViewRep\fP
	PhigsWKS: specified PHIGS workstation resource id is invalid
	FloatingPointFormat: device does not support the specified fp format

\fBPEXSetWKSWindow\fP
	PhigsWKS: specified PHIGS workstation resource id is invalid
	FloatingPointFormat: device does not support the specified fp format

\fBPEXSetWKSViewport\fP
	PhigsWKS: specified PHIGS workstation resource id is invalid
	FloatingPointFormat: device does not support the specified fp format
	Value: bad value for "use_drawable" parameter

\fBPEXSetHLHSRMode\fP
	PhigsWKS: specified PHIGS workstation resource id is invalid
	Value: bad value for "mode" parameter

\fBPEXPostStructure\fP
	PhigsWKS: specified PHIGS workstation resource id is invalid
	Structure: specified structure resource id is invalid

\fBPEXUnpostStructure\fP
	PhigsWKS: specified PHIGS workstation resource id is invalid
	Structure: specified structure resource id is invalid

\fBPEXUnpostAllStructures\fP
	PhigsWKS: specified PHIGS workstation resource id is invalid

\fBPEXGetWKSPostings\fP
	Structure: specified structure resource id is invalid

\fBPEXGetPickDevice\fP
	PhigsWKS: specified PHIGS workstation resource id is invalid
	Value: bad value for "dev_type" parameter
	FloatingPointFormat: device does not support the specified fp format

\fBPEXChangePickDevice\fP
	PhigsWKS: specified PHIGS workstation resource id is invalid
	Value: bad value for "dev_type" parameter
	Value: an item in the item_list is out of range
	FloatingPointFormat: device does not support the specified fp format

\fBPEXCreatePickMeasure\fP
	IDChoice: ID already in use or not in range assigned to client
	PhigsWKS: specified PHIGS workstation resource id is invalid
	Alloc: server failed to allocate the resource for some reason
	Value: bad value for "dev_type" parameter

\fBPEXFreePickMeasure\fP
	PickMeasure: specified pick measure resource id is invalid

\fBPEXGetPickMeasure\fP
	PickMeasure: specified pick measure resource id is invalid

\fBPEXUpdatePickMeasure\fP
	PickMeasure: specified pick measure resource id is invalid

\fBPEXOpenFont\fP
	IDChoice: ID already in use or not in range assigned to client
	PEXfont: string does not name a useable PEX font
	Alloc: server failed to allocate the resource for some reason

\fBPEXCloseFont\fP
	PEXfont: string does not name a useable PEX font

\fBPEXQueryFont\fP
	PEXfont: font resource id does not name a useable PEX font
	FloatingPointFormat: device does not support the specified fp format

\fBPEXListFonts\fP
	none

\fBPEXListFontsWithInfo\fP
	FloatingPointFormat: device does not support the specified fp format

\fBPEXQueryTextExtents\fP
	PEXfont: font resource id does not name a useable PEX font
	FloatingPointFormat: device does not support the specified fp format
	PipelineContext: pc_id contains an invalid pipeline context id
.fi
.bp
.AP "Appendix D: Definition of Table Default Values"
.SH
\s+3Appendix D: Definition of Table Default Values\s-3
.LP
.RU
.LP
If a table entry that is not defined is referenced, the contents of
the default table entry will be used.
The default entry for all tables
is one, except for the view, depth cue, RGB approximation,
and intensity approximation
tables whose default entry is zero.
If the contents of the default table entry is not defined, then
the default attribute values listed below
will be used to define a default table entry that will be used instead.
For each type of table, the attribute name, data type, and default value
are listed.  Each PEX implementation should provide documentation describing
the choices it made for those attributes listed as "implementation-dependent".
.sp 2
.LP
.Bl "LineBundle   (1..n, default entry = 1)"
.LD
.ta 0.2i 1.7i 3.7i
	line_type	LINE_TYPE	1
	polyline_interp	POLYLINE_INTERP	1
	curve_approx	CURVE_APPROX	{0, 1.0}
	line_width	FLOAT	1.0
	line_color	COLOR_SPECIFIER	{\fIIndexed\fP, 1}
.ta
.DE


.Bl "MarkerBundle   (1..n, default entry = 1)"
.LD
.ta 0.2i 1.7i 3.7i
	marker_type	MARKER_TYPE	3
	marker_scale	FLOAT	1.0
	marker_color	COLOR_SPECIFIER	{\fIIndexed\fP, 1}
.ta
.DE


.Bl "TextBundle   (1..n, default entry = 1)"
.LD
.ta 0.2i 1.7i 3.7i
	text_font_index	TABLE_INDEX	1
	text_precision	TEXT_PRECISION	\fIString\fP
	char_expansion	FLOAT	1.0
	char_spacing	FLOAT	0.0
	text_color	COLOR_SPECIFIER	{\fIIndexed\fP, 1}
.ta
.DE


.Bl "InteriorBundle   (1..n, default entry = 1)"
.LD
.ta 0.2i 1.7i 3.7i
	interior_style	INTERIOR_STYLE	1
	interior_style_index	TYPE_OR_TABLE_INDEX	1
	surface_color	COLOR_SPECIFIER	{\fIIndexed\fP, 1}
	reflection_attr	REFLECTION_ATTRIBUTES	{1.0, 1.0, 1.0, (\fIIndexed\fP, 1), 0.0, 0.0}
	reflection_model	REFLECTION_MODEL	1
	surface_interp	SURFACE_INTERP	1
	bf_interior_style	INTERIOR_STYLE	1
	bf_interior_style_index	TYPE_OR_TABLE_INDEX	1
	bf_surface_color	COLOR_SPECIFIER	{\fIIndexed\fP, 1}
	bf_reflection_attr	REFLECTION_ATTRIBUTES	{1.0, 1.0, 1.0, (\fIIndexed\fP, 1), 0.0, 0.0}
	bf_reflection_model	REFLECTION_MODEL	1
	bf_surface_interp	SURFACE_INTERP	1
	surface_approx	SURFACE_APPROX	{0, 1.0, 1.0}
	trim_curve_approx	CURVE_APPROX	{0, 1.0}
.ta
.DE


.Bl "EdgeBundle   (1..n, default entry = 1)"
.LD
.ta 0.2i 1.7i 3.7i
	surface_edges	SWITCH	\fIOff\fP
	surface_edge_type	SURFACE_EDGE_TYPE	1
	surface_edge_width	FLOAT	1.0
	surface_edge_color	COLOR_SPECIFIER	{\fIIndexed\fP, 1}
.ta
.DE


.Bl "Pattern   (1..n, default entry = 1)"
.LD
.ta 0.2i 1.7i 3.7i
	color_type	COLOR_TYPE	implementation-dependent
	numx	CARD16	implementation-dependent
	numy	CARD16	implementation-dependent
	colors	LISTofCOLOR	implementation-dependent
.ta
.DE

.Bl "Color   (0..n, default entry = 1)"
.LD
.ta 0.2i 1.7i 3.7i
	color	DIRECT_COLOR	implementation-dependent
.ta
.DE


.Bl "TextFont   (1..n, default entry = 1)"
.LD
.ta 0.2i 1.7i 3.7i
	font	{PEX_FONT_ID, X11_FONT_ID}	implementation-dependent
.ta
.DE


.Bl "View   (0..n, default entry = 0)"
.LD
.ta 0.2i 1.7i 3.7i
	clip_flags	BITMASK	all \fIOn\fP
	clip_limits	NPC_SUBVOLUME	(0,0,0),(1,1,1)
	orientation	MATRIX	identity matrix
	mapping	MATRIX	identity matrix
.ta
.DE


.Bl "Light   (1..n, default entry = 1)"
.LD
.ta 0.2i 1.7i 3.7i
	light_type	LIGHT_TYPE	implementation-dependent
	direction	VECTOR_3D	implementation-dependent
	point	COORD_3D	implementation-dependent
	concentration	FLOAT	implementation-dependent
	spread_angle	FLOAT	implementation-dependent
	attenuation	[factor1, factor2 : FLOAT]	implementation-dependent
	color 	COLOR_SPECIFIER	implementation-dependent
.ta
.DE
Depending on the type of light, some of the values in a table entry
may be ignored.  Undefined entries in the light table that are referenced
are treated as lights that are set to \fIOff\fP.


.Bl "DepthCue   (0..n, default entry = 0)"
.LD
.ta 0.2i 1.7i 3.7i
	mode	SWITCH	\fIOff\fP
	front_plane	FLOAT	implementation-dependent
	back_plane	FLOAT	implementation-dependent
	front_scaling	FLOAT	implementation-dependent
	back_scaling	FLOAT	implementation-dependent
	color	COLOR_SPECIFIER	implementation-dependent
.ta
.DE


.Bl "RGBApprox   (0..n, default entry = 0)" 
.LD
.ta 0.2i 1.7i 3.7i
	red_max	CARD16	implementation-dependent
	green_max	CARD16	implementation-dependent
	blue_max	CARD16	implementation-dependent
	red_mult	CARD32	implementation-dependent
	green_mult	CARD32	implementation-dependent
	blue_mult	CARD32	implementation-dependent
	base_pixel	CARD32	implementation-dependent
	dither	SWITCH	implementation-dependent
.ta
.DE
It is suggested that PEX implementations on color devices
provide default entries that correlate
with the X definition of RGB_DEFAULT_MAP for the device.  For instance,
if a device has eight-bit pixels which index into a 24-bit hardware colormap,
and its notion of an RGB_DEFAULT_MAP
is a 6x6x6 color cube encoded in 216 colormap entries starting with cell
number 16, then the suggested values would be:
.LD
.ta 0.2i 1.7i 3.7i
	red_max	CARD16	5
	green_max	CARD16	5
	blue_max	CARD16	5
	red_mult	CARD32	1
	green_mult	CARD32	6
	blue_mult	CARD32	36
	base_pixel	CARD32	16
	dither	SWITCH	implementation-dependent
.ta
.DE


.Bl "IntensityApprox   (0..n, default entry = 0)"
.LD
.ta 0.2i 1.7i 3.7i
	intensity_max	CARD16	implementation-dependent
	base_pixel	CARD32	implementation-dependent
	dither	SWITCH	implementation-dependent
.ta
.DE
It is suggested that PEX implementations on monochrome devices
provide default entries that correlate
with the X definition of RGB_GRAY_MAP for the device.  For instance,
if a device has eight-bit pixels which index into a 24-bit hardware colormap,
and its notion of an RGB_GRAY_MAP
is 216 levels of gray stored in colormap entries starting with cell
number 16, then the suggested values would be:
.LD
.ta 0.2i 1.7i 3.7i
	intensity_max	CARD16	215
	base_pixel	CARD32	16
	dither	SWITCH	implementation-dependent
.ta
.DE
